/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : drink.c
 * Author : Clode@RevivalWorld
 * Date   : 2003-03-04
 * Note   : drink O
 * Update :
 *  o 2000-00-00  
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <feature.h>

inherit COMMAND;

string help = @HELP
ζƪO
drink '~'		- NYӪ~ܨ{l

HELP;

private void do_command(object me, string arg)
{
	int capacity;
	object ob;
	
	if( !arg )
	{
		if( me->is_npc() )
			return me->do_command("say QnڳܨǤH\n");
		else
			return tell(me, pnoun(2, me)+"QnܨǤH\n");
	}
	
	ob = present(arg, me) || present(arg, environment(me));
	
	if( !objectp(ob) )
	{
		if( me->is_npc() )
			return me->do_command("say èS "+arg+" oضơC\n");
		else
			return tell(me, "èS "+arg+" oضơC\n");
	}

	if( !ob->is_drink() )
	{
		if( me->is_npc() )
			return me->do_command("say "+ob->query_idname()+"OơALkΡC\n");
		else
			return tell(me, ob->query_idname()+"OơALkΡC\n");
	}
	
	capacity = query("capacity", ob);

	if( capacity + me->query_drink_cur() > me->query_drink_max() )
	{
		if( me->is_npc() )
			return me->do_command("say ڳܤU"+ob->query_idname()+"FI\n");
		else
			return tell(me, pnoun(2, me)+"ܤU"+ob->query_idname()+"FI\n");
	}
	
	me->add_drink(capacity);

	msg("$ME$YOUjfjfaܤFUhC\n", me, ob, 1);

	ob->drink();
	destruct(ob, 1);
}