/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : get.c
 * Author : Clode@RevivalWorld
 * Date   : 2001-10-10
 * Note   : get O
 * Update :
 *  o 2000-00-00  
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <daemon.h>
#include <feature.h>
#include <message.h>
#include <location.h>

inherit COMMAND;

string help = @HELP
N~Ϊ߬B_

get [ƶq|all] [~] [Ƨ]	- NYƶqαƧǪY~߬B_

HELP;

private void do_command(object me, string arg)
{
	int mass, from_environment=1;
	object ob, target, env;
	string from, msg="", amount;

	if( !arg )
	{
		if( me->is_npc() )
			return me->do_command("say QnھߤFH\n");
		else
			return tell(me, pnoun(2, me)+"QnߤFH\n");
	}
	
	// Delay UO
	if( me->is_delaying() )
		return tell(me,	me->query_delay_msg());

	env = environment(me);
	
	if( sscanf(arg, "%s from %s", arg, from) == 2 )
	{
		if( !objectp(target = present(from)) )
			return tell(me, "ǫS "+from+" oӤHΪ~C\n");
		else
			from_environment = 0;
	}
	else target = env;

	if( sscanf(arg, "$%s %s", arg, amount) == 2 )
	{
		if( me->is_npc() )
			return me->do_command("say ڵLk߬BC\n");

		if( !MONEY_D->money_unit_exist(arg) )
			return tell(me, "èS "+arg+" oسfC\n");
		
		amount = big_number_check(amount);
		if( !amount )
			return tell(me, "пJTƦrC\n");
		
		if( count(amount, "<=", 0) )
			return tell(me, "BnjsC\n");
		
		if( !objectp(ob = present(arg, target)) )
			return tell(me, "ǫèS "+arg+" oسfC\n");

		if( count(amount, ">", query("money", ob)) )
			return tell(me, "ǫèSoh "+arg+" C\n");
		
		ob->move(me, amount);
		
		log_file("command/get", me->query_idname()+"߰_ "+money(arg, amount));
		CHANNEL_D->channel_broadcast("nch", me->query_idname()+"߰_ "+money(arg, amount));

		return msg("$ME "HIY+money(arg, amount)+" "NOR+(from_environment?"":"q"+target->query_idname()+"")+"ߤF_ӡC\n", me,0,1);
	}
	
	if( sscanf(arg, "%s %s", amount, arg) == 2 )
	{
		if( amount == "all") ;
		
		// pG amount äOƦr
		else if( !big_number_check(amount) )
		{
			arg = amount + " " + arg;
			amount = "1";	
		}	
		else if( count(amount, "<", 1) ) amount = "1";
	}
	else amount = "1";
	
	if( objectp(ob = present(arg, target)) )
	{
		object base_ob = load_object(base_name(ob));

		if( me == ob )
			return tell(me, pnoun(2, me)+"pGuiHۤv_ӡAЦܧŮvjUQUC\n");
		
		if( me == target )
			return tell(me, ob->query_idname()+"wgb"+pnoun(2, me)+"WFIIC\n");
			
		if( target->is_living() )
			return msg("$MEb$YOUWFNNAյۧ"+QUANTITY_D->obj(ob, amount)+"I\n", me, target, 1);
		
		if( ob->is_living() )
			return msg("$MEb$YOUWFNNAյۧIOI$YOU_ӡII\n", me, ob,1);
		
		if( ob->is_money() )
		{
			if( amount != "all" && count(amount, ">", query("money", ob)) )
				return tell(me, "o̪ShC\n");
			
			if( amount == "all" )
				amount = query("money", ob);
	
			msg("$ME "HIY+money(query("unit", ob), amount)+" "NOR+(from_environment?"":"q"+target->query_idname()+"")+"ߤF_ӡC\n", me,0,1);
			
			log_file("command/get", me->query_idname()+"߰_F "+money(query("unit", ob), amount));
			CHANNEL_D->channel_broadcast("nch", me->query_idname()+"߰_F "+money(query("unit", ob), amount));
			ob->move(me, amount);
			
			return;
		}
		
		if( amount != "all" && count(amount,">", query_temp("amount",ob)||1 ) )
		{
			if( me->is_npc() )
				return me->do_command("say "+"o̪"+ob->query_idname()+"ShӡC\n");
			else
				return tell(me, "o̪"+ob->query_idname()+"ShӡC\n");
		}
		
		if( query("mass", ob) == -1 )
		{
			msg("$MEHN"+QUANTITY_D->obj(ob, amount)+"@|_Au$MEaF@yuګInӭF...vC\n",me,0,1);
			return me->faint();
		}
		
		if( amount == "all" )
		{
			amount = ((me->query_max_loading() - me->query_loading()) / (query("mass", ob)||1)) + "";
			
			if( count(amount, ">", query_temp("amount", ob)||1) )
				amount = query_temp("amount", ob)||"1";
				
			if( count(amount, "==", 0) )
				return tell(me, pnoun(2, me)+""+ob->query_idname()+"FC\n");
		}
		
		if( me->get_object(ob, amount) )
			return msg("$ME"+QUANTITY_D->obj(ob || base_ob, amount)+(from_environment?"":"q"+target->query_idname()+"")+"ߤF_ӡC\n", me,0,1);
		else
			return msg("$ME"+QUANTITY_D->obj(ob || base_ob, amount)+(from_environment?"":"q"+target->query_idname()+"")+"F_ӡAuťjL@nذաAjL_FISC\n",me,0,1);
	}
	
	if( lower_case(arg) == "all" )
	{
		object *all_ob = filter_array(present_objects(me), (: !$1->is_living() && query("mass",$1) >= 0 :));
		
		if( userp(target) )
			return msg("$MEb$YOUWFNNAյۧ$YOUҦFI\n",me,target,1);
		
		if( sizeof(all_ob) )
		{
			int too_heavy, loading, max_loading;
			
			max_loading = me->query_max_loading();
			
			foreach(ob in all_ob)
			{
				mass = query("mass",ob);

				if( mass == -1 ) continue;
		
				if( ob->is_money() )
				{
					msg += HIR"D"NOR+ob->query_idname()+NOR"\n";
					
					log_file("command/get", me->query_idname()+"߰_F"+QUANTITY_D->money_info(query("unit", ob), query("money", ob)));
					CHANNEL_D->channel_broadcast("nch", me->query_idname()+"߰_F"+QUANTITY_D->money_info(query("unit", ob), query("money", ob)));
					ob->move(me);	
					continue;
				}
				
				amount = copy(query_temp("amount",ob)) || "1";
				
				loading = max_loading - me->query_loading();
				
				if( count(loading, "<", count(amount,"*",mass)) )
				{
					if( loading < mass ) continue;
					
					msg += HIR"D"NOR+QUANTITY_D->obj(ob, loading/mass, 1)+"\n";
					
					ob->move(me, loading/mass);

					too_heavy = 1;
				}
				else
				{
					msg += HIR"D"NOR+remove_fringe_blanks(QUANTITY_D->obj(ob, amount))+"\n";
					ob->move(me , amount);
				}
			}
			
			if( msg == "" )
			{
				if( me->is_npc() )
					return me->do_command("say ھߤ_ӥ󪺪FC\n");
				else
					return tell(me, pnoun(2, me)+"ߤ_ӥ󪺪FC\n");
			}
			
			msg("$ME"+(from_environment?"aW߱oʪF賣ߤF_":"$YOUWளFqqFX")+"C\n"+msg+"\n", me, target,1);
			
			if( too_heavy ) tell(me, "ѤUFӭʤFC\n\n");
			
			return;
		}
		return tell(me, (from_environment?"oӦa":target->query_idname())+"S󪫫~iH߭C...C\n");
	}
	
	if( me->is_npc() )
		return me->do_command("say ǫS "+arg+" o󪫫~C\n");
	else
		return tell(me, "ǫS "+arg+" o󪫫~C\n");
}