/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : go.c
 * Author : Cookys@RevivalWorld
 * Date   : 2001-7-20
 * Note   : ʫOC
 * Update :
 *  o 2000-00-00  
 *
 -----------------------------------------
 */

#include <lock.h>
#include <ansi.h>
#include <daemon.h>
#include <feature.h>
#include <location.h>
#include <message.h>
#include <delay.h>
#include <buff.h>
#include <citydata.h>

inherit COMMAND;

string help = @HELP
ʫO

oӫOiHzbͪ@ɤۥѪ樫AzQha
q`iH樫VpU:

north		_	northeast	F_
south		n	northwest	_
east		F	southeast	Fn
west			southwest	n
up		W	down		U

HWoǤVObtΤw]OW (аѦ alias -d)
FKϥΡAzuݭnJVYiAp: n, s, e, w, ne, nw, se, sw, u, d
bYǰϰi|X{ҥ~VAzunJӤVWYiC

bؿvhiQ go 'Ӽh' FӼӼh

Ҧp : go 100			- F 100F

O: look
HELP;

mapping corresponding =
([
    "north"         :"south",
    "south"         :"north",
    "east"          :"west",
    "west"          :"east",
    "northwest"     :"southeast",
    "northeast"     :"southwest",
    "southwest"     :"northeast",
    "southeast"     :"northwest",
    "up"            :"down",
    "down"          :"up",
]);

private void do_command(object me, string arg)
{
	mixed exit;
	mapping exits;
	string my_idname, from;
	object env, newenv;
	int moving_stamina_cost;

	if( !arg )
		return tell(me, "AQn̨H\n");
	
	// OǤH
	if( query("prisoner", me) )
	{
		msg("$ME}QKRALkۥѦʡC\n", me, 0, 1);
		return;
	}
		
	//LUO
	if( me->is_delaying() )
	{
		tell(me, me->query_delay_msg());
		return me->show_prompt();
	}

	env = environment(me);

	if( !objectp(env) ) 
		return tell(me, pnoun(2, me)+"ثeLkVmʡAгqŮvBzC\n");

	my_idname = me->query_idname();

	if( env->is_maproom() )
	{
		switch(MAP_D->valid_move(me, arg))
		{
			case 1:
			{
				moving_stamina_cost = -me->query_all_buff(BUFF_MOVING_STAMINA);
				
				if( moving_stamina_cost > 0 )
				{
					if( !me->cost_stamina(moving_stamina_cost) )
						return tell(me, pnoun(2, me)+"wgSO~eiFC\n");
					else
						msg("$MEӶOF "+moving_stamina_cost+" IOĤOeiC\n", me, 0, 1);
				}
				
				if( me->query_loading() > me->query_max_loading() )
				{
					msg("$MEۨIeiAרsOOqߡC\n", me, 0, 1);
					me->faint();
					return;
				}
				MAP_D->move(me, arg);
				
				return;
				break;
			}
			case -1:
			{
				if( wizardp(me))
					return MAP_D->move(me, arg);
				else
					return tell(me, ""+CHINESE_D->to_chinese(arg)+"VQFA"+pnoun(2, me)+"SkC\n");
					
				break;
			}
			case -2:
			{
				if( query_temp("go_resist", me) == "WALL_"+arg )
					msg("$MED"+CHINESE_D->to_chinese(arg)+"OAo̵MqFUhALB򭻸z@ˡC\n", me, 0, 1);
				else
				{
					set_temp("go_resist", "WALL_"+arg, me);
					tell(me, ""+CHINESE_D->to_chinese(arg)+"VO@A"+pnoun(2, me)+"SkC\n");
				}
				return;
				break;
			}
			default:
			{
				return tell(me, " "+arg+" VSXC\n");
				break;
			}
		}
	}

	// @벾
	if( !mapp(exits = query("exits", env)) || !sizeof(exits) )
		return tell(me, "o̥|PSXfA"+pnoun(2, me)+"Q̥hH\n");

	if( exit = exits[arg] )
	{
		if( me->is_fighting() )
		{
			if( !COMBAT_D->do_flee(me) )
				return;
		}

		from = CHINESE_D->to_chinese(corresponding[arg]);

		if( functionp(exit) )
			exit = evaluate(exit, me);

		// YOyХXf
		if( arrayp(exit) )
		{
			if( (MAP_D->query_map_system(exit))->query_coor_data(exit, "lock") & LOCKED && !wizardp(me))
				return tell(me, " "+capitalize(arg)+" VQFA"+pnoun(2, me)+"SkC\n");

			if( !wizardp(me) && (MAP_D->query_map_system(exit))->query_coor_data(exit, "lock") & WIZLOCKED )
				return tell(me, " "+capitalize(arg)+" V@DѤѦӭצA"+pnoun(2, me)+"SkC\n");

			broadcast(env, my_idname+""+(CHINESE_D->to_chinese(arg)||" "+capitalize(arg)+NOR" V")+"fFXhC\n", 0, me);

			me->move(exit);

			if( from )
				broadcast(exit, my_idname+"q"+from+"̨FXӡC\n", 0, me);
			else
				broadcast(exit, my_idname+"FLӡC\n", 0, me);

			me->follower_move(env, exit);
		}
		// YOW٥Xf
		else if( stringp(exit) )
		{
			if( query("lock/"+arg, env) & LOCKED && !wizardp(me))                       
				return tell(me, " "+capitalize(arg)+" VQFA"+pnoun(2, me)+"SkC\n");

			if( !wizardp(me) && query("lock/"+arg, env) & WIZLOCKED )
				return tell(me, " "+capitalize(arg)+" V@DѤѦӭצA"+pnoun(2, me)+"SkC\n");

			broadcast(env, my_idname+""+(CHINESE_D->to_chinese(arg)||" "+capitalize(arg)+NOR" V")+"}C\n", 0, me);

			me->move(exit);

			if( from )
				broadcast(exit, my_idname+"q"+from+"FLӡC\n", 0, me);
			else
				broadcast(exit, my_idname+"FLӡC\n", 0, me);

			me->follower_move(env, exit);
		}
		else
			tell(me, "oӤVXfQFALkqLC\n");
	}
	else if( to_int(arg) > 0 && big_number_check(arg) )
	{
		int current_floor = env->query_floor()-1;
		int floor = to_int(arg)-1;
		string msg = "";
		array loc = env->query_location();

		if( current_floor == floor )
			return tell(me, pnoun(2, me)+"wgOb "+(floor+1)+" ӤFC\n");

		if( !arrayp(loc) ) return tell(me, "ǫS "+arg+" ӡC\n");

		// ֳtW
		if( current_floor < floor )
		{
			newenv = environment(me);

			for(current_floor = env->query_floor();current_floor<=floor;current_floor++)
			{
				exit = CITY_NUM_ROOM(loc[CITY], loc[NUM]) + "/"+loc[X]+"_"+loc[Y]+"_"+(current_floor?current_floor+"_":"")+env->query_building_type()+".o";

				if( !file_exists(exit) )
					return tell(me, "ǫS "+arg+" ӡC\n");

				if( query("lock/up", newenv) & LOCKED )
					return tell(me, " "+(current_floor+1)+" ӪqDQFC\n");

				newenv = load_object(exit[0..<3]);
			}
			
			//for(current_floor = env->query_floor();current_floor<=floor;current_floor++)		
			msg += pnoun(2, me)+"fq詹 "WHT+(floor+1)+NOR" ӤWhC\n";

			tell(me, msg);
			me->move(newenv);
			me->follower_move(env, newenv);
		}
		// ֳtU
		else
		{
			newenv = environment(me);

			for(current_floor = env->query_floor()-2;current_floor>=floor;current_floor--)
			{	
				exit = CITY_NUM_ROOM(loc[CITY], loc[NUM]) + "/"+loc[X]+"_"+loc[Y]+"_"+(current_floor?current_floor+"_":"")+env->query_building_type()+".o";
					
				if( !file_exists(exit) )
					return tell(me, "ǫS "+arg+" ӡC\n");

				if( query("lock/down", newenv) & LOCKED )
					return tell(me, " "+(current_floor+1)+" ӪqDQFC\n");
					
				newenv = load_object(exit[0..<3]);
			}

			//for(current_floor = env->query_floor()-2;current_floor>=floor;current_floor--)
				msg += pnoun(2, me)+"fq詹 "WHT+(floor+1)+NOR" ӤUhC\n";
			
			tell(me, msg);
			me->move(newenv);
			me->follower_move(env, newenv);
		}

		msg("$MEqq̨FXӡC\n", me, 0, 1);
	}
	else
		tell(me, " "+arg+" VSXC\n");
}

