/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : chfn.c
 * Author : Sinji@RevivalWorld
 * Date   : 2006-09-07
 * Note   : chfn OC
 * Update :
 *  o 2000-00-00
 *
 -----------------------------------------
 */

#include <feature.h>
#include <message.h>
#include <ansi.h>

#define CH_ID		(1<<0)
#define CH_NAME		(1<<1)
#define CH_EMAIL	(1<<2)

#define DEFAULT		CH_ID | CH_NAME | CH_EMAIL
#define HELP		"/doc/help/color"

inherit COMMAND;

string help = @HELP
ϥΪ̸T

OiΨӧϥΪ̸TpUG

-i	ק缾a^Nm
-n	ק缾aW٤Φm
-e	ק缾aqllHc

p[Ѽƫhܥק

O榡:
chfn [-i] [-n] [-e]

O: finger, nick
HELP;

private void change_prompt(object me, int flag);
private void change_input(object me, int flag, string arg);
private void do_command(object me, string arg)
{
	int flag;
	if( arg )
	{
		if( sscanf(arg, "%*s-i%*s", arg) == 2 )	flag |= CH_ID;
		if( sscanf(arg, "%*s-n%*s", arg) == 2 )	flag |= CH_NAME;
		if( sscanf(arg, "%*s-e%*s", arg) == 2 ) flag |= CH_EMAIL;
	}
	if( !flag ) flag = DEFAULT;
	tell(me, "LпJ [ENTER]AпJ '~q'AmUпJ '~h'\n");
	tell(me, WHT"["HIW"Change Information"NOR + WHT"]wwwwwwwwwwwwwwww\n"NOR);
	change_prompt(me, flag);
}
private void change_prompt(object me, int flag)
{
	if( flag & CH_ID )
	{
		tell(me, "\nID - [" + me->query_id() + "]\n");
		tell(me, "пJ" + pnoun(2, me) + "m^NG");
		input_to( (: change_input, me, flag :), 2 );
	}
	else if( flag & CH_NAME )
	{
		tell(me, "\nNAME - [" + me->query_name() + "]\n");
		tell(me, "пJ" + pnoun(2, me) + "mW١G");
		input_to( (: change_input, me, flag :), 2 );
	}
	else if( flag & CH_EMAIL )
	{
		tell(me, HIR"\n`NGHc}N@ƥɮפ̾ڡC\n"NOR);
		tell(me, "EMAIL - [" + query("email", me) + "]\n");
		tell(me, "пJ" + pnoun(2, me) + "qllHcG");
		input_to( (: change_input, me, flag :), 2 );
	}
	return;
}
private void change_input(object me, int flag, string arg)
{
	string *res;

	arg = remove_ansi(arg);

	if( arg && query("encode/gb", me) ) arg = G2B(arg);

	if( !arg ) arg = "";

	if( arg == "~q" )
	{
		tell(me, "JC\n");
		return me->finish_input();
	}
	if( arg == "~h" )
	{
		tell(me, read_file(HELP));
		return change_prompt(me, flag);
	}
	if( flag & CH_ID )
	{
		if( arg == "" )
			tell(me, "Lm^N]wC\n");
		else
		{
			if( !(res = me->set_idname(ansi(arg), 0)) )
			{
				tell(me, "s]w^NP즳^NPAЭs]wC\n");
				return change_prompt(me, flag);
			}
			tell(me, "m^N '"+ res[0] +"' ]wC\n");
		}
		flag ^= CH_ID;
	}
	else if( flag & CH_NAME )
	{
		int len;

		if( arg == "" )
			tell(me, "LmWٳ]wC\n");
		else
		{
			arg = ansi(arg);
			len = noansi_strlen(arg);
			if( len > 12 || len < 2 )
			{
				tell(me, "W٥b 1  12 ӦrAЭs]wC\n");
				return change_prompt(me, flag);
			}
			foreach(int i in remove_ansi(arg))
			{
				if( i <= ' ' )
				{
					tell(me, "ФũlαXΪťաAЭs]wC\n");
					return change_prompt(me, flag);
				}
			}
			res = me->set_idname(0, ansi(arg));
			tell(me, "mW '" + res[1] + "' ]wC\n");
		}
		flag ^= CH_NAME;
	}
	else if( flag & CH_EMAIL )
	{
		if( arg == "" )
			tell(me, "LqllHc]wC\n");
		else
		{
			if( sscanf(arg, "%*s@%*s.%*s") != 3 )
			{
				tell(me, "Hc}榡DC\n");
				return change_prompt(me, flag);
			}
			if( !set("email", arg, me) )
				tell(me, "qllHc '" + arg + "' ]wѡC\n");
			else
				tell(me, "qllHc '" + arg + "' ]wC\n");
		}
		flag ^= CH_EMAIL;
	}
	if( flag ) return change_prompt(me, flag);
	return me->finish_input();
}
