/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : fight.c
 * Author : Clode@RevivalWorld
 * Date   : 2006-03-26
 * Note   : fight O
 * Update :
 *  o 2000-00-00  
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <daemon.h>
#include <feature.h>

inherit COMMAND;

string help = @HELP
PH԰O

fight 'ؼ'		- MYH}l԰

HELP;

private void do_command(object me, string arg)
{
	object enemy;
	
	if( !arg )
		return tell(me, pnoun(2, me)+"QnM־԰H\n");
		
	if( arg == "-all" )
	{
		object enemies = filter_array(present_objects(me), (: $1 != $(me) && $1->is_living() && !$1->is_faint() && !query("no_fight", $1) :));
			
		if( sizeof(enemies) )
		foreach(enemy in  enemies)
		{
			msg(HIY"$ME"HIY"}l$YOU"HIY"iC\n"NOR, me, enemy, 1);
			
			// ͹ĵi
			//if( userp(enemy) )
			//	tell(enemy, BEEP);
		
			COMBAT_D->start_fight(me, enemy);
		}
		else
			return tell(me, "ǫSiHiؼСC\n");

		return;
	}
	else if( arg == "-stop" )
	{
		if( !COMBAT_D->in_fight(me) )
			return tell(me, pnoun(2, me)+"èSb԰C\n");
		
		msg("$ME԰C\n", me, 0, 1);
		COMBAT_D->stop_fight(me);
		return;
	}
	
	if( !objectp(enemy = present(arg, environment(me))) )
		return tell(me, "ǫS "+arg+" oӤHC\n");

	if( enemy == me )
		return tell(me, pnoun(2, me)+"Mۤv԰C\n");

	if( !enemy->is_living() )
		return tell(me, enemy->query_idname()+"OͪA"+pnoun(2, me)+"SkM"+pnoun(3, enemy)+"԰C\n");

	if( enemy->is_faint() )
		return tell(me, enemy->query_idname()+"wgSO"+pnoun(2, me)+"԰FC\n");

	if( COMBAT_D->is_fighting(me, enemy) )
		return tell(me, pnoun(2, me)+"M"+enemy->query_idname()+"wgb԰C\n");
		
	if( !wizardp(me) )
		return tell(me, "԰\դC\n");

	if( query("no_fight", enemy) )
		return tell(me, pnoun(2, me)+"Lk"+enemy->query_idname()+"iC\n");
	
	msg(HIY"$ME"HIY"}lV$YOU"HIY"iC\n"NOR, me, enemy, 1);
	
	// ͹ĵi
	//if( userp(enemy) )
	//	tell(enemy, BEEP);

	COMBAT_D->start_fight(me, enemy);
}
