/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : help.c
 * Author : Clode@RevivalWorld
 * Date   : 2001-2-13
 * Note   : help O, LAӧoӧ˦menua..
 * Update :
 *  o 2000-00-00
 *
 -----------------------------------------
 */

#define HELP_DIR	"/doc/help/"

#include <ansi.h>
#include <help.h>
#include <feature.h>
#include <daemon.h>
#include <message.h>

inherit COMMAND;

string help = @HELP
O

oӫOiHϥΪ̨oϥΦU\઺
ϥΪ̯󻴩xͪ@ɪާ@覡

O榡:
help			DDC
help <DD>		o <DD> i@BT

O:
HELP;

private varargs string help_style(string title, string arg, string content, string lastmodify)
{
	return sprintf(
		" %-52s%24s\n" 
		WHT"zwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww{\n"NOR // 78 re
		"\n%s\n"
		WHT"|wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww}\n"NOR + (!undefinedp(lastmodify)?CYN"%77s\n"NOR:"") ,
		HIW+title+NOR + " - ", NOR WHT"["HIW + arg + NOR WHT"]"NOR, arg=="color"?content:ansi(content), "̫sɶ "+lastmodify);
}

private void do_command(object me, string arg)
{
	string help, cmd_alias;
	mapping info;
	object ob, env = environment(me);
	function fp;

	if( !arg ) arg = "topics";

	if( !env )
		return tell(me, pnoun(2, me)+"b_ǪaAгqŮvBzC\n");

	// һ
	if( arg == "here" )
	{
		array loc = query_temp("location", me);

		if( !env )
			return tell(me, pnoun(2, me)+"ثeäBҤC\n");

		// aϮyл
		if( env->is_maproom() )
			return me->more((MAP_D->query_map_system(loc))->query_coor_help(loc) || "oӦaèSSOC\n");

		// Ҳթж\໡
		else if( mapp(info = env->query_action_info(query("function", env))) && mapp(info["help"]) && info["help"]["topics"])
			return me->more(info["help"]["topics"]);

		// @ж\໡	
		else
			return me->more(fetch_variable("help", env) || "oӦaèSSOC\n");
	}

	if( query("help/"+arg, env) )
		return me->more(help_style("󻡩", arg, query("help/"+arg, env)));

	// 󻡩
	if( objectp(ob = present(arg)) && stringp(fetch_variable("help", ob)) )
		return me->more(help_style("󻡩", arg, fetch_variable("help", ob)));

	// ҲիO
	if( mapp(info = env->query_action_info(query("function", env))) && mapp(info["help"]) && info["help"][arg] )
		return me->more(help_style("ҲիO", arg, info["help"][arg]));

	// @뻡
	if( file_size(HELP_DIR+arg) > 0 )
	{
		string title, content;
		help = read_file(HELP_DIR + arg);
		if( sscanf(help, "%s|\n%s", title, content) )
			help = help_style(title, arg, content, TIME_D->replace_ctime(stat(HELP_DIR+arg)[1]));
		return me->more(help);
		//return me->more_file(HELP_DIR+arg);
	}
	if( stringp(cmd_alias = COMMAND_D->default_alias(arg)) )
		arg = explode(cmd_alias, " ")[0];

	// atΫO
	if( functionp(fp = COMMAND_D->find_ppl_command(arg)) )
	{
		help = fetch_variable("help", function_owner(fp)) || "OõL󻡩C\n";
		return me->more(help_style("aO", arg, help));
	}
	if( wizardp(me) )
	{
		// ŮvtΫO
		if( functionp(fp = COMMAND_D->find_wiz_command(arg)) )
		{
			help = fetch_variable("help", function_owner(fp)) || "OõL󻡩C\n";
			return me->more(help_style("ŮvO", arg, help));
		}

		if( arg[<2..<1] == "()" ) arg = arg[0..<3];

		// MudOS 󻡩
		foreach(string dir in SEARCH_PATHS)
			if( file_size(dir+arg) > 0 )
				return me->more_file(dir+arg);
	}

	tell(me, "S "+arg+" C\n");
}
