/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : labor.c
 * Author : Clode@RevivalWorld
 * Date   : 2003-05-22
 * Note   : labor O
 * Update :
 *  o 2000-00-00
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <feature.h>
#include <message.h>
#include <location.h>
#include <daemon.h>
#include <npc.h>
#include <buff.h>

inherit COMMAND;

string help = @HELP
    oӫOAdݥثewUΪҦHOMAHμxղMWHOA
baӡAHKROLu@Ϊ̨LƱC

labor			- ܩҦuC
labor 'us'	- NӽsuIܱze
labor salary 1000	- xs 1000 ww~(w]ӫf)

HELP;

void labor_call(object me, object labor)
{
	if( !objectp(me) || !objectp(labor) )
		return;

	msg("$MEF@ʨӦ"+me->query_idname()+"xհTAߨXoeC\n", labor, 0, 1);
	
	labor->move_to_environment(me);
	
	msg("$MEݵaFBC\n", labor, 0, 1);
	tell(me, labor->query_idname()+"wFتaC\n");
}

string labor_list(object me)
{
	int i;
	object labor, env;
   	string place, job;
	string msg = "";
    	string salary, salary_paid, totalsalary, *labors = query("hirelabors", me);
    	string moneyunit = MONEY_D->city_to_money_unit(query("city", me)) || MONEY_D->query_default_money_unit();
    
    	if( !sizeof(labors) )
    		return me->query_idname()+"SΥHOC\n";
    			
    	msg = pnoun(2, me)+"`@ΤF "+sizeof(labors)+" ӤHOG\n";
	msg += NOR WHT"wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww\n"NOR;
	msg +=     HIW"s HOW          m                         ˱K u@ ~($"+moneyunit+")\n"NOR;
	msg += NOR WHT"wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww\n"NOR;

    	foreach( string file in labors )
    	{
    		if( !file_exist(file+".o") )
    		{
    			set("hirelabors", labors - ({ file }), me);
    			if( !sizeof(query("hirelabors", me)) )
    				delete("hirelabors", me);
    			continue;
    		}

    		if( !objectp(labor = load_object(file)) )
    			error("Can't load "+file+".");
    			
    		if( query("adventure", labor) )
    			place = AREA_D->query_area_name(query("adventure/area", labor), query("adventure/num", labor));
    		else if( objectp(env = environment(labor)) )
    		{
    			if( env->is_maproom() )
    			{
    				array loc = query_temp("location", labor);
    					
    				place = loc_short(loc);
    			}
    			else
    				place = env ? HIG+(env->query_room_name()||query("short", env)||"Wa")+NOR : HIR"btzƬy"NOR;
    		}
    		else
    			place = HIR"ۤ"NOR;

		switch( query("job/cur", labor) )
		{
			case CLERK:
				job = HIC""NOR CYN""NOR;
				break;
			case WORKER:
				job = HIY"u"NOR YEL"H"NOR;
				break;
			case ENGINEER:
				job = HIR""NOR RED"o"NOR;
				break;
			case ADVENTURER:
				job = HIG""NOR GRN"I"NOR;
				break;
			default:
				job = NOR WHT"L"NOR;
				break;
		}
		salary = SALARY_D->query_labor_salary(labor);
		totalsalary = count(salary, "+", totalsalary);
    		msg += sprintf(HIY" %-3d"NOR" %-18s%-30s%5s %-4s %s\n", ++i, noansi_strlen(labor->query_idname())<=16?labor->query_idname():labor->query_name(), place, HIG+query("relationship/"+me->query_id(1), labor)+NOR, job, HIY+NUMBER_D->number_symbol(salary)+NOR);
    	}
    	
    	salary_paid = query("salary_paid", me);
    	
    	msg += sprintf("\n "NOR YEL"CI~`B "HIY"$%s %s"NOR YEL"Aww~ "HIY"$%s %s"NOR YEL" ("HIY"%s"NOR YEL" Ӥ)\n"NOR,  moneyunit, NUMBER_D->number_symbol(totalsalary), moneyunit, NUMBER_D->number_symbol(salary_paid), count(totalsalary, ">", 0) ? NUMBER_D->number_symbol(count(salary_paid, "/", totalsalary)) : "0");
    	msg += NOR WHT"wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww\n"NOR;
    	
    	return msg;
}

void labor_salary(object me, string arg)
{
	string moneyunit = MONEY_D->city_to_money_unit(query("city", me)) || MONEY_D->query_default_money_unit();

	if( !arg )
		return tell(me, pnoun(2, me)+"Qnxsh֦ww~H\n");

	arg = big_number_check(arg);
	
	if( count(arg, "<=", 0) )
		return tell(me, "пJTBƦrC\n");
		
	if( !me->spend_money(moneyunit, arg) )
		return tell(me, pnoun(2, me)+"WSh $"+moneyunit+" FIC\n");
		
	set("salary_paid", count(query("salary_paid", me), "+", arg), me);
		
	msg("$MExsF "HIY"$"+moneyunit+" "+NUMBER_D->number_symbol(arg)+NOR" ww~C\n", me, 0, 1);	
	
	me->save();
}

private void do_command(object me, string arg)
{
	int i, num;
	object labor;
	string salary;
	int waiting_time;

    	if( !arg )
    		return tell(me, labor_list(me));
	else if( (num = to_int(arg)) > 0 )
	{
		string *labors = query("hirelabors", me);
		
		if( num > sizeof(labors) )
			return tell(me, "èSoh춱ΤHOC\n");
		
		foreach( string file in labors )
		{
			if( ++i == num )
			{
				if( !file_exist(file+".o") )
	    			{
	    				set("hirelabors", labors - ({ file }), me);
	    				if( !sizeof(query("hirelabors", me)) )
	    					delete("hirelabors", me);
	    				continue;
	    			}

    				if( !objectp(labor = load_object(file)) )
    					error("Can't load "+file+".");

				if( same_environment(me, labor) )
					return tell(me, labor->query_idname()+"wgbo̤FC\n");

				if( query("adventure", labor) && file_exists(query("adventure/from", labor)) && ADVENTURE_D->is_doing_adventure(query("adventure/from", labor)) )
					return tell(me, labor->query_idname()+"b汴IȤALkl^C\n");

				waiting_time = labor->query_loading()/1000;
				
				// ̤ 5 
				if( waiting_time < 5 )
					waiting_time = 5;
				
				msg("$MEF@ʫHF"+labor->query_idname()+"s"+pnoun(3, labor)+"ߨ軰ӦB(ݭn "+waiting_time+" ɶ)C\n", me, 0, 1);
				
				if( query_temp("labor_call_out_handler", labor) )
				{
					remove_call_out(query_temp("labor_call_out_handler", labor));
					delete_temp("labor_call_out_handler", labor);
				}
				set_temp("labor_call_out_handler", call_out((: labor_call, me, labor:), waiting_time), labor);
				return;
			}
		}
	}
	else if( sscanf(arg, "salary %s", salary) == 1 )
	{
		labor_salary(me, salary);
		return;
	}
	else if( wizardp(me) && find_player(arg) )
		return tell(me, labor_list(find_player(arg)));
	
	return tell(me, "пJTO榡(help labor)C\n");
}