/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : levy.c
 * Author : Clode@RevivalWorld
 * Date   : 2003-04-04
 * Note   : xΤga
 * Update :
 *  o 2000-00-00
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <map.h>
#include <daemon.h>
#include <feature.h>
#include <message.h>
#include <location.h>

inherit COMMAND;

string help = @HELP
    ΩxiϥΦOӱjxga
levy here	- xثeүmgaAYgaYؿv@AN|
                  ɫؿv쥻ga֦̳ॢؿvҦga
levy north	- x_䪺ؿvΤga
levy south	- xn䪺ؿvΤga
levy east	- x䪺ؿvΤga
levy west	- xF䪺ؿvΤga
levy -d		- wxFga

@Ӥ뤺Wu	- ux~a(ҦpŦaBAСBB[)
WL@Ӥ를Wu	- ixҦЦa
HELP;

private void confirm_levy(object me, array loc, string owner, string arg)
{
	if( arg != "y" && arg != "yes" )
		return me->finish_input();

	ESTATE_D->remove_estate(loc);
	
	CITY_D->set_coor_data(loc, "owner", "GOVERNMENT/"+loc[CITY]);
	CITY_D->set_coor_icon(loc, BMAG"D"NOR);

	ESTATE_D->set_land_estate("GOVERNMENT/"+loc[CITY], loc);
	
	if( !owner )
		CHANNEL_D->channel_broadcast("city", me->query_idname()+"jxF"+CITY_D->query_city_idname(loc[CITY], loc[NUM])+" "HIG+(loc[X]+1)+","+(loc[Y]+1)+NOR" gaC\n", me);
	else
		CHANNEL_D->channel_broadcast("city", me->query_idname()+"jxF "HIY+capitalize(owner)+NOR" b"+CITY_D->query_city_idname(loc[CITY], loc[NUM])+" "HIG+(loc[X]+1)+","+(loc[Y]+1)+NOR" gaC\n", me);
	
	return msg("$MEjxFogaAHѥϥΡC\n", me, 0, 1);
}

private void do_command(object me, string arg)
{
	string owner;
	array loc;
	object env = environment(me);
	object ownerob;

	if( !env || !env->is_maproom() ) 
		return tell(me, pnoun(2, me)+"LkxogaC\n");
	
	loc = query_temp("location", me);

	if( arg == "north" )
		loc = arrange_city_location(loc[X], loc[Y]-1, loc[CITY], loc[NUM]);
	else if( arg == "south" )
		loc = arrange_city_location(loc[X], loc[Y]+1, loc[CITY], loc[NUM]);
	else if( arg == "west" )
		loc = arrange_city_location(loc[X]-1, loc[Y], loc[CITY], loc[NUM]);
	else if( arg == "east" )
		loc = arrange_city_location(loc[X]+1, loc[Y], loc[CITY], loc[NUM]);

	if( !CITY_D->valid_coordinate(loc[X], loc[Y], loc[CITY], loc[NUM]) )
		return tell(me, "ӤVyп~C\n");

	if( !CITY_D->is_mayor_or_officer(loc[CITY], me) )
		return tell(me, pnoun(2, me)+"OoyΩxC\n");
		
	owner = CITY_D->query_coor_data(loc, "owner");
	
	if( arg == "-d" )
	{
		if( owner != "GOVERNMENT/"+loc[CITY] )
			return tell(me, "oa쥻NOΦaC\n");
		
		if( CITY_D->query_coor_data(loc, TYPE) == ROAD )
			return tell(me, pnoun(2, me)+"DC\n");
			
		if( CITY_D->query_coor_data(loc, TYPE) == BRIDGE )
			return tell(me, pnoun(2, me)+"١C\n");

		CITY_D->delete_coor_data(loc);

		ESTATE_D->remove_estate(loc);

		CHANNEL_D->channel_broadcast("city", me->query_idname()+"X"+CITY_D->query_city_idname(loc[CITY], loc[NUM])+" "HIG+(loc[X]+1)+","+(loc[Y]+1)+NOR" FgaC\n", me);
	
		return msg("$MEXFoFgaAHѥʶRC\n", me, 0, 1);
	}


	if( owner )
	{
		if( belong_to_government(owner) )
			return tell(me, "oawgOΦaC\n");

		if( belong_to_enterprise(owner) )
			return tell(me, "Lkx~gaC\n");

		if( !CITY_D->is_mayor(loc[CITY], me) )
			return tell(me, "oga "+owner+" Ҿ֦AuxpHgaC\n");

		if( !sizeof(ESTATE_D->query_loc_estate(loc)["roomtable"]) )
		{
			tell(me, "O_TwLvjx "+capitalize(owner)+" ֦o "HIY+money(MONEY_D->city_to_money_unit(loc[CITY]), ESTATE_D->query_estate_value(loc))+NOR" gaH(yes/no)");
			input_to( (: confirm_levy, me, loc, owner :) );
			return;
		}
	
		if( find_player(owner) )
			return tell(me, pnoun(2, me)+"LkjxuWaЦaC\n");
			
		ownerob = load_user(owner);

		// @Ӥ를WuixЦa
		if( !wizardp(me) && time() - query("last_on/time", ownerob) < 30*24*60*60 )
		{
			tell(me, ownerob->query_idname()+"@Ӥ뤺gWuA\xЦaC\n");
			destruct(ownerob);
			return;
		}
		
		tell(me, "O_TwLvjx"+ownerob->query_idname()+"o "HIY+money(MONEY_D->city_to_money_unit(loc[CITY]), ESTATE_D->query_estate_value(loc))+NOR" gaH(yes/no)");
		
		destruct(ownerob);
		
		input_to( (: confirm_levy, me, loc, owner :) );
			
		return;
	}
	
	if( !CITY_D->query_coor_data(loc, "region") )
		return tell(me, pnoun(2, me)+"uxw]wnWϤgaC\n");

	switch( CITY_D->query_coor_data(loc, TYPE) )
	{
		case MOUNTAIN:
		case FOREST:
		case RIVER:
			return tell(me, "oaO۵MaΡALkxC\n");
			break;
	}

	confirm_levy(me, loc, owner, "yes");
}
