/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : msg.c
 * Author : Clode@RevivalWorld
 * Date   : 2004-06-17
 * Note   : msg O
 * Update :
 *  o 2000-00-00
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <feature.h>
#include <message.h>
#include <daemon.h>

inherit COMMAND;

string help = @HELP
    ̪ܳ񦬨쪺 1000 Ӳ/WDάOKyTC

msg +		W[YT
msg -		YT
msg 		]wTơA̤֬ 10 A̦h 1000 
msg clear		RҦT
msg info		dߥثeT

T]AG}WD(chat, city, rumor, news, ...), emotion, say, tell

HELP;

private void do_command(object me, string arg)
{
	int i, size;
	array data;
	object target;
	string type;
		
	if( arg == "clear" )
	{
		me->clear_msg_log();
		return tell(me, pnoun(2, me)+"MҦTC\n");
	}

	if( arg == "info" )
	{
		mapping setup = query("msg", me);
		
		if( !mapp(setup) || !sizeof(keys(setup)-({ "size" })) )
			return tell(me, pnoun(2, me)+"S]wTC\n");
		
		map_delete(setup, "size");
		
		return tell(me, pnoun(2, me)+"ثe]wTءG"+implode(keys(setup), ", ")+"\n");
	}
	
	if( arg && (size = to_int(arg)) )
	{
		if( size < 10 || size > 1000 )
			return tell(me, "T̤֬ 10 A̦h 1000 C\n");
		
		set("msg/size", size, me);
		tell(me, pnoun(2, me)+"]wTƬ "+size+" C\n");
		me->save();
		return;
	}

	if( arg && sscanf(arg, "+%s", type) == 1 )
	{
		if( type == "say" || type == "tell" || type == "emotion" || type == "announce" || CHANNEL_D->valid_channel(SECURE_D->level_num(me->query_id(1)), type) )
		{
			set("msg/"+type, 1, me);
			tell(me, pnoun(2, me)+"}l "+type+" TC\n");
			me->save();
			return;
		}
		else
			return tell(me, "Lk]w "+type+" oذTC\n");
	}
	else if( arg && sscanf(arg, "-%s", type) == 1 )
	{
		if( type == "say" || type == "tell" || type == "emotion" || type == "announce" || CHANNEL_D->valid_channel(SECURE_D->level_num(me->query_id(1)), type) )
		{
			delete("msg/"+type, me);
			tell(me, pnoun(2, me)+" "+type+" TC\n");
			me->save();
			return;
		}
		else
			return tell(me, "Lk]w "+type+" oذTC\n");
	}
	
	if( wizardp(me) && arg && objectp(target = find_player(arg)) && SECURE_D->level_num(target) <= SECURE_D->level_num(me) )
		data = target->query_msg_log();
	else
		data = me->query_msg_log();
    	
    	size = sizeof(data);
    	
    	if( size )
    	{
    		string *str;
    			
    		str = ({ (target?target->query_idname():"")+"@ "+(size/3)+" °TG\nwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww\n" });
    		
    		if( arg && !target )
    		{
    			for(i=0;i<size;i+=3)
    				if( data[i+1] == arg )
    					str += ({ HIW+ctime(data[i])[11..15]+NOR"-"+data[i+2] });
    		}
    		else
    		{
    			for(i=0;i<size;i+=3)
    				str += ({ HIW+ctime(data[i])[11..15]+NOR"-"+data[i+2] });
    		}
   
   		str += ({ "wwwwwwwwwwwwwwwwwwwwwwwwwwwwثeɨ "HIW+ctime(time())[11..15]+NOR"ww\n" });
   		me->more(implode(str, ""));
	}	
    	else
    		return tell(me, (target?target->query_idname():"")+"ثeSTC\n");
}
