/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : order.c
 * Author : Clode@RevivalWorld
 * Date   : 2003-05-19
 * Note   : ROO
 * Update :
 *  o 2003-00-00  
 *
 -----------------------------------------
 */

#include <daemon.h>
#include <ansi.h>
#include <feature.h>
#include <message.h>
#include <npc.h>
#include <skill.h>
#include <secure.h>

inherit COMMAND;

string help = @HELP
   oiHAUROۤvHOAثe}񪺩ROpUG

SROO
  order 'u' to name ''		- uWr
  order 'u' to id '^'		- u^Wr

  order 'u' to work clerk		- ROuqƩu@(u@ clerk/worker/engineer)
  order 'u' to work -d		- ROuu@

  order 'u' to learn 'ޯ'		- ROuVzǲߧޯ(zƤf~ޯPоǧޯ)
  order 'u' to learn 'ޯ' 50%	- @ӶO 50% 믫ӱоɭu

  order 'u' to heal			- ΦۤvOӱϧUw˪u(ȮɫO)

зǨtΫO
  order 'u' to command		- d߭uiHϥΪtΫO
  order 'u' to 'O'		- ROuYӨtΫO(OΪkPa`ΪkۦP)


O: labor
HELP;

private void do_command(object me, string arg)
{
	string id, key, value;
	object npc, env;

	if( !arg )
		return tell(me, pnoun(2, me)+"QnRO֡H\n");

	if( sscanf(arg, "%s to %s", id, key) != 2 )
		return tell(me, pnoun(2, me)+"QnROְơH( order boy to name k)\n");
		
	env = environment(me);

	if( !objectp(npc = present(id, env)) )
		return tell(me, "ǫS "+id+" oӤHC\n");
	
	if( !npc->is_living() )
		return tell(me, pnoun(2, me)+"LkRO@ӵLͩRFC\n");
	
	if( !npc->is_npc() || (!wizardp(me) && query("boss", npc) != me->query_id(1)) )
		return tell(me, npc->query_idname()+"äO"+pnoun(2, me)+"ΪC\n");

	sscanf(key, "%s %s", key, value);

	if( query("faint", npc) && key != "heal" )
		return tell(me, pnoun(2, me)+"LkROˤu@ƱC\n");

	switch(lower_case(key))
	{
		case "name":
		{
			if( !value || !value[0] )
				return tell(me, pnoun(2, me)+"Qn"+npc->query_idname()+"򤤤WrH\n");

			value = kill_repeat_ansi(value+NOR);

			if( !is_chinese(value) )
				return tell(me, ""+pnoun(2, me)+"ΡuvWrC\n");
	
			if( noansi_strlen(value) > 12 || noansi_strlen(value) < 2 )
				return tell(me, "Wrb 1  6 ӤrC\n");

			msg("$MEhJ$YOUDG"+pnoun(2, npc)+"HᤤWlNWsu"+value+"vaI\n", me, npc, 1);
			npc->set_idname(0, value);
			npc->do_command("say ¦ڨsWrAڤ@w|tz...");

			npc->save();				
			break;
		}
		case "id":
		{
			if( !value || !value[0] )
				return tell(me, pnoun(2, me)+"Qn"+npc->query_idname()+"^WrH\n");
			
			value = kill_repeat_ansi(lower_case(value)+NOR);
			
			if( !is_english(value) )
				return tell(me, ""+pnoun(2, me)+"Ρu^vWrC\n");
			
			if( noansi_strlen(value) > 16 || noansi_strlen(value) < 3 )
				return tell(me, "^Wrb 3  16 ӭ^rƤC\n");
				
			if( user_exists(remove_ansi(value)) )
				return tell(me, "oW{aWrC\n");
				
			msg("$MEhJ$YOUDG"+pnoun(2, npc)+"H^WlNWsu"+value+"vaI\n", me, npc, 1);
			npc->set_idname(value, 0);
			npc->do_command("say ¦ڨs^WrAڤ@w|tz...");
			
			npc->save();
			break;
		}
		case "work":
		{
			int job;
			string job_name;
			mapping action_info;

			if( !value || !value[0] )
				return tell(me, pnoun(2, me)+"Qns"+npc->query_idname()+"˪u@(engineer, worker, clerk, adventurer)H\n");
			
			//if( !wizardp(me) && query("owner", env) != me->query_id(1) )
			//	return tell(me, "ǫäO"+pnoun(2, me)+"ؿvALku@C\n");

			switch( value )
			{
				case "-d":
					if( !query("job", npc) )
						return tell(me, npc->query_idname()+"쥻NSbiu@C\n");
					
					msg("$MEs$YOUҦu@C\n", me, npc, 1);
					delete("job", npc);
					delete("position", npc);
					npc->do_command("say OC");
					return;
				case "engineer":
					job = ENGINEER;		
					job_name = HIR"u"NOR RED"{v"NOR;
					break;
				
				case "worker":
					job = WORKER;
					job_name = HIY"u"NOR YEL"H"NOR;
					break;
				
				case "clerk":
					job = CLERK;
					job_name = HIC""NOR CYN""NOR;
					break;
				
				case "adventurer":
					job = ADVENTURER;
					job_name = HIG""NOR GRN"I"NOR;
					break;
				default:
					return tell(me, "nؤu@(engineer, worker, clerk, adventurer)H\n"NOR);
			}
			
			//if( query("job/cur", npc) == job )
			//	return tell(me, npc->query_idname()+"wgb"+job_name+"u@FC\n");

			action_info = env->query_action_info(query("function", env));
			
			//if( !mapp(action_info) || !(action_info["job"] & job) )
			//	return tell(me, "ǫäݭn"+job_name+"oؤu@HOC\n");
			
			//if( env->query_master() != env )
			//	return tell(me, "uubsꤤߤu@AbLau@OSΪC\n");

			msg("$MEhJ$YOUDGqѰ_"+pnoun(2, npc)+"N"+job_name+"u@aI\n", me, npc, 1);
			npc->do_command("say nIڤ@w|ɤߺɤOu@I");			
			npc->do_command("follow -d");

			//broadcast(env, "u"+npc->query_idname()+"}lۤu@.....\n");
			
			set("position", job_name, npc);
			set("job/cur", job, npc);
			set("job/efficiency", 500, npc);
			
			break;
		}

		case "learn":
		{
			int percent;
			int energy, costsocial;
			int max_level;
			int npc_level;

			if( !value || !value[0] )
				return tell(me, pnoun(2, me)+"Qn"+npc->query_idname()+"ǲߤޯH\n");

			if( sscanf(value, "%s %d%%", value, percent) == 2 )
			{
				if( percent <= 0 || percent > 100 )
					return tell(me, "пJT믫ӶOʤC\n");
					
				energy = percent * me->query_energy_max() / 100;
			}
			else
				energy = 50;

			value = lower_case(value);
			
			npc_level = npc->query_skill_level(value);
			
			if( !SKILL_D->skill_exists(value) )
				return tell(me, "èS "+value+" oاޯC\n");

			if( npc_level >= me->query_skill_level("teach") )
				return tell(me, pnoun(2, me)+""+(SKILL("teach"))->query_idname()+"ŤA"+npc->query_idname()+""+(SKILL(value))->query_idname()+"ŤAWɡC\n");

			max_level = (SKILL(value))->max_level(npc);
			
			if( npc_level >= max_level )
				return tell(me, npc->query_idname()+""+(SKILL(value))->query_idname()+"ޯ൥ŤwgFWC\n");

			if( !(SKILL(value))->allowable_learn(npc) )
				return tell(me, npc->query_idname()+"Lkǲ߳oޯC\n");
				
			if( !me->cost_energy(energy) )
				return tell(me, pnoun(2, me)+"믫 "+energy+"ALkAǱ§ޯFC\n");
				
			costsocial = energy / 10;
			
			if( costsocial < 5 )
				costsocial = 5;
			
			if( !me->cost_social_exp(costsocial) )
				return tell(me, pnoun(2, me)+"|gȤ "+costsocial+"ALkAǱ§ޯFC\n");
				
			msg("$MEӶO "+energy+" 믫JӦaǱ$YOU"+(SKILL(value))->query_idname()+"gC\n"+npc->query_idname()+""+(SKILL(value))->query_idname()+"Fi@BAѡC\n", me, npc, 1);
			
			npc->add_skill_exp(value, pow((me->query_skill_level("eloquence")+1) * energy, 1.001));
			
			npc_level = npc->query_skill_level(value);
			
			if( npc_level >= max_level )
			{
				set("skills/"+value+"/level", max_level, npc);
				set("skills/"+value+"/exp", (SKILL(value))->level_exp(max_level), npc);
				//tell(me, npc->query_idname()+""+(SKILL(value))->query_idname()+"ޯ൥ŤwgAWɡC\n");
			}
			break;
		}
		case "command":
		{
			npc->do_command("say ڥثeiH檺tΫOG"+implode(COMMAND_D->query_available_command(STANDARD), ", "));
			break;
		}
		case "heal":
		{
			msg("$MEKb$YOUIAHͤONۤvͩRO`J$YOU餤C\n", me, npc, 1);
			
			npc->set_all_ability_full();
			
			if( npc->is_faint() )
				npc->wakeup();
			else
				msg("$MEPı믫ʭC\n", npc, 0, 1);

			npc->save();
		
			me->faint();
			break;
		}
		default:
		{
			msg("$MERO$YOUGu"HIY+(value?key+" "+value:key)+NOR"vC\n", me, npc, 1);

			if( !wizardp(me) && (COMMAND_D->find_chn_command(key) || COMMAND_D->find_emt_command(key)) )
				return npc->do_command("say ڤbWDWo]@O");

			npc->do_command(value?key+" "+value:key);
			break;
		}
	}
}