/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : passwd.c
 * Author : Clode@RevivalWorld
 * Date   : 2001-07-30
 * Note   : 
 * Update :
 *  o 2000-00-00
 *
 -----------------------------------------
 */

#include <daemon.h>
#include <feature.h>
#include <message.h>
#include <secure.h>

inherit COMMAND;

string help = @HELP
KXקO

oӫOiHקϥΪ̱KX

ЦUaȥOL᪺KXïdUTϥΪ̸T
HKKX򥢮ɡAiHzLTϥΪ̸TVŮv^
pקϥΪ̸TAԱ help chfn HohT

O:
HELP;

private void redo_passwd(object me);

private void confirm_new_passwd(object me, string new_passwd, string arg)
{
	/* קKQ~ */
	if( !is_command() ) return;
	
	tell(me, repeat_string("*", strlen(arg))+"\n");
	
	if( !arg || crypt(arg, new_passwd) != new_passwd )
	{
		tell(me, "KXT{ѡC\n");
		return redo_passwd(me);
	}
	
	if( !PASSWORD_D->set_password(me->query_id(1), new_passwd) )
	{
		tell(me, "KX]wѡAгqŮvBzC\n");
		return me->finish_input();
	}
	
	tell(me, "i MD5 sXtνsX:"+new_passwd+"\nKXsXxsC\n"+me->query_idname()+"KXwsAsKXߧYͮġC\n");
	me->finish_input();
}
	
private void input_new_passwd(object me, string arg)
{
	if( !is_command() ) return;
	
	tell(me, repeat_string("*", strlen(arg))+"\n");
	
	tell(me, "ЦAJ@T{G\n>");
	input_to( (: confirm_new_passwd, me, crypt(arg, 0) :), 3 );
}

private void check_old_passwd(object me, string arg)
{
	string old_passwd = PASSWORD_D->query_password(me->query_id(1));
	
	tell(me, repeat_string("*", strlen(arg))+"\n");
	
	if( !old_passwd ) 
	{
		tell(me, "±KXjMGoͿ~AгqŮvBzC\n");
		return me->finish_input();
	}
	
	if( !arg || crypt(arg, old_passwd) != old_passwd )
	{
		tell(me, "KXJ~C\n");
		return redo_passwd(me);
	}
	
	tell(me, "пJsKXG\n>");
	input_to( (: input_new_passwd, me :), 3 );
}

private void confirm_redo_passwd(object me, string arg)
{
	if( !arg ) return redo_passwd(me);
	arg = lower_case(arg);
	
	if( arg[0] == 'y' )
	{
		tell(me, "\nХJz쥻KXG\n>");
		input_to( (: check_old_passwd, me :), 3 );
	}
	else 
	{
		tell(me, "\nܧKXA~ϥέKXC\n");
		me->finish_input();
	}
}
	
private void redo_passwd(object me)
{
	tell(me, "\nקKXѡAO_s]w(Yes/No)H");
	input_to( (: confirm_redo_passwd, me :) );
}

private void do_command(object me, string arg)
{
	string id, newpasswd;

	if( call_stack(1)[<1] != me || this_player(1) != me ) return;
	
	if( arg && sscanf(arg, "%s %s",id, newpasswd) == 2 && SECURE_D->level_num(me->query_id(1)) >= ADVISOR )
	{
		newpasswd = remove_ansi(newpasswd);
		
		if( strlen(newpasswd) < 4 )
			return tell(me, "KXrƥj 4C\n");

		if( user_exists(id) )
		{
			if( !PASSWORD_D->set_password(id, crypt(newpasswd, 0)) )
				return tell(me, id+" KX]wѡC\n");
			else
				return tell(me, id+" sKX]w "+newpasswd+"C\n");
		}
	}
		
	tell(me, "ХJz쥻KXG\n>");
	input_to( (: check_old_passwd, me :), 3 );
}