/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : sit.c
 * Author : Clode@RevivalWorld
 * Date   : 2002-02-20
 * Note   : O
 * Update :
 *  o 2000-00-00  
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <map.h>
#include <delay.h>
#include <feature.h>
#include <daemon.h>
#include <message.h>

inherit COMMAND;

string help = @HELP
    AiHϥγoӫObOBjBDFa𮧡AO_|
q]ɭ٭n֤@ICӦboTӦa𮧪ĪG]PAoIN
dݦUFCpGbASoǴ[ܡAA]iHҼ{Rb񪺦a
سy(build)@ӡC

t~ sit iHѥ𮧳]Į֦ӳ]w\ϥΦ]IaW
     sit -l          dݥثe\ϥΦW
     sit -onlyme     u\֦̦ۤvϥ
     sit -open       }ҦHϥ
     sit 'ID'        ]w}񵹬YǯSwaϥ(AJ@)

HELP;

#define REGEN	60

private void do_command(object me, string arg)
{
	int cost, time, regen, type;
	array loc = query_temp("location", me);
	string owner, myid;
	string *allow;
	string map_system;

	if( !arrayp(loc) || (!CITY_D->is_city_location(loc) && !AREA_D->is_area_location(loc)) )
		return tell(me, pnoun(2, me)+"LkboӦa𮧡C\n");

	map_system = MAP_D->query_map_system(loc);

	myid = me->query_id(1);
	owner = map_system->query_coor_data(loc, "owner");
	allow = map_system->query_coor_data(loc, "sit_allow");		
	type = map_system->query_coor_data(loc, TYPE);
	
	if( type != PAVILION && type != TREE && type != GRASS )
		return tell(me, "oӦaSkU𮧡C\n");
	
	if( map_system == CITY_D )
	{
		if( arg  )
		{
			if( arg == "-l" )
			{
				if( sizeof(allow) )
					tell(me, "𮧳]IثeQ\ϥΪa "+implode(allow, " ")+"C\n");
				else if( arrayp(allow) )
					tell(me, "𮧳]Iثeu\֦̦ۤvϥΡC\n");
				else
					tell(me, "𮧳]Iثe}ҦHϥΡC\n");
				
				return;
			}
	
			if( owner != me->query_id(1) )
				return tell(me, pnoun(2, me)+"Oa֦HAoӥ𮧦aI]wC\n");
				
			if( arg == "-onlyme" )
			{
				CITY_D->set_coor_data(loc, "sit_allow", ({ }));
				return tell(me, pnoun(2, me)+"Na]wu"+pnoun(2, me)+"ۤviHϥΡC\n");
			}
			else if( arg == "-open" )
			{
				CITY_D->delete_coor_data(loc, "sit_allow");
				return tell(me, pnoun(2, me)+"Na]w}ҦHϥΡC\n");
			}
			else
			{
				allow = allow || allocate(0);
				arg = remove_ansi(lower_case(arg));
				
				if( strlen(arg) > 12 )
					return tell(me, "пJTa IDC\n");
	
				if( member_array(arg, allow) != -1 )
				{
					allow -= ({ arg });
					tell(me, pnoun(2, me)+" "+capitalize(arg)+" ϥΦ]IC\n");
				}
				else
				{
					if( sizeof(allow) > 20 )
						return tell(me, "\WLkWL 20 HC\n");
	
					allow |= ({ arg });
					tell(me, pnoun(2, me)+"\ "+capitalize(arg)+" ϥΦ]IC\n");
				}
				
				CITY_D->set_coor_data(loc, "sit_allow", allow);
				return;
			}	
		}
		
		if( owner != myid && arrayp(allow) && member_array(myid, allow) == -1 )
			return tell(me, "oO "+capitalize(owner)+" pH֦]IA"+pnoun(2, me)+"ثeQ\ϥΡC\n");
	}

	if( me->is_delaying() )
		return tell(me, me->query_delay_msg());

	switch( type )
	{
		case PAVILION:
			cost = me->query_stamina_max() - me->query_stamina_cur();
			msg("$MEʵ"+(map_system->query_coor_data(loc, "short")||"DF")+"۬WǡAb۴ȤWǲD(_ "+cost+" O)C\n", me, 0, 1);
			regen = me->stamina_regen()+REGEN;
			time = 2*cost/regen + 1;
			
			if( time <= 0 )
				tell(me, "𮧧C\n");
			else
			{
				set_temp("rest_regen/stamina", REGEN, me);
				me->start_delay(REST_DELAY_KEY, time, pnoun(2, me)+"b"+(map_system->query_coor_data(loc, "short")||"DF")+"𮧡C\n", "𮧧C\n", bind((: delete_temp("rest_regen", $(me)), $(me)->set_stamina_full() :), me));
			}
			break;
			
		case TREE:
			cost = me->query_health_max() - me->query_health_cur();
			msg("$MEʵ"+(map_system->query_coor_data(loc, "short")||"F")+"Ab@K𽮤Uɨ۵M(_ "+cost+" ͩR)C\n", me, 0, 1);
			
			regen = me->health_regen()+REGEN;
			time = 2*cost/regen + 1;
			
			if( time <= 0 )
				tell(me, "𮧧C\n");
			else
			{
				set_temp("rest_regen/health", REGEN, me);
				me->start_delay(REST_DELAY_KEY, time, pnoun(2, me)+"bU𮧡C\n", "𮧧C\n", bind((: delete_temp("rest_regen", $(me)), $(me)->set_health_full() :), me));
			}
			break;
			
		case GRASS:
			cost = me->query_energy_max() - me->query_energy_cur();
			msg("$ME׽b"+(map_system->query_coor_data(loc, "short")||"")+"WALث(_ "+cost+" 믫)C\n", me, 0, 1);
			
			regen = me->energy_regen()+REGEN;
			time = 2*cost/regen + 1;
			
			if( time <= 0 )
				tell(me, "𮧧C\n");
			else
			{
				set_temp("rest_regen/energy", REGEN, me);
				me->start_delay(REST_DELAY_KEY, time, pnoun(2, me)+"b"+(map_system->query_coor_data(loc, "short")||"")+"W𮧡C\n", "𮧧C\n", bind((: delete_temp("rest_regen", $(me)), $(me)->set_energy_full() :), me));
			}
			break;
		default:
			error("sit error.");
	}
}
