/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : transfer.c
 * Author : Clode@RevivalWorld
 * Date   : 2005-03-03
 * Note   : transfer O
 * Update :
 *  o 2000-00-00
 *
 -----------------------------------------
 */

#include <feature.h>
#include <daemon.h>
#include <location.h>
#include <map.h>
#include <roommodule.h>

inherit COMMAND;

string help = @HELP
    ЦavಾOAFuಾɩҦж]wPeN@
ಾA[BAеDؿvhLkಾC

transfer here to 'ID'	- NaЦaಾt@Ӫa
HELP;


private void do_command(object me, string arg)
{
	string targetid;
	object targetob;
	array loc = query_temp("location", me);
	mapping estdata;
	array building_info;
	array loctemp;
	int target_architectonic_level;

	if( !arrayp(loc) || !environment(me)->is_maproom() )
		return tell(me, pnoun(2, me)+"bؿvfiЦaC\n");
		
	if( ESTATE_D->whose_estate(loc) != me->query_id(1) )
		return tell(me, "oɫؿväOݩ"+pnoun(2, me)+"C\n");

	estdata = ESTATE_D->query_loc_estate(loc);

	if( CITY_D->query_coor_data(loc, TYPE) != DOOR )
		return tell(me, pnoun(2, me)+"uಾؿvЦaC\n");
	
	if( !arg || !sscanf(arg, "here to %s", targetid) )
		return tell(me, help);
	
	if( !objectp(targetob = find_player(targetid)) )
		return tell(me, "ثeuWS "+targetid+" o쪱aC\n");
	
	if( me == targetob )
		return tell(me, "LkಾЦaۤvC\n");

	if( query("city", targetob) != query("city", me) )
		return tell(me, "uNЦaಾP@yC\n");

	if( !same_environment(me, targetob) )
		return tell(me, targetob->query_idname()+"Өo̤~iЦaಾC\n");

	target_architectonic_level = targetob->query_skill_level("architectonic") + targetob->query_skill_level("architectonic-adv");
	
	foreach(string sloc in estdata["roomtable"])
	{
		loctemp = restore_variable(sloc);	
		
		if( target_architectonic_level < sizeof(city_roomfiles(loctemp))-1 )
			return tell(me, targetob->query_idname()+"ؿv޳Nޯ൥ŤHӨo˪ؿvC\n");
	}
	
	building_info = BUILDING_D->query_building(estdata["type"]);
	
	if( building_info[ROOMMODULE_MAXLIMIT] > 0 && ESTATE_D->query_owner_amount(targetid, estdata["type"]) >= building_info[ROOMMODULE_MAXLIMIT] )
		return tell(me, targetob->query_idname()+"ثؿvƶqwgFWC\n");

		
	if( !ESTATE_D->transfer_estate(me->query_id(1), targetob->query_id(1), loc) )
		return tell(me, "ЦaಾoͿ~AгqŮvBzC\n");
	
	CHANNEL_D->channel_broadcast("city", me->query_idname()+"N"+CITY_D->query_city_idname(loc[CITY], loc[NUM])+"("+(loc[X]+1)+","+(loc[Y]+1)+")Цaಾ"+targetob->query_idname()+"C", me);
	msg("$MENؿvЦaಾ$YOUC\n", me, targetob, 1);
}
