/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : land_dominium.c
 * Author : Clode@RevivalWorld
 * Date   : 2002-1-21
 * Note   : gaҦv
 * Update :
 *  o 2000-00-00
 *
 -----------------------------------------
 */

#include <map.h>
#include <ansi.h>
#include <inherit.h>
#include <daemon.h>
#include <message.h>
#include <location.h>
#include <roommodule.h>

inherit STANDARD_OBJECT;

string DECLARATION = @TEXT


	             [1;37;43m g a   v  [m
    QγoigaҦviۥѻ{@LH֦gaA{
gaK%^GENDER%^Ҿ֦A{ga%^GENDER%^KiH}lQΦgaӳгy]
ݩۤv]IAܤ@a claim Yi{C      [1;31m~w[m
                                                     [1;31mx֢x[m
    ̡֦G%^ID%^                             [1;31mxx[m
    ĴGû                               [1;31mw[m
    

TEXT;

void do_claim(object me, string arg);

mapping actions = 	
([
	"claim"			:(: do_claim :),
]);

void do_claim(object me, string arg)
{
	object env = environment(me);
	mapping data;
	string owner;
	array loc = query_temp("location", me);
	
	if( !(owner = query_temp("owner")) )
		return tell(me, "oO@io󪺤gaҦvA"+pnoun(2, me)+"LkϥΡC\n", CMDMSG);
		
	if( owner != me->query_id(1) )
		return tell(me, "oigaҦvO "+capitalize(owner)+" A"+pnoun(2, me)+"LvϥΡC\n", CMDMSG);
	
	if( !arrayp(loc) || !env || !env->is_maproom() ) 
		return tell(me, pnoun(2, me)+"Lk{ogaC\n", CMDMSG);

	if( !CITY_D->is_city_location(loc) )
		return tell(me, pnoun(2, me)+"ubϰ줺{gaC\n", CMDMSG);

	if( loc[CITY] != query("city", me) )
		return tell(me, pnoun(2, me)+"ubۤv̻{gaC\n", CMDMSG);

	if( !(CITY_D->query_coor_data(loc, "region") & AGRICULTURE_REGION) )
		return tell(me, pnoun(2, me)+"u{wggLFWA~ϡC\n", CMDMSG);
	
	if( !mapp(data = CITY_D->query_coor_data(loc)) )
		return tell(me, "gaƿ~AгqŮvBzC\n", CMDMSG);
	
	if( nullp(owner = data["owner"]) && nullp(data["ownership"]) )
	{
		if( CITY_D->set_coor_data(loc, "owner", me->query_id(1)) )
		{
			CITY_D->set_coor_icon(loc, BWHT""NOR);
			CITY_D->set_coor_data(loc, "claimed", 1);
			tell(me, pnoun(2, me)+"QΤgaҦv{FogaC\n", CMDMSG);
			
			// ]wЦaT
			ESTATE_D->set_land_estate(me->query_id(1), loc);

			delete("flag/land_dominium", me);
			me->save();
			destruct(this_object());
		}
		else if( owner == me->query_id(1) )
			return tell(me, "oawgO"+pnoun(2, me)+"FC\n", CMDMSG);
	}
	else tell(me, "oawgOOHFA"+pnoun(2, me)+"Lk{C\n", CMDMSG);
}

// b֤WNO֪
void set_owner()
{
	object env = environment(this_object());

	if( env && userp(env) )
	{
		set_idname(env->query_id()+"'s land dominium", env->query_name()+"gaҦv");
		set("long", terminal_colour(DECLARATION, (["ID":sprintf("%-12s",ansi_capitalize(env->query_id())), "GENDER":(query("gender", env)=="k"?"A":"p")])));
		set_temp("owner", env->query_id(1));
	}
}

void create()
{
	set_idname("droped land dominium", "o󪺤gaҦv");
	set_temp("keep", 2);
	set("long", terminal_colour(DECLARATION, (["ID":sprintf("%-12s","wo"), "GENDER":"L"])));
	
	call_out( (: set_owner :), 1 );
	
        if( this_object()->set_shadow_ob() ) return;
	
	set("unit","i");
	set("mass",10);
	set("value", -1);
	set("flag/no_amount", 1);
        set("flag/no_drop", 1);
        set("flag/no_give", 1);
}
