/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : mjai_clode.c
 * Author : Clode@RevivalWorld
 * Date   : 2005-12-31
 * Note   : OWQi±N AI 
 * Update :
 *  o 2000-00-00  

 -----------------------------------------
 */

#include <ansi.h>
#include <inherit.h>
#include "mj.h"

inherit STANDARD_NPC;

#define MJOB	(query_temp("mjobject"))

varargs void create()
{
	set_idname("AI MJer",HIC"Huz"NOR CYN"±NL"NOR);
	set("unit", "");
	startup_living();
}

// C@iPIs AI_pg() ]w۰ʸIb
void AI_pg()
{
	string *group;
	mapping Pdata = copy(fetch_variable("Pdata", MJOB));
	mapping data = Pdata[this_object()];

	// YwgťPhIbˬd
	if( sizeof(data[LISTEN]) ) return;

	foreach( group in MJOB->tile_logic_check(data[TILE]) )
	{
		if( sizeof(group) == 2 && group[0] == group[1] && member_array(group[0], data[AUTOPON]) == -1 )
			data[AUTOPON] += ({ group[0] });

		if( sizeof(group) == 3 && group[0] == group[1] && group[1] == group[2] && member_array(group[0], data[AUTOGON]) == -1 )
			data[AUTOGON] += ({ group[0] });
	}
}

// WaPIs AI_eat P_O_YP
// ^ǭnYiP ex:({ "2w", "3w" })
string *AI_eat()
{
	int i;
	string *group;
	array choice = allocate(2, allocate(0));
	mapping MJdata = copy(fetch_variable("MJdata", MJOB));
	mapping Pdata = copy(fetch_variable("Pdata", MJOB));
	mapping data = Pdata[this_object()];

	if( sizeof(data[LISTEN]) || !MJdata[DUMPING] ) return 0;

	foreach( group in MJOB->tile_logic_check(data[TILE]) )
	switch(sizeof(group))
	{
	case 1: choice[0] += group;
		break;
	case 2: if( group[0] != group[1] )
			choice[1] += ({ group });
		break;
	}

	// check 
	foreach( group in choice[1] )
	{
		// YSb諸ɭ
		if( group[0][0] == group[1][0] - 1
		    && MJdata[DUMPING][1] == group[0][1]
		    && (MJdata[DUMPING][0] == group[0][0] - 1 || MJdata[DUMPING][0] == group[1][0] + 1 ))
			return group;
	}

	// check O_}
	for(i=0;i<sizeof(choice[0])-1;i++)
	{
		if( choice[0][i][1] == choice[0][i+1][1]
		    && choice[0][i][0] == choice[0][i+1][0] - 2
		    && MJdata[DUMPING][1] == choice[0][i][1]
		    && MJdata[DUMPING][0] == choice[0][i][0] + 1)
			return ({ choice[0][i], choice[0][i+1] });
	}

	return 0;
}

//  AI PɩIs AI_da()
string AI_da()
{
	string *group;
	array choice = allocate(2, allocate(0));
	string *result = allocate(0);
	mapping MJdata = copy(fetch_variable("MJdata", MJOB));
	mapping Pdata = copy(fetch_variable("Pdata", MJOB));
	mapping data = Pdata[this_object()];

	foreach( group in MJOB->tile_logic_check(data[TILE]) )
	switch(sizeof(group))
	{
		case 1: choice[0] += group;
			break;
		case 2: if( group[0] != group[1] )
				choice[1] += ({ group });
			break;
	}

	// ̷ӦrP -> i -> L, N氦Ƨ
	choice[0] = sort_array(choice[0],
	    (: member_array($1[0]-48, ({ ({1,9,2,8,3,7,4,6,5}), ({9,1,8,2,7,3,6,4,5}) })[random(2)])
		> member_array($2[0]-48, ({ ({1,9,2,8,3,7,4,6,5}), ({9,1,8,2,7,3,6,4,5}) })[random(2)]) ? 1 : -1 :));

	// HťPɶ}lpߥP
	if( MJdata[LISTENING] || sizeof(MJdata[DUMPED]) > 35 )
	{
		if( sizeof(choice[0]) )
		{
			// uQLP
			result = choice[0] & (string *)MJdata[DUMPED];
			
			// LPhƶ
			if( sizeof(result) )
			{
				// ƧǭQLP, ̪񪺵PƳ̫eY
				result = sort_array(result, (: member_array($1, $(MJdata)[DUMPED]) < member_array($2, $(MJdata)[DUMPED]) ? 1 : -1 :));
			}
			// YOSQLPhrP
			else
			{
				result = choice[0] & ({ "ea", "so", "we", "no", "jo", "fa", "ba" });
			}
		}

		if( !sizeof(result) && sizeof(choice[1]) )
		{
			// QL
			foreach( group in choice[1] )
			{
				if( member_array(group[0], MJdata[DUMPED]) != -1 )
					result += ({ group[0] });
				if( member_array(group[1], MJdata[DUMPED]) != -1 )
					result += ({ group[1] });
			}

			if( sizeof(result) )
			{
				result = sort_array(result, (: member_array($1, $(MJdata)[DUMPED]) < member_array($2, $(MJdata)[DUMPED]) ? 1 : -1 :));
				
			}
		}
	}
	else
	{
		// Yh
		if( sizeof(choice[0]) )
		{
			// P_O_b}, ܫhiP
			foreach( string t in choice[0] )
			{
				if( member_array(t[1], ({ 'w', 's', 't' })) == -1 ||
				(member_array(sprintf("%c%c", t[0]+2, t[1]), choice[0]) == -1 && member_array(sprintf("%c%c", t[0]-2, t[1]), choice[0]) == -1) )
					result += ({ t });
			}
		}
		
		// ɶq䥴
		if( !sizeof(result) )
			result = choice[0];

		// YL, h䥴
		if( !sizeof(result) && sizeof(choice[1]) )
		{
			// QL
			foreach( group in choice[1] )
			{
				if( member_array(group[0], MJdata[DUMPED]) != -1 )
					result += ({ group[0] });
				if( member_array(group[1], MJdata[DUMPED]) != -1 )
					result += ({ group[1] });
			}
		}
	}

	// ASNéPMwP
	if( !sizeof(result) )
		result = sort_array(data[TILE], (: member_array($1, $(MJdata)[DUMPED]) < member_array($2, $(MJdata)[DUMPED]) ? 1 : -1 :));

	return result[0];
}

// CPIs AI_tin() P_O_ťP au hu
array AI_tin()
{
	int i, j, listencount;
	object ppl;
	string tile, seatile;
	mapping listening = allocate_mapping(0);
	mapping MJdata = copy(fetch_variable("MJdata", MJOB));
	mapping Pdata = copy(fetch_variable("Pdata", MJOB));
	mapping data = Pdata[this_object()];
	string *mytiles = data[TILE];
		
	// ۰ʤRǵPiHť
	foreach( tile in Tsort )
	{
		if( MJOB->valid_hu_check(MJOB->tile_sort(mytiles+({ tile })), 0, 0) )
		{
			// ˬdۤvFXi
			i = member_array(tile, mytiles);
			if(i!=-1)
			{
				j++;
				while( i++<sizeof(mytiles)-1 && mytiles[i-1] == mytiles[i] )
					j++;
			}

			// ˬdXi
			foreach( seatile in MJdata[DUMPED] )
			if( seatile == tile ) j++;

			// ˬdҦHeXi
			foreach( ppl in fetch_variable("Psort", MJOB) )
			{
				i = member_array( tile, fetch_variable("Pdata", MJOB)[ppl][OTILE] );
				if(i!=-1)
				{
					j++;
					while( i++<sizeof(Pdata[ppl][OTILE])-1 && Pdata[ppl][OTILE][i-1] == Pdata[ppl][OTILE][i] )
						j++;
				}
			}

			listening[tile] = 4-j;
		}
	}


	foreach( i in values(listening) )
	listencount += i;

	// ť
	if( !sizeof(listening) || !listencount )
		return 0;

	// Yuť@P, hť, ]w۰ʭJ
	if( sizeof(listening) == 1 )
		return keys(listening); // @ au hu ʧ@
	else if( listencount < 3 )
		return keys(listening);
	else
		return ({1});// ťP
}

void emotion_begin()
{
	set_this_player(this_object());
	switch(random(10))
	{
		case 0:this_object()->do_command("say ڷQ@UӭiP.....");break;
                case 1:this_object()->do_command("pace ڬOQKHgXӪ");break;
		case 2:this_object()->do_command("pace 147 258 369");break;
		case 3:this_object()->do_command("pace 13579 2468");break;
	}
}
void emotion_eat()
{
	set_this_player(this_object());
	switch(random(10))
	{
		case 1:this_object()->do_command("mars");	break;
		case 2:this_object()->do_command("wire Y");	break;
		case 3:this_object()->do_command("fascinate");	break;
	}
}

void emotion_pon()
{
	set_this_player(this_object());
	switch(random(10))
	{
		case 1: this_object()->do_command("pace I"); break;
		case 2: this_object()->do_command("sing"); break;
		case 3: this_object()->do_command("excellent I"); break;
		case 4: this_object()->do_command("fascinate I"); break;
	}
}

void emotion_mo()
{
	mapping MJdata = copy(fetch_variable("MJdata", MJOB));

	set_this_player(this_object());
	switch(random(20))
	{
		case 1:this_object()->do_command("wahaha");break;
                case 2:this_object()->do_command("pace ڬOQtHgXӣx");break;
		case 3..4:
			if( MJdata[LISTENING] )
			{
				this_object()->do_command("imho "+MJOB->full_chinese(Tsort[random(sizeof(Tsort))])+"jvӦ "+sprintf("%.2f%%", random(1000)/10.)); break;
			}
			break;
		case 5..8:
			if( MJdata[LISTENING] )
			{
				this_object()->do_command("imho ӦHbť "+MJOB->full_chinese(Tsort[random(sizeof(Tsort))])); break;
			}
			break;
		case 9:
			if( MJdata[LISTENING] )
				this_object()->do_command("imho ӦHbť "HIY"MP"NOR YEL"3"NOR); break;
	}
}
