/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : rice seedlings.c
 * Author : Clode@RevivalWorld
 * Date   : 2002-2-20
 * Note   : _
 * Update :
 *  o 2000-00-00
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <inherit.h>

inherit STANDARD_OBJECT;

void create()
{
	set_idname("rice seedling","_");

	if( this_object()->set_shadow_ob() ) return;

	set("unit", "");
	set("mass", 10);	// q
	set("value", 1);	// 
	set("badsell", 1);

	// ؤlT
	set("seed_data",
		([
			//, @, ΩүO]w
			"str_cost": ([
				"sow"		:5, //μخɻݭnO
				"irrigate"	:10, //@CɤݭnO 
				"reap"		:10 //ήɻݭnO
				]),

			//ؤl
			"seed":"_",

			//]wάO
			"sow_type":"",

			//β~ƶq]wP~|
			"reap":({ 15, "/obj/farming/rice.c"}),

			//UӨBJA@T
			"msg":
			([
				// خɪT
				"sow":
					"_aЦaA@YYVaPıC\n" ,

				// @ɪ@ƻPT
				"irrigate":
				({
					1,"_ФWpp]wgjFC\n",
					2,"u_Ф@NsMARFͮC\n",
					3,"_ФW_̤wgFC\n",
					5,"u@⪺_СAwgΦA@FA@ߵ@}lKiHΡC\n",
				}),

				// ήɵݬƻPT
				"reap":
				({
					20,
					"oAФW_̤wgFAשiHΤFC\n",
					"oAиgLhӪ@Aש󦨼ΤFC\n@ΤF$NUMU_̡C\n"
				}),

				// oɪƻPT
				"neglect":
				({	
					300,
					"oAХѩhӯʥF@AW_]\FC\n",
					"oAХѩhӯʥF@AwgoFC\n",
				}),

				// ѮvTԭz
				"weather":
				([
					"RAINY":"sӪBqϱo@ǽ_]wGFC\n",
					"SNOWY":"jssYϱo_]̳a\FC\n",
					"WINDY":"gjŧϱo_]Qjdy_C\n",
				]),
			]),
		])
	);
}