/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : young_crab.c
 * Author : Clode@RevivalWorld
 * Date   : 2005-09-30
 * Note   : p
 * Update :
 *  o 2000-00-00
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <inherit.h>
#include <nature.h>
#include <map.h>

inherit STANDARD_OBJECT;

void create()
{
        set_idname("young crab","p");
        
        if( this_object()->set_shadow_ob() ) return;
        
        set("long", "pɡC\n");
        set("unit", "");
        set("mass", 150);
        set("value", 4000);
        set("badsell", 1);

	// ؤlT
	set("growth",
	([
		//
		"type":		FISHFARM,

		//W
		"idname":	this_object()->query_idname(),
		
		//}lͲɪT
		"start_msg":"pɦbeʵۡAyayLC\n" ,
			
	       	//CݭnƺPƶq
	       	"material":
	       	([
	       		"/obj/materials/water":10,
	       		"/obj/materials/wood":20,
	       		"/obj/materials/stone":10,
	       	]),
			
	       	//~ƶq]wP~|
	       	"harvest":
	       	([
	       		"/obj/fishfarm/product/big_crab":8,
	       	]),

		//ͦɪT
		"harvest_msg":"$MEwߦaXjhɡC\n",

		//شӦ~һݭnޯP䵥
		"skill":
		([
			"fishfarm":70,
		]),

		//ɪT
		"growing":
		([
			5:	"pɦb|B]Ӷ]hC\n",
			100:	"pɪⰦpg@b|PC\n",
			300:	"pɷUӷUjA{laDF_ӡC\n",
			500:	"ɪⰦgUӷUj]UӷUOC\n",
			800:	"ɦۨⰦ¶ªj]ARRaѤoYݡC\n",
			1200:	"κjhɤwgiH{פFC\n",
		]),
	
		// ѮvTԭz
		"weather":
		([
			SNOWY:	"jssYϱojhɭ̳򪺭ᦺC\n",
			SHOWER:	"sӪBqϱojhɭ̳QjRC\n",
			TYPHOON:"䭷ŧϱojhɭ̳QjRC\n",
			FOEHN:	"Ijŧjhɭ̦]ŹLӦC\n",
		]),
	]));
}
