/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : cattle_stud.c
 * Author : Clode@RevivalWorld
 * Date   : 2005-09-09
 * Note   : ؤ
 * Update :
 *  o 2000-00-00
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <inherit.h>
#include <nature.h>
#include <map.h>

inherit STANDARD_OBJECT;

void create()
{
        set_idname("cattle stud","ؤ");
        
        if( this_object()->set_shadow_ob() ) return;
        
        set("long", "ΨӥtͲدbC\n");
        set("unit", "");
        set("mass", 5000);
        set("value", 4000);
        set("badsell", 1);

	// ؤlT
	set("growth",
	([
		//
		"type":		PASTURE,

		//W
		"idname":	this_object()->query_idname(),
		
		//}lͲɪT
		"start_msg":"ؤs|BBMΪAROP®C\n" ,
			
	       	//CݭnƺPƶq
	       	"material":
	       	([
	       		"/obj/materials/water":10,
	       		"/obj/farming/product/herbage":15,
	       	]),
			
	       	//~ƶq]wP~|
	       	"harvest":
	       	([
	       		"/obj/pasture/product/beef":9,
	       	]),

		//ͦɪT
		"harvest_msg":"$MEwߦaO_èXsAסC\n",

		//شӦ~һݭnޯP䵥
		"skill":
		([
			"pasture":70,
		]),

		//ɪT
		"growing":
		([
			5:	"iJF@eNtAؤ}lۥtC\n",
			50:	"ؤ̫_LhͬAiH`N쳡欰ǤPC\n",
			150:	"{ljF_ӡAGOhFC\n",
			300:	"̤YUF\hdpAu̲Ӥߪ¶bpǨûQe̪C\n",
			600:	"pvAUUC\n",
			800:	"p̥djAiHi榬FC\n",
		]),
	
		// ѮvTԭz
		"weather":
		([
			SNOWY:	"jssYϱos̳򪺭ᦺC\n",
			SHOWER:	"sӪBqϱos̨DfC\n",
			TYPHOON:"䭷ŧϱos̳QjjӪY{C\n",
			FOEHN:	"Ijŧs̹LӦC\n",
		]),
	]));
}
