/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : chicken_stud.c
 * Author : Clode@RevivalWorld
 * Date   : 2005-09-09
 * Note   : 
 * Update :
 *  o 2000-00-00
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <inherit.h>
#include <nature.h>
#include <map.h>

inherit STANDARD_OBJECT;

void create()
{
        set_idname("chicken stud","");
        
        if( this_object()->set_shadow_ob() ) return;
        
        set("long", "ΨӥtͲدbC\n");
        set("unit", "");
        set("mass", 1000);
        set("value", 500);
        set("badsell", 1);

	// ؤlT
	set("growth",
	([
		//
		"type":		PASTURE,

		//W
		"idname":	this_object()->query_idname(),
		
		//}lͲɪT
		"start_msg":"s̩BBBasۡAUۦYۭe}ơC\n" ,
			
	       	//CݭnƺPƶq
	       	"material":
	       	([
	       		"/obj/materials/water":5,
	       		"/obj/farming/product/rice":5,
	       	]),
			
	       	//~ƶq]wP~|
	       	"harvest":
	       	([
	       		"/obj/pasture/product/egg":50,
	       		"/obj/pasture/product/chicken":20,
	       	]),

		//ͦɪT
		"harvest_msg":"$MEwߦaO_èXsAסC\n",

		//شӦ~һݭnޯP䵥
		"skill":
		([
			"pasture":0,
		]),

		//ɪT
		"growing":
		([
			5:	"iJF@eNtA}lۥtC\n",
			50:	"̫_LhͬAiH`N쳡欰ǤPC\n",
			100:	"ͤUFXJAö}l_JӡC\n",
			200:	"p̤@a}JӥXAup̤_asssAGﲴes@ɥRۦn_ߡC\n",
			300:	"pvAUUC\n",
			400:	"p̥djAiHi榬FC\n",
		]),
	
		// ѮvTԭz
		"weather":
		([
			SNOWY:	"jssYϱos̳򪺭ᦺC\n",
			SHOWER:	"sӪBqϱos̨DfC\n",
			TYPHOON:"䭷ŧϱos̳QjjӪY{C\n",
			FOEHN:	"Ijŧs̹LӦC\n",
		]),
	]));
}
