/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : QuestNPC.c
 * Author : 
 * Date   : 2005-01-05
 * Note   : 
 * Update :
 *  o 2000-00-00
 *
 -----------------------------------------
 */

/*
	tιw] NPC 禡
	void reply_emote(object me, string verb, string args);
	void reply_say(object me, string msg);
	void reply_catch_tell(object me, string verb, string args);
	void reply_get_object(object me, object ob, mixed amount);
	void reply_get_money(object me, string unit, mixed money);
*/

#include <ansi.h>
#include <inherit.h>
#include <gender.h>
#include <daemon.h>
#include <quest.h>

inherit STANDARD_NPC;

void do_command(string cmd);

void set_behavior()
{
	//set("behavior/walking", 120);

	set("behavior/random", 
	    ([
		(: do_command("sigh ̪񳣳Ө쳽ApGڨ⳨٦bܤ@w|o˪") :)   : 50,
		(: do_command("glare |ʤߤjN") :) : 50,
		(: do_command("why") :) : 50,
		(: do_command("inn") :) : 50,
		(: do_command("mutter ̪uI...") :) : 50,
	    ]));
}
void delete_behavior()
{
	delete("behavior");
}

void reply_say(object me, string msg)
{
	if( !objectp(me) || !msg ) return;

	if( strsrch(msg, "") != -1 && strsrch(msg, "") < 0 || strsrch(msg, "") != -1)
		do_command("say ڡHڥuOӤwաAڷQӧ䤣^ӤFաAڪ񤣨F");
		
	if( strsrch(msg, "") != -1 )
		do_command("say oڡA⳨qڶ}lǳN@ڨ{bA]O򯫩_ALNOFI}F..");

	if( strsrch(msg, "ʤߤjN") != -1 )
		do_command("say ӸܪڡAe}lڨs̥h˳AܤFIsNIIjΡAGӧڪNFAڹbnL...");
}

void reply_emote(object me, string verb, string args)
{
	if( objectp(me) ) {
		switch(verb) {
			case "hi":
				do_command("sigh " +me->query_id(1)+ " AnAƶ");
				break;
			case "?":
				do_command("eh " +me->query_id(1)+ " ݤڡA߱OܦnOӶç" );
				break;
			case "hmm":
				do_command("say FHƶ...");
				break;
			default:
				do_command("? " +me->query_id(1)+ " ڭ̡DDOܼaHQFH");
				break;
		}
	}
}

int target_gone(object me)
{
	if( same_environment(this_object(), me) )
		return 1;

	do_command("say áHIH]hFOAӬOӤD^jnH...unun...");

	if( objectp(me) )
		delete_temp("quest/"QUEST_BOHR"/running", me);

	set_behavior();
	return -1;
}

void reply_get_object(object me, object ob, mixed amount)
{
	if( !objectp(ob) ) return;

	if( me->query_quest_step(QUEST_BOHR) == 2 && query("behavior") && base_name(ob) == __DIR__"broken_rod"  )
	{
		destruct(ob);
		
		if( query_temp("quest/"QUEST_BOHR"/running", me) )
			return;

		set_temp("quest/"QUEST_BOHR"/running", 1, me);

		// Dʦ欰
		delete_behavior();

		process_function(({
			4,
			(: target_gone($(me)) :),
			(: do_command("wa") :),
			4,
			(: target_gone($(me)) :),
			(: do_command("roll") :),
			(: do_command("scream "+$(me)->query_id(1) ) :),
			4,
			(: target_gone($(me)) :),
			(: do_command("say oDDo⳨񤣴NOڪܡH"+pnoun(2, $(me))+"Sa٧ڪܡH") :),
			4,
			(: target_gone($(me)) :),
			(: do_command("sob "+$(me)->query_id(1)+" "+pnoun(2, $(me))+"uOӦnH") :),
			4,
			(: target_gone($(me)) :),
			(: do_command("say uOӷPEFAڸӫ"+pnoun(2, $(me))+"OC") :),
			(: do_command("ponder") :),
			6,
			(: target_gone($(me)) :),
			(: do_command("say o˦nFAڧڪ߱oOe"+pnoun(2, $(me))+"nFAMOj§Ao]OFڤQX~FC") :),
			2,
			(: target_gone($(me)) :),
			(: new(__DIR__"fishing_note")->move($(me)) :),
			(: msg("$MEoFOC\n", $(me), 0, 1) :),
			(: $(me)->add_title(HIW""NOR WHT"FH"NOR) :),
			(: delete_temp("quest/"QUEST_BOHR"/running", $(me)) :),
                        (: $(me)->set_quest_finish(QUEST_BOHR, QUEST_BOHR_NAME, pnoun(2, $(me))+"iFLAoF@ǼyC") :),
			(: !wizardp($(me)) && CHANNEL_D->channel_broadcast("city", $(me)->query_idname()+"Ѷ}Fu"QUEST_BOHR_NAME"v", $(me)) :),
			4,
			(: target_gone($(me)) :),
			(: msg("u$ME_˻spllۤWǹСAN}VVGA̫~M㰦x"HIY""NOR"C\n"NOR, this_object(), 0, 1) :),
			5,
			(: target_gone($(me)) :),
			(: msg("$ME"HIY""NOR YEL"p"NOR"D`ĪRۡC\n"NOR, this_object(), 0, 1) :),
			(: do_command("mutter oUlڤSiHA~򪺳F") :),
			(: do_command("thank "+$(me)->query_id(1) ) :),
			// _Dʦ欰
			(: set_behavior() :),
		    }));
		destruct(ob);
	}
	else
	{
		process_function(({
			1,
			do_command("say oOHڤnoӪF..."),
			1,
			do_command("drop all"),
		    }));
	}
}
void create()
{
	set_idname("bohr",HIG"i"NOR GRN""NOR);
	
	set("long", "@߷R~klAݥLTܭWyˤlGJ@ǧxC");
	set("unit", "");
	set("age", 48);
	set("gender", MALE_GENDER);

	// ҰʥDʦ欰
	set_behavior();

	startup_living();
}
                                                  
