/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : john_barton.c
 * Author : 
 * Date   : 2005-01-05
 * Note   : 
 * Update :
 *  o 2000-00-00
 *
 -----------------------------------------
 */

/*
	tιw] NPC 禡
	void reply_emote(object me, string verb, string args);
	void reply_say(object me, string msg);
	void reply_catch_tell(object me, string verb, string args);
	void reply_get_object(object me, object ob, mixed amount);
	void reply_get_money(object me, string unit, mixed money);
*/

#include <ansi.h>
#include <inherit.h>
#include <gender.h>
#include <daemon.h>
#include <quest.h>

inherit STANDARD_NPC;

void do_command(string cmd);

void set_behavior()
{
	//set("behavior/walking", 120);

	set("behavior/random", 
	    ([
		(: do_command("say AڰOooӦڡA|䤣O...") :)   : 50,
		(: do_command("sigh 䤣쪺ܦo@w|ܥ檺...") :) : 50,
	    ]));
}
void delete_behavior()
{
	delete("behavior");
}

void reply_say(object me, string msg)
{
	if( !objectp(me) || !msg ) return;

	if( strsrch(msg, "") != -1 || strsrch(msg, "") != -1)
		do_command("say ڷQeڥiRkB͡C");
		
	if( strsrch(msg, "") != -1 )
	{
		do_command("say ˪ڡAڤ]DAڷQjO}G@IaC");
		
		if( !me->query_quest_finish(QUEST_BOHR) && me->query_quest_step(QUEST_BOHR) == 0 )
		{
			me->set_quest_note(QUEST_BOHR, QUEST_BOHR_NAME, "JFjEڹyALGb@تC");
			me->set_quest_step(QUEST_BOHR, 1);
		}
	}
}

void reply_emote(object me, string verb, string args)
{
	if( objectp(me) ) {
		switch(verb) {
			case "hi":
				do_command(verb + " " +me->query_id(1)+ " " + "AnAаݦƶܡH");
				break;
			case "?":
				do_command("say AFΨزݧڡAڥuOӧF誺AiOڡC");
				break;
			default:
				do_command("sorry " +me->query_id(1)+ " pڥbAЧOZ");
				break;
		}
	}
}

int target_gone(object me)
{
	if( same_environment(this_object(), me) )
		return 1;

	do_command("say áHIH]hFOAӬOӤD^jnH...unun...");

	if( objectp(me) )
		delete_temp("quest/"QUEST_BOHR"/running", me);

	set_behavior();
	return -1;
}

void reply_get_object(object me, object ob, mixed amount)
{
	string obname;

	if( !objectp(ob) ) return;

	obname = ob->query_name();

	if( me->query_quest_step(QUEST_BOHR) == 1 && query("behavior") && (base_name(ob) == "/obj/farming/product/lily" || base_name(ob) == "/obj/farming/product/rose"))
	{
		destruct(ob);
	
		if( query_temp("quest/"QUEST_BOHR"/running", me) )			
			return;

		set_temp("quest/"QUEST_BOHR"/running", 1, me);

		// Dʦ欰
		delete_behavior();

		process_function(({
			2,
			(: target_gone($(me)) :),
			(: do_command("tsk Aune"+$(obname)+"ڡHoˤӦnNa") :),
			4,
			(: target_gone($(me)) :),
			(: do_command("say oӰeڤkBͦo@w|ܰAnaA"+pnoun(2, $(me))+"FC") :),
			(: do_command("thank "+$(me)->query_id(1) ) :),
			5,
			(: target_gone($(me)) :),
			(: do_command("ah") :),
			2,
			(: target_gone($(me)) :),
			(: do_command("say oӬOڭbWߨ쪺AڤF]SΡANeAa") :),
			5,
			(: target_gone($(me)) :),
			(: new(__DIR__"broken_rod")->move($(me)) :),
			(: msg("$MEoF@ª˻sC\n", $(me), 0, 1) :),
			(: do_command("say ڨFAuO§A") :),
			(: delete_temp("quest/"QUEST_BOHR"/running", $(me)) :),
			(: $(me)->set_quest_note(QUEST_BOHR, QUEST_BOHR_NAME, pnoun(2, $(me))+"jEڹyFALAF@ݰ_ª˻sC") :),
			(: $(me)->set_quest_step(QUEST_BOHR, 2) :),
			// _Dʦ欰
			(: set_behavior() :),
		    }));
	}
	else
	{
		process_function(({
			1,
			do_command("say oOHڤnoӪF..."),
			1,
			do_command("drop all"),
		    }));
	}
}
void create()
{
	set_idname("john barton",HIW"j"NOR WHT"Eڹy"NOR);

	set("unit", "");
	set("age", 19);
	set("gender", MALE_GENDER);
	set("long", "@Ӧ۰~TNC~AݥLˤlGbWoۡC");
	
	// ҰʥDʦ欰
	set_behavior();

	startup_living();
}
