/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : city_walker.c
 * Author : Clode@RevivalWorld
 * Date   : 2006-02-27
 * Note   : 
 * Update :
 *  o 2000-00-00
 *
 -----------------------------------------
 */

/*
	tιw] NPC 禡
	void reply_emote(object me, string verb, string args);
	void reply_say(object me, string msg);
	void reply_catch_tell(object me, string verb, string args);
	void reply_get_object(object me, object ob, mixed amount);
	void reply_get_money(object me, string unit, mixed money);
*/

#include <ansi.h>
#include <inherit.h>
#include <gender.h>
#include <daemon.h>
#include <quest.h>

inherit STANDARD_NPC;

void do_command(string cmd);

void set_behavior()
{
	set("behavior/random", 
	    ([
		(: do_command("sing") :)   : 50,
	    ]));
}

void delete_behavior()
{
	delete("behavior");
}

void reply_say(object me, string msg)
{
	object ob;

	if( !objectp(me) || !msg ) return;

	if( strsrch(msg, "") != -1 )
	{
		do_command("say OӤHjl...Ʊbڦͤ~̥iHCM@ɦUj...ݺɦUؤHͬ...C");
		return;
	}
		
	if( strsrch(msg, "C") != -1 )
	{
		do_command("say ...OAȹCOڳ̳w@ƤF...");
		do_command("say ٰOoQG~eJ@Mڤ@˫ܳwBȦ檺֤H...{bMhL@֩OC");
		
		return;
	}

	if( strsrch(msg, "") != -1 )
	{
		do_command("say L֬Oo˼g..."+@TEXT

wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww
 Cݨj½sADܱoRAaKyZڭ̱a
 PϰAߤAN|Ԥ@Ӥ_ڡG
 MAKɨ}ɪMsEEE
 HBձyEEEgTxJLߡEEEѵOHhjEEE
 饫euRAOayYvAڭ̻P@ɦPB߰ʡEEE
 ̭nALר̡AIl@H𮧡G
 @bhF誺ڷQB@b֦ۥI
wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww
	
TEXT
	);
		do_command("say hOH`誺@֪Io֪WrO...xAV|ڳMѤFo֪WrF...");
		
		return;
	}

	if( strsrch(msg, "Wr") != -1 )
	{
		do_command("sigh");
		do_command("say on@֧ڳMѤFWr...");
		
		if( query("total_online_time", me) < 24*60*60*30 )
			return tell(me, pnoun(2, me)+"Wuɶ 30 ѵLki榹ȡC\n");

		if( me->query_quest_step(QUEST_CITY_WALKER) == 0 )
		{
			if( me->query_quest_finish(QUEST_CITY_WALKER) && time() < me->query_quest_time(QUEST_CITY_WALKER) + 60*60*24)
				return tell(me, pnoun(2, me)+"b̪񪺤@Ѥ~oӤH͹LC\n");
			
			me->set_quest_note(QUEST_CITY_WALKER, QUEST_CITY_WALKER_NAME, "CHGLѰO֦W۷bNAγ\o@ɤWHDC");
			me->set_quest_step(QUEST_CITY_WALKER, 1);
		}
		
		return;
	}
	
	if( me->query_quest_step(QUEST_CITY_WALKER) == 3 && strsrch(msg, "@Ӥ_") != -1 )
	{			
		do_command("ah");
		do_command("say IINOoӦWrA...pAA{b@wbӫ̼g֧a...");
		do_command("say ڷQ"+pnoun(2, me)+"]OqjӪaIڳo̦ӪF"+pnoun(2, me)+"ӻӫܹΡAN"+pnoun(2, me)+"aC");
		
		ob = new("/quest/city_walker/land_essence");

		msg("$YOUN"+ob->query_idname()+"浹$MEC\n", me, this_object(), 1);
		
		ob->set_keep();
		ob->move(me);

		me->set_quest_finish(QUEST_CITY_WALKER, QUEST_CITY_WALKER_NAME, "CHF֦WAoF@Ǽy~C");
		CHANNEL_D->channel_broadcast("city", me->query_idname()+" Ѷ}Fu"+QUEST_CITY_WALKER_NAME+"v", me);
		return;
	}
}

void reply_emote(object me, string verb, string args)
{

}

int target_gone(object me)
{

}

void reply_get_object(object me, object ob, mixed amount)
{

}

void create()
{
	set_idname("city walker",NOR CYN"CH"NOR);

	set("unit", "");
	set("age", 32);
	set("gender", MALE_GENDER);
	set("long", "@ӥ|BȦ檺CHC");
	
	// ҰʥDʦ欰
	set_behavior();

	startup_living();
}
