/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : grandam.c
 * Author : Clode@RevivalWorld
 * Date   : 2005-12-13
 * Note   : 
 * Update :
 *  o 2000-00-00
 *
 -----------------------------------------
 */

/*
	tιw] NPC 禡
	void reply_emote(object me, string verb, string args);
	void reply_say(object me, string msg);
	void reply_catch_tell(object me, string verb, string args);
	void reply_get_object(object me, object ob, mixed amount);
	void reply_get_money(object me, string unit, mixed money);
*/

#include <ansi.h>
#include <inherit.h>
#include <gender.h>
#include <daemon.h>
#include <quest.h>

inherit STANDARD_NPC;

void do_command(string cmd);

void set_behavior()
{
	set("behavior/random", 
	    ([
			(: do_command("sweat") :)   : 50,
	    ]));
}


void delete_behavior()
{
	delete("behavior");
}

void reply_say(object me, string msg)
{
	if( !objectp(me) ) return;

	if( !msg || !msg[0] )
		do_command("say H"+pnoun(2, me)+"ťM");
	
	else if( strsrch(msg, "_") != -1 )
		do_command("say O֧rHڤ{ѭC");
		
	else if( strsrch(msg, "Z") != -1 )
		do_command("say iĤlAZLNbs}UAuLO²몺AҡAMbaQH`");
		
	else if( strsrch(msg, "¦") != -1 )
	{
		do_command("sigh ¦Ъ...");
		do_command("say ̪l̾xommAjaO¦бFZKkhLܡAڪD¦Цo|oبƪ");
		do_command("say ڬOݵۦojAoOo򵽸ѤHNi|ب...");
	}
	else if( strsrch(msg, "H") != -1 )
		do_command("say @H"+pnoun(2, me)+"OsHѶܡHO¦Цb@Bäs}o{AHѦGèSSOA¦ШɭԬݨ]NHF^");
	else if( strsrch(msg, "s}") != -1 )
		do_command("say ڤ]MӤs}b̡AڥuDO¦Ыe@}l`sMvZħɧ쪺");
	else if( strsrch(msg, "ħ") != -1 )
		do_command("say ħNOڪMFAznn]ӸոժAڳo̥iֺħA]zĨfAz");
	else if( strsrch(msg, "") != -1 )
	{
		do_command("say ӨӨӡAoīOұj");
		msg("$MEQ$YOUjF@DįA$MEuı@}YwدtC\n", me, this_object(), 1);
		me->faint();
		do_command("say xHݨӳoĤjAڴN...~HnnNnæY");
	}
	else if( strsrch(msg, "v") != -1 )
	{
		do_command("say Zfܩ_ǡAڤ]ghݹLLXA]Lq_wLf]");
		do_command("say γ\...Фa@RPkkvonLAL{boǳӿF");
	}
	else if( strsrch(msg, "s") != -1 )
		do_command("say oӦ~Y٦sܡHڤwgn[SݨF");
	else if( strsrch(msg, "An") != -1 )
		do_command("say AnO¦¸ZΪAouO");
	else if( strsrch(msg, "Pk") != -1 )
	{
		do_command("say obӺ}GFANSOAҥH`O٦oPkAPk`OƩwAڤ]oob");
		
		if( me->query_quest_finish(QUEST_YIN_LING_YU) && me->query_quest_step(QUEST_YIN_LING_YU_2) == 0)
		{
			me->set_quest_note(QUEST_YIN_LING_YU_2, HIC"¦"NOR CYN""NOR, "JFĦѤӱCADFФaPksbC");
			me->set_quest_step(QUEST_YIN_LING_YU_2, 1);
		}
	}
	else
		do_command("say H"+pnoun(2, me)+"ťM");
}

void reply_emote(object me, string verb, string args)
{
	if( !objectp(me) ) return;
}

void reply_get_object(object me, object ob, mixed amount)
{
	if( !objectp(ob) ) return;

	process_function(({
		1,
		do_command("say oOHڤnoӪF..."),
		1,
		do_command("drop all "+ob->query_id(1)),
	}));
}


void create()
{
	set_idname("grandam", "ѤӱC");
	set_temp("status", HIY""NOR YEL""NOR);

	set("long", "@bsåHĬͪѤӱCAγ\oD@ǨƱAյ۰ݰݬ(say)oaC");
	set("unit", "");
	set("age", 62);
	set("gender", FEMALE_GENDER);

	// ҰʥDʦ欰
	set_behavior();

	startup_living();
}
