/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : grandam.c
 * Author : Clode@RevivalWorld
 * Date   : 2005-12-13
 * Note   : 
 * Update :
 *  o 2000-00-00
 *
 -----------------------------------------
 */

/*
	tιw] NPC 禡
	void reply_emote(object me, string verb, string args);
	void reply_say(object me, string msg);
	void reply_catch_tell(object me, string verb, string args);
	void reply_get_object(object me, object ob, mixed amount);
	void reply_get_money(object me, string unit, mixed money);
*/

#include <ansi.h>
#include <inherit.h>
#include <gender.h>
#include <daemon.h>
#include <quest.h>

inherit STANDARD_NPC;

void do_command(string cmd);

void set_behavior()
{
	set("behavior/random", 
	    ([
			(: do_command("sing") :)   : 50,
	    ]));
}

void delete_behavior()
{
	delete("behavior");
}

void reply_say(object me, string msg)
{
	if( !objectp(me) ) return;

	if( !msg || !msg[0] )
		return;
		
	if( strsrch(msg, "_") != -1 )
	{
		do_command("say ڤDLO֡AڥiHqoӦWrP@ѤHjR");
		return;
	}
	
	if( strsrch(msg, "Z") != -1 )
	{
		do_command("say ڤDLO֡AڪDLwgDJAHʹNOpAñzҾ֦@a...");
		return;
	}
	
	if( strsrch(msg, "¦") != -1 )
	{
		do_command("say ...¦ЪAo¾ܰQHwA~eڴJLoAȺ޷ɧڤww骺GAڤԤߧiDooӥwoͪd@");
		return;
	}
	
	if( strsrch(msg, "H") != -1 )
	{
		do_command("say ¦ЩҫX賥sHѪSäb󥦪ĩʡAӬObĭ|FƤd~ҲͪF");
		return;
	}
	
	if( strsrch(msg, "F") != -1 )
	{
		do_command("smile "+me->query_id(1));
		do_command("say "+pnoun(2, me)+"|JW¦СAKOtHAWѦ۷|"+pnoun(2, me)+"");
		
		if( me->query_quest_step(QUEST_YIN_LING_YU_2) == 1 )
		{
			me->set_quest_note(QUEST_YIN_LING_YU_2, QUEST_YIN_LING_YU_2_NAME, "FPkypC̡zADFӳo賥sHѨ㦳ۯFʡC");
			me->set_quest_step(QUEST_YIN_LING_YU_2, 2);
		}
		return;
	}
	
	if( strsrch(msg, "") != -1 )
	{
		do_command("say ѹa|ôaH.....");
		return;
	}
		
	if( me->query_quest_step(QUEST_CITY_WALKER) == 1 && strsrch(msg, "CH") != -1 )
	{
		do_command("say H"+pnoun(2, me)+"QD@LƱܡH");
		me->set_quest_note(QUEST_CITY_WALKER, QUEST_CITY_WALKER_NAME, "γ\ŪqֵpCťťC");
		me->set_quest_step(QUEST_CITY_WALKER, 2);
		return;
	}
	
	if( me->query_quest_step(QUEST_CITY_WALKER) == 2 && strsrch(msg, "@b֦ۥ") != -1 )
	{
		msg("$ME`N$YOUFάMŸʤF@UAHYS^_쥻ˤl...C\n", me, this_object(), 1);
		do_command("say ...Ӧp");
		do_command("say o֥s@u@Ӥ_ڡvA"+pnoun(2, me)+"OۧaC");
		
		me->set_quest_note(QUEST_CITY_WALKER, QUEST_CITY_WALKER_NAME, "ӳo֥s@u@Ӥ_ڡvC");
		me->set_quest_step(QUEST_CITY_WALKER, 3);
		return;
	}
}

void reply_emote(object me, string verb, string args)
{
	if( !objectp(me) ) return;
	
	do_command("bow "+me->query_id(1));
}

void reply_get_object(object me, object ob, mixed amount)
{
	if( !objectp(ob) ) return;

	process_function(({
		1,
		do_command("say ѹa|ôaH..."),
		1,
		do_command("drop all "+ob->query_id(1)),
	}));
}


void create()
{
	set_idname("mu qing yi", HIG"p"NOR GRN"C"NOR);
	set_temp("status", HIG"@~"NOR GRN"Pk"NOR);

	set("long", "nMq~klAo護ϤHۦoAboǤѱoۺF©C");
	set("unit", "");
	set("age", 24);
	set("gender", FEMALE_GENDER);

	// ҰʥDʦ欰
	set_behavior();

	startup_living();
}
