/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : yin_ling_yu.c
 * Author : Clode@RevivalWorld
 * Date   : 2005-12-13
 * Note   : 
 * Update :
 *  o 2000-00-00
 *
 -----------------------------------------
 */

/*
	tιw] NPC 禡
	void reply_emote(object me, string verb, string args);
	void reply_say(object me, string msg);
	void reply_catch_tell(object me, string verb, string args);
	void reply_get_object(object me, object ob, mixed amount);
	void reply_get_money(object me, string unit, mixed money);
*/

#include <ansi.h>
#include <inherit.h>
#include <gender.h>
#include <daemon.h>
#include <quest.h>

inherit STANDARD_NPC;

void do_command(string cmd);

void set_behavior()
{
	set("behavior/random", 
	    ([
		(: do_command("inn |o...") :)   : 50,
		(: do_command("cold") :) : 50,
	    ]));
}


void delete_behavior()
{
	delete("behavior");
}

void reply_say(object me, string msg)
{
	if( !objectp(me) ) return;
	
	if( !msg || !msg[0] )
		do_command("say "+pnoun(2, me)+"H");
	
	else if( me->query_quest_step(QUEST_YIN_LING_YU_2) == 2 && strsrch(msg, "H") != -1 )
	{
		do_command("say "+pnoun(2, me)+"Oڵ"+pnoun(2, me)+"HѶܡHOڦbL˪L誺@BKs}o{");
		do_command("shiver");
		do_command("say pG...pGOFZAڮڥSiiJiȪs}......Z");
		
		me->set_quest_step(QUEST_YIN_LING_YU_2, 3);
		me->set_quest_note(QUEST_YIN_LING_YU_2, QUEST_YIN_LING_YU_2_NAME, "¦ЦV"+pnoun(2, me)+"_HѪӾObL˪L誺@Ks}C");
	}
	else if( strsrch(msg, "_") != -1 )
		do_command("sob "+me->query_id(1)+" II_INOLA֥hϥLILbj......֪I");
	else if( strsrch(msg, "Z") != -1 )
		do_command("sob "+me->query_id(1)+" ZLwgF......ө_L......Oڪ...");
	else if( strsrch(msg, "H") != -1 )
		do_command("say HѡH"+pnoun(2, me)+"⳥sHѶܡHiH@@ܡH");
	else
		do_command("say "+pnoun(2, me)+"H");
}

void reply_emote(object me, string verb, string args)
{
	if( !objectp(me) ) return;
	
	//do_command(verb + " " + me->query_id(1) + " " + (args||""));
}

int target_gone(object me)
{
	if( same_environment(this_object(), me) )
		return 1;
	
	do_command("say HOHo@ɤWSHnzڤF...");
	
	if( objectp(me) )
	{
		tell(me, this_object()->query_idname()+"bI۵ۡGHOHo@ɤWSHnzڤF...\n");
		delete_temp("quest/"QUEST_YIN_LING_YU"/running", me);
	}
	
	set_behavior();
	return -1;
}

void reply_get_object(object me, object ob, mixed amount)
{
	if( !objectp(ob) ) return;
	
	if( me->query_quest_step(QUEST_YIN_LING_YU)==3 && query("behavior") && base_name(ob) == "/quest/yin_ling_yu/wild_ginseng" )
	{
		destruct(ob);
		
		if( query_temp("quest/"QUEST_YIN_LING_YU"/running", me) )
			return;
		
		set_temp("quest/"QUEST_YIN_LING_YU"/running", 1, me);
		
		// Dʦ欰
		delete_behavior();
		
		process_function(({
			2,
			(: target_gone($(me)) :),
			(: msg("$MEbbaݵ۳sHxA$YOUiDo_wg`TC\n", this_object(), $(me), 1) :),
			6,
			(: target_gone($(me)) :),
			(: msg("$ME}lza_@qGơC\n\n", this_object(), $(me), 1) :),
			4,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"gӥZAҡAWs"HIW"}Z"NOR"\n", this_object(), $(me), 1) :),
			8,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"jۯ¦ФTLO¦ЪF~AqpHNO"HIM"C"NOR MAG"˰"NOR"\n", this_object(), $(me), 1) :),
			8,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"b¦ФQɭԡA¦ЫKMaHhsWL"HIG""NOR GRN"A"NOR"ͬ\n", this_object(), $(me), 1) :),
			8,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"¦ЪD}Z餣nAoۦpʭu@AKɱ`s}UUL\n", this_object(), $(me), 1) :),
			8,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"No˹LFnX~\n", this_object(), $(me), 1) :),
			4,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"¦ФGQGFA"HIY"FF"NOR YEL"ɥ"NOR"o̵M``UsU}Z\n", this_object(), $(me), 1) :),
			8,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"ƱNoͦbeX\n", this_object(), $(me), 1) :),
			4,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"}ZMۯ¦"HIW"jq"NOR"GpbܷСAnAӤFnn\n", this_object(), $(me), 1) :),
			6,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"ۻۨ}ZLyµۡALWGۤ@"HIR"A"NOR RED""NOR"A¦ШSݨ\n", this_object(), $(me), 1) :),
			8,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"¦ЫD`ˤߦa^s\n", this_object(), $(me), 1) :),
			4,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"D}ZAwoF\n", this_object(), $(me), 1) :),
			5,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"oɦbsW\n", this_object(), $(me), 1) :),
			4,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"JFbsϿWۭC"HIW"_"NOR"\n", this_object(), $(me), 1) :),
			4,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"_OӦbca"HIG"TN"NOR GRN"C~"NOR"\n", this_object(), $(me), 1) :),
			5,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"MO즸\n", this_object(), $(me), 1) :),
			4,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"_娣FL¦\n", this_object(), $(me), 1) :),
			6,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"̵Mjawۯ¦\n", this_object(), $(me), 1) :),
			6,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"¦Ф]D_媺߫\n", this_object(), $(me), 1) :),
			6,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"WK_FowgkBͪ\n", this_object(), $(me), 1) :),
			6,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"_寺IFIY\n", this_object(), $(me), 1) :),
			6,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"Ѧ"WHT"w"NOR"\n", this_object(), $(me), 1) :),
			3,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"_bUseݤF¦ЦSݭna\n", this_object(), $(me), 1) :),
			7,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"¦зQFQ\n", this_object(), $(me), 1) :),
			4,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"KUF_嶶Doe@"HIY"s"NOR YEL"H"NOR"s}U}Za\n", this_object(), $(me), 1) :),
			8,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"_ˤIFIYAۤ@"HIY"s"NOR YEL"H"NOR"}F\n", this_object(), $(me), 1) :),
			6,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"¦Ф߱]nF\hAK^a\n", this_object(), $(me), 1) :),
			6,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"j@\n", this_object(), $(me), 1) :),
			3,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"¦ФSߦaUsh}ZAƱMLMnp\n", this_object(), $(me), 1) :),
			8,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"Z@}Za\n", this_object(), $(me), 1) :),
			3,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"o}Z"HIR""NOR RED"f"NOR"ۧMAwM\n", this_object(), $(me), 1) :),
			4,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"o@¦бYFAoAѬ|oͳoبơAOֿѱFLIH\n", this_object(), $(me), 1) :),
			10,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"¦зQۡABX@ӤHy\n", this_object(), $(me), 1) :),
			4,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"_ILMO"HIY""NOR YEL"H"NOR"I\n", this_object(), $(me), 1) :),
			8,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"¦Ф@^b}Z骺ǡAOo`FL\n", this_object(), $(me), 1) :),
			8,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"oۡA"HIM""NOR MAG""NOR"o_Ml\n", this_object(), $(me), 1) :),
			6,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"۪f"HIR""NOR RED""NOR"չϴM_媺U\n", this_object(), $(me), 1) :),
			8,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"¶FnXs\n", this_object(), $(me), 1) :),
			4,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"MeX{@ӨklAæb@"HIW"j"NOR WHT""NOR"\n", this_object(), $(me), 1) :),
			6,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"OQѨө_\n", this_object(), $(me), 1) :),
			4,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"FA媺_\n", this_object(), $(me), 1) :),
			4,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"NOLF}ZI\n", this_object(), $(me), 1) :),
			4,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"¦"WHT"Ÿ"NOR"ۡAo@ya_娭\n", this_object(), $(me), 1) :),
			8,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"rMM_娭Wh\n", this_object(), $(me), 1) :),
			4,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"MlNoˤ@nTaiF_媺\n", this_object(), $(me), 1) :),
			4,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"_hWajsA"HIY""NOR YEL""NOR"a^YݤF\n", this_object(), $(me), 1) :),
			4,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"MOoAoO...\n", this_object(), $(me), 1) :),
			10,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"Mjt@ݥX{@s"HIW"s"NOR WHT""NOR"j۵ۡGbIӤHbIlII\n", this_object(), $(me), 1) :),
			5,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"_N¦ЪlĤO@\n", this_object(), $(me), 1) :),
			5,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"ϤޥXI᪺MlA"HIR"A"NOR RED""NOR"QӥXAqo¦кA\n", this_object(), $(me), 1) :),
			5,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"_ۯ¦мnjۡG"HIY"]Iֶ]I"NOR"\n", this_object(), $(me), 1) :),
			4,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"۫KۤMls騺ĥh...\n", this_object(), $(me), 1) :),
			4,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"¦~aFAoDO@^ơA|oˡAeu_agXۤMlbMs̥\n", this_object(), $(me), 1) :),
			10,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"_廷ǨӼRnG"HIY"ֶ]IIֶ]II"NOR"\n", this_object(), $(me), 1) :),
			5,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"¦гQ~oਭN]A]LF"HIG""NOR GRN""NOR"A]LF"HIB"s"NOR BLU""NOR"A\qSL\n", this_object(), $(me), 1) :),
			5,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"ש"WHT"ɤO"NOR"A˦baW\n", this_object(), $(me), 1) :),
			12,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"]LFh[\n", this_object(), $(me), 1) :),
			4,
			(: target_gone($(me)) :),
			(: msg(HIY"G"NOR YEL" - "NOR"ӫKF$YOU...\n\n", this_object(), $(me), 1) :),
			4,
			(: target_gone($(me)) :),
			(: msg("$ME__aoqGơA_yX\Rۮ\n", this_object(), $(me), 1) :),
			6,
			(: target_gone($(me)) :),
			(: msg("$ME⤤sHx浹F$YOU\n", this_object(), $(me), 1) :),
			2,
			(: target_gone($(me)) :),
			(: do_command("say o⳥sHxڤwgSΤFANF"+pnoun(2, $(me))+"a ") :),
			(: new("/quest/yin_ling_yu/tear_wild_ginseng")->move($(me)) :),
			(: $(me)->set_quest_finish(QUEST_YIN_LING_YU, QUEST_YIN_LING_YU_NAME, "JFy¦СzAoF_A_wgFC") :),
			(: delete_temp("quest/"QUEST_YIN_LING_YU"/running", $(me)) :),
			(: !wizardp($(me)) && CHANNEL_D->channel_broadcast("city", $(me)->query_idname()+" Ѷ}Fu"+QUEST_YIN_LING_YU_NAME+"v", $(me)) :),
			6,
			(: target_gone($(me)) :),
			(: msg("$YOUݵۤW⳥sHxW۲\A$YOUQoqdGGƾ_٤FA[[o@yC\n", this_object(), $(me), 1) :),
			
			6,
			(: target_gone($(me)) :),
			(: msg("^Y@ݥu¦ЧbbaݵۻA$YOUıoNoR@Rn...C\n", this_object(), $(me), 1) :),
			// _Dʦ欰
			(: set_behavior() :),
		    }));
	}
	else
	{
		process_function(({
			1,
			do_command("say oOHڤnoӪF..."),
			1,
			do_command("drop all "+ob->query_id(1)),
		    }));
	}
}


void create()
{
	set_idname("yin ling yu",HIC""NOR CYN"¦"NOR);
	set_temp("status", HIC""NOR CYN""NOR);
	
	set("long", "@Ӷˤ߱klADopˤߡC");
	set("unit", "");
	set("age", 22);
	set("gender", FEMALE_GENDER);
	
	// ҰʥDʦ欰
	set_behavior();
	
	startup_living();
}
