/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : recycle.c
 * Author : Clode@RevivalWorld
 * Date   : 2003-05-03
 * Note   : U^ʧ@
 * Update :
 *  o 2000-00-00  
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <map.h>
#include <feature.h>
#include <message.h>
#include <daemon.h>

inherit ROOM_ACTION_MOD;

#define RECYCLE_MONEY	10

void do_recycle(object me, string arg)
{
	//mixed value;
	//string money = "0", moneyunit;
	string msg="", amount;
	object ob, env = environment(me);

	if( !arg )
		return tell(me, "ثe^`ơG"+NUMBER_D->number_symbol(query("numbers", env))+" ӡC\n", CMDMSG);

	if( sscanf(arg, "%s %s", amount, arg) == 2 )
	{
		if( amount == "all" ) ;
		// pG amount äOƦr
		else if( !big_number_check(amount) )
		{
			arg = amount + " " + arg;
			amount = "1";	
		}	
		else if( count(amount, "<", 1) ) amount = "1";
	}
	else amount = "1";
	
	//moneyunit = MONEY_D->city_to_money_unit(env->query_city());
	
	if( objectp(ob = present(arg, me)) )
	{
		if( amount != "all" && count(amount, ">", query_temp("amount", ob)||1) ) 
			return tell(me, pnoun(2, me)+"Wu "+(query_temp("amount",ob)||1)+" "+(query("unit",ob)||"")+ob->query_idname()+"C\n", CMDMSG);
		
		if( ob->is_keeping() )
			return tell(me, pnoun(2, me)+"Ѱ"+ob->query_idname()+"Od(keep)AC\n");

		if( amount == "all" )
			amount = (query_temp("amount", ob)||"1")+"";
		
		// ]׮tLj|yRQ, Ȯ mark
		//value = query("value", ob);
		//if( count(value, ">", RECYCLE_MONEY) || count(value, "<=", 0) )
		//	money = count(amount, "*", RECYCLE_MONEY);
		//else
		//	money = count(amount, "*", count(value, "/", 2));
		
		//me->earn_money(moneyunit, money);

		set("numbers", count(query("numbers", env), "+", amount), env);
		msg("$ME"+QUANTITY_D->obj(ob, amount)+"i귽^Aثe^`ơG"+NUMBER_D->number_symbol(query("numbers", env))+" ӡC\n", me, 0, 1);
		
		destruct(ob, amount);
		return;
	}
	
	if( lower_case(arg) == "all" )
	{
		object *all_ob = all_inventory(me);
		
		if( sizeof(all_ob) )
		{
			foreach(ob in all_ob)
			{
				amount = query_temp("amount",ob)||"1";
				
				if( ob->is_keeping() || (count(query("value", ob),">",0) && query_temp("endurance", ob)>=0) ) continue;
			
				msg += HIG"D"NOR+QUANTITY_D->obj(ob, amount, 1)+"\n";
				
				//value = query("value", ob);

				//if( count(value, ">", RECYCLE_MONEY) || count(value, "<=", 0) )
				//	money = count(money, "+", count(amount, "*", RECYCLE_MONEY));
				//else
				//	money = count(money, "+", count(amount, "*", count(value, "/", 2)));
				
				set("numbers", count(query("numbers", env), "+", amount), env);
				destruct(ob);
			}

			//me->earn_money(moneyunit, money);

			return msg("$ME⨭W^Fi귽^FCثe^`ơG"+NUMBER_D->number_symbol(query("numbers", env))+" ӡC\n"NOR, me, 0, 1);
		}
		return tell(me, pnoun(2, me)+"WSFiH^I\n", CMDMSG);
	}
	
	return tell(me, pnoun(2, me)+"WS "+arg+" o󪫫~C\n", CMDMSG);
}
	

// ]wؿvжA
nosave mapping action_info =
([
	"recycle"	:
	([
		"short"	: NOR GRN"^"NOR,
		"help"	:
			([
"topics":
@HELP
    ^ߥiH^Ҧ󤣨Ȫ~APɬFyOAC^@󪫫~io 10 C
HELP,

"recycle":
@HELP
^귽OAΪkpUG
  recycle		- ܥثew^`
  recycle all		- ^WҦȪ~
  recycle garbage	- ^ 1  garbage ~
  recycle 3 garbage	- ^ 3  garbage ~
HELP,

			]),
		"action":
			([
				"recycle"	: (: do_recycle :),
			]),
	]),
]);


// ]wؿv
nosave array building_info = ({
	
	// ؿvW
	HIG"U^"NOR

	// }iؿv̤֩ж
	,1

	// ̤jۦPؿvƶq(0 N)
	,0

	// ؿvؿv, GOVERNMENT(F), ENTERPRISE(~), INDIVIDUAL(pH)
	,GOVERNMENT

	// ؿviؿvϰ, AGRICULTURE_REGION(A~), INDUSTRY_REGION(u~), COMMERCE_REGION(ӷ~)
	,AGRICULTURE_REGION | INDUSTRY_REGION | COMMERCE_REGION

	// }iO
	,"5000000"

	// ؿvռаO
	,0

	// ca^m
	,30
	
	// ̰i[\Ӽh
	,1
	
	// ̤jۦPؿvƶq(0 N)
	,0
	
	// ؿvɥN
	,1
});
