/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : warehouse.c
 * Author : Clode@RevivalWorld
 * Date   : 2002-05-26
 * Note   : Ҳ - ܮw
 * Update :
 *  o 2000-00-00  
 *
 -----------------------------------------
 */

#include <npc.h>
#include <ansi.h>
#include <map.h>
#include <feature.h>
#include <daemon.h>
#include <message.h>

inherit ROOM_ACTION_MOD;

inherit __DIR__"inherit/_object_database_mod.c";
inherit __DIR__"inherit/_action_list";
inherit __DIR__"inherit/_action_import";
inherit __DIR__"inherit/_action_export";
inherit __DIR__"inherit/_action_transport";
inherit __DIR__"inherit/_action_setup";
inherit __DIR__"inherit/_action_auction";

#define WAREHOUSE_CAPACITY	-1

// ]wؿvжA
nosave mapping action_info =
([
	"warehouse"	:
	([
		"short"	: HIR"xîw"NOR,
		"help"	: 
			([ 
"topics":
@HELP
    ܮwOaxê~aC
HELP,

"import":
@HELP
Nӫ~W[OAΪkpUG[޲zO]
  import all		- NҦW~sJܮw
  import all rice	- NҦ rice ~sJܮw
  import 3 rice		- N 3  rice ~sJܮw
  import rice		- N 1  rice ~sJܮw
HELP,

"export":
@HELP
Nӫ~U[OAΪkpUG[޲zO]
  export all		- NҦ~qܮwX
  export all rice	- NҦ rice ~qܮwX
  export 3 rice		- N 3  rice ~qܮwX
  export rice		- N 1  rice ~qܮwX
HELP,

"transport":
@HELP
B骫~OAΪkpUG
  transport rice to 1 51,22	- N 1  rice ~Bܲ 1 ìPy(51,22)Bؿv
  transport 3 rice to 2 51,22	- N 3  rice ~Bܲ 2 ìPy(51,22)Bؿv
  transport 2 3 to 1 51,22	- N 2 s 3 ~B  1 ìPy(51,22)Bؿv
HELP,

"setup":
@HELP
]wܮw\઺OAΪkpUG[޲zO]
  setup class 2 ~ 		- Ns 2 ~쭹~[lWAiۭq
HELP,

"auction":
@HELP
檫~OAΪkpUG

auction '~s' 'ƶq' $'' $'ʶR' 'ɶ'

Ҧp:
	
auction 1 500 $20000 $1000000 5		- s 1 ~ 500 ӡAл $20000A
					  ʶR $1000000Aɶ 5 p

ȳ@߬ $RW

HELP,

			]),
		"master":1,
		"action":
			([
				"import"	: (: do_import($1, $2, "products", WAREHOUSE_CAPACITY) :),
				"export"	: (: do_export($1, $2, "products") :),
				"list"		: (: do_warehouse_list($1, $2, "products", WAREHOUSE_CAPACITY) :),
				"transport"	: (: do_transport($1, $2, "products") :),
				"setup"		: (: do_warehouse_setup($1, $2) :),
				"auction"	: (: do_auction($1, $2, "products") :),
			]),
	]),

]);

// ]wؿv
nosave array building_info = ({
	
	// ؿvW
	HIR"ܮw"NOR

	// }iؿv̤֩ж
	,1

	// ̤jۦPؿvƶq(0 N)
	,0

	// ؿvؿv, GOVERNMENT(F), ENTERPRISE(~), INDIVIDUAL(pH)
	,INDIVIDUAL

	// ؿviؿvϰ, AGRICULTURE_REGION(A~), INDUSTRY_REGION(u~), COMMERCE_REGION(ӷ~)
	,INDUSTRY_REGION

	// }iO
	,"2000000"
	
	// ؿvռаO
	,0

	// ca^m
	,2
	
	// ̰i[\Ӽh
	,1
	
	// ̤jۦPؿvƶq(0 N)
	,5
	
	// ؿvɥN
	,1
});

