/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : adventure_d.c
 * Author : Clode@RevivalWorld
 * Date   : 2006-03-22
 * Note   : It
 * Update :
 *  o 2000-00-00  
 *
 -----------------------------------------
 */

#include <daemon.h>
#include <message.h>

#define DATA		"/data/daemon/adventure.o"
#define NPC_TYPE	({ "leader", "prospector", "explorer", "guard", "scout" })
mapping adventure;


int save()
{
	save_object(DATA);
}

//
// O_bi汴I
//
int is_doing_adventure(mixed env)
{
	if( stringp(env) )
		return !undefinedp(adventure[env]);
	else if( objectp(env) )
		return !undefinedp(adventure[base_name(env)]);
	else
		return 0;
}

//
// |ݭnɶ
//
int time_still(object env)
{
	return adventure[base_name(env)]["time"];
}

//
// }lI
//
void start_adventure(object env, mapping data)
{
	adventure[base_name(env)] = data;
}

//
// ߸禡
//
void heart_beat()
{
	object env;
	object ob;
	string npctype;
	string filename, filename2;
	mapping data, data2;
	
	// XҦ NPC , ˬd
	foreach(filename, data in adventure)
	{
		foreach(npctype in NPC_TYPE)
		{
			if( data[npctype] && file_exists(data[npctype]) )
				adventure[filename][npctype+"_ob"] = load_object(data[npctype]);
			else
				map_delete(adventure[filename], npctype+"_ob");
		}
		
		// IaF -> I
		if( !file_exist(filename) )
		{
			foreach(npctype in NPC_TYPE)
			{
				if( !objectp(ob = adventure[filename][npctype+"_ob"]) ) continue;
				delete("adventure", ob);
				ob->save();
			}

			map_delete(adventure, filename);
		}
	}
	
	// i汴I
	foreach(filename, data in adventure)
	{
		adventure[filename]["time"]--;

		// I
		if( adventure[filename]["time"] <= 0 )
		{
			env = load_object(filename);
			
			foreach(npctype in NPC_TYPE)
			{
				if( !objectp(ob = adventure[filename][npctype+"_ob"]) ) continue;

				delete("adventure", ob);
				ob->move(env);
				ob->save();
				msg("$MEFbu"+AREA_D->query_area_idname(data["area"], data["num"])+"vIʡAhΦa^즹aC\n", ob, 0, 1);
			}
			
			map_delete(adventure, filename);
			continue;
		}

		foreach(filename2, data2 in adventure)
		{
			// Pϰ줣i԰
			if( data["area"] != data2["area"] || data["num"] != data2["num"] || filename == filename2 ) continue;

			// dLOUUקK԰
			if( data["scout_ob"] && random(data["scout_ob"]->query_agi()) > 5 ) continue;
			
			// Ҧ@, i԰
			if( data["guard_ob"] && data2["guard_ob"] )
			{
				if( random(data["guard_ob"]->query_phy()) > random(data2["guard_ob"]->query_phy()) )
					CHANNEL_D->channel_broadcast("nch", "ǨӦbu"+AREA_D->query_area_idname(data["area"], data["num"])+"vA"+capitalize(data["boss"])+" P "+capitalize(data2["boss"])+" 䱴IoYĬC\n");				
				
				map_delete(adventure, filename);
			}
			// Yuڤ観@
			else if( data["guard_ob"] )
			{
				if( random(data["guard_ob"]->query_phy()) > 5 )
					CHANNEL_D->channel_broadcast("nch", "ǨӦbu"+AREA_D->query_area_idname(data["area"], data["num"])+"vA"+capitalize(data["boss"])+" P "+capitalize(data2["boss"])+" 䱴IoYĬC\n");	
			}
			// Yu観@
			else if( data2["guard_ob"] )
			{
				if( random(data2["guard_ob"]->query_phy()) > 5 )
					CHANNEL_D->channel_broadcast("nch", "ǨӦbu"+AREA_D->query_area_idname(data["area"], data["num"])+"vA"+capitalize(data["boss"])+" P "+capitalize(data2["boss"])+" 䱴IoYĬC\n");	
			}
			// Y賣S@
			else
			{
				if( !random(3) )
					CHANNEL_D->channel_broadcast("nch", "ǨӦbu"+AREA_D->query_area_idname(data["area"], data["num"])+"vA"+capitalize(data["boss"])+" P "+capitalize(data2["boss"])+" 䱴IoYĬC\n");	
			}
		}
	}
	
	save();
}


int remove()
{
	return save();
}

void create()
{
	if( !restore_object(DATA) )
	{
		adventure = allocate_mapping(0);

		save();
	}
	
	set_heart_beat(600);
}

string query_name()
{
	return "It(ADVENTURE_D)";
}
