/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : clean_d.c
 * Author : Clode@RevivalWorld
 * Date   : 2003-06-05
 * Note   : MF
 * Update :
 *  o 2000-00-00  
 *
 -----------------------------------------
 */

#include <daemon.h>

#define ADAY	(60*60*24)
#define LOG	"daemon/clean"

#define CLEAN_NEWBIE_ESTATE_DAYS	7	// 7 ѥWuB`Wuɶ 2 pɤs⨤尣Цa
#define CLEAN_NEWBIE_CHAR_DAYS		180	// 180 ѥWuB`Wuɶ 2 pɤs⨤尣䨤
#define CLEAN_ESTATE_DAYS		365	// 365 ѥWuѪaRЦa
#define CLEAN_CHAR_DAYS			3650	// 3650 ѥWuѪaR䨤


void clean_user()
{
	object user;
	int total, time = time(), overtime;
	string msg, dir, id;
        string *root_dir = filter_array(get_dir("/data/user/"), (: strlen($1) == 1 :));

	CHANNEL_D->channel_broadcast("news", "tΰbMz@~AеyԡC");

        foreach( dir in root_dir )
        {
        	reset_eval_cost();

        	foreach( id in get_dir("/data/user/"+dir+"/") )
        	{
        		total++;
        		
        		if( SECURE_D->is_wizard(id) ) continue;

			if( find_player(id) && environment(find_player(id)) ) continue;
			
        		user = load_user(id);

			if( !objectp(user) )
			{
				CHANNEL_D->channel_broadcast("sys", "LkJϥΪ̪ "+id);
				log_file(LOG, "LkJϥΪ̪ "+id);
				continue;
			}
			
			overtime = (time - query("last_on/time", user))/ADAY;

			// `Wuɶ 2 pɤs⨤
			if( query("total_online_time", user) < 7200 )
			{
				if( overtime > CLEAN_NEWBIE_ESTATE_DAYS && sizeof(ESTATE_D->query_player_estate(id)) )
				{
					ESTATE_D->remove_estate(id);
					msg = capitalize(id)+" `Wuɶ 2 pɥBWL "+CLEAN_NEWBIE_ESTATE_DAYS+" ѥWu("+overtime+" )A^Цa";
					
					LOGIN_D->add_login_message(id, msg);
					CHANNEL_D->channel_broadcast("news", msg);
					log_file(LOG, msg);
				}
				else if( overtime > CLEAN_NEWBIE_CHAR_DAYS )
				{
					set("password", PASSWORD_D->query_password(id), user);
					user->save();
					
					msg = capitalize(id)+" `Wuɶ 2 pɥBWL "+CLEAN_NEWBIE_CHAR_DAYS+" ѥWu("+overtime+" )AR䨤";
					
					CHAR_D->destruct_char(id);
					CHANNEL_D->channel_broadcast("news", msg);
					log_file(LOG, msg);
				}
			}
			else
			{
				if( overtime > CLEAN_ESTATE_DAYS && sizeof(ESTATE_D->query_player_estate(id)) )
				{
					ESTATE_D->remove_estate(id);
					msg = capitalize(id)+" WL "+CLEAN_ESTATE_DAYS+" ѥWu("+overtime+" )A^Цa";
					
					LOGIN_D->add_login_message(id, msg);
					CHANNEL_D->channel_broadcast("news", msg);
					log_file(LOG, msg);
				}
				else if( overtime > CLEAN_CHAR_DAYS )
				{
					set("password", PASSWORD_D->query_password(id), user);
					user->save();
					
					msg = capitalize(id)+" WL "+CLEAN_CHAR_DAYS+" ѥWu("+overtime+" )AR䨤";
					CHAR_D->destruct_char(id);
					CHANNEL_D->channel_broadcast("news", msg);
					log_file(LOG, msg);
				}
			}

			if( objectp(user) && !userp(user) )
				destruct(user);
        	}
        }
        
        CHANNEL_D->channel_broadcast("news", "b`ơG"+total+"AMz@~C");
}

void create()
{
	

}

string query_name()
{
	return "ɮײMt(CLEAN_D)";
}
