/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : compile_object.c
 * Author : Clode@RevivalWorld
 * Date   : 2001-07-05
 * Note   : included by Master Object
 * Update :
 *  o 2002-00-00

 -----------------------------------------
 */

// compile_object: This is used for loading MudOS "virtual" objects.
// It should return the object the mudlib wishes to associate with the
// filename named by 'file'.  It should return 0 if no object is to be
// associated.
/*
W١G
        compile_object - ѵ (virtual object) \઺ mudlib C
ykG
        object compile_object( string pathname );

         compile_object( r |W );
ΪkG
         mudlib Xʵ{J@ӤsbO餤ɮסAXʵ{|I
        s compile_object 禡C|ҨӻApG mudlib Is
        call_other("/obj/file.r", "some_function")  new("/obj/file.r") 
        AO餤Ss /obj/file.r.c FAXʵ{NIsD_
         (master object)  compile_object("/obj/file.r")CpG mudlib 
        s (associate) /obj/file.r ɮסAcompile_object() NǦ^ 0Cp
        G mudlib @NANnǦ^ /obj/file.r oӪCb compile_object()
        s@ɮצW٩M󤧫AXʵ{ӨANpPCsb
        file.r.c oɮסAӸJɲͪNO compile_object() Ǧ^
        C
@̡G
        Tim Hollebeek  Beek@ZorkMUD, Lima Bean, IdeaExchange, and elsewhere
½ĶG
        spock@muds.net          2000.May.20.    v22 
*/

#include <daemon.h>

varargs mixed compile_object(string file, int cloning)
{
	return VIRTUAL_D->compile_object(file, cloning);
}