/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : valid_override.c
 * Author : Clode@RevivalWorld
 * Date   : 2001-07-05
 * Note   : included by Master Object
 * Update :
 *  o 2002-00-00

 -----------------------------------------
 */

#include <object.h>

/*
W١G
        valid_override -  efun:: γ~C
ykG
        int valid_override( string file, string efun_name, string mainfile );
 
         valid_override( r ɮ, r ~禡W, r Dɮ );
ΪkG
        file OөIsڤWҳBɮסFmainfile OsĶɮסq]
        #include YḀi|PrC
 
        bD_ (master.c) [W valid_override() iH efun:: o
        emyk (prefix) γ~CCXʵ{սsĶe[W efun:: 
        禡ɡA|IsD_󤤪 valid_override()CpG valid_override()
        Ǧ^ 0AhsĶѡCҥH@ǸT efun:: emykW׭@Ϊ~
        禡Avalid_override() iHѤ@Ӥkק復̪@ΡC
 
        pGzƱϥέ 3.1.2   efun:: @ΡAuݭnbD_
        master.c [WUoG
 
        int valid_override(string file, string efun) { return 1; }
 
        UO@ӭh valid_override() dҡG
        qĶGdһP 21 õLPAOثewhF mainfile Ѽơr

        int valid_override( string file, string name )
        {
                if (file == "/adm/obj/simul_efun") {
                        return 1;
                }

                if (name == "destruct")
                        return 0;
                if (name == "shutdown")
                        return 0;
                if (name == "snoop")
                        return 0;
                if (name == "exec")
                        return 0;

                return 1;
        }
ѦҡG
        valid_object, function_exists
@̡G
        Tim Hollebeek  Beek@ZorkMUD, Lima Bean, IdeaExchange, and elsewhere
½ĶG
        spock@muds.net          2000.May.21.    v22 

*/

int valid_override(string file, string name, string mainfile)
{
	
	if( file[0..24] == SIMUL_EFUN_OB[0..24] ) return 1;

	switch(name)
	{
		case "memory_summary":
                case "destruct"        :
		case "shutdown"	:
		case "exec"	:	return 0;
		default		:	return 1;
	}
}
