/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : room_wizhall_1.c
 * Author : Clode@RevivalWorld
 * Date   : 2003-08-23
 * Note   : зǩж
 * Update :
 *  o 2000-00-00
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <inherit.h>
#include <message.h>
#include <daemon.h>

inherit STANDARD_ROOM;

string help = @HELP
boӥZL_жèSSTC
HELP;

// w]Xf
#define DEFAULT_CITY_EXIT(city, num)	({ 49, 49, 0, city, num, 0, "49/49/0/"+city+"/"+num+"/0" })

mapping actions;

array south_exit(object ob)
{
	string city = query("city", ob);
	int num = query("section_num", ob);

	if( !sizeof(CITY_D->query_cities()) )
		return 0;

	if( !CITY_D->city_exist(city) )
	{
		string *cities = CITY_D->query_cities() - ({ "wizard" });
		
		if( sizeof(cities) )
		{	
			do
			{
				city = cities[random(sizeof(cities))];
			}
			while( CITY_D->query_city_info(city, "no_occupy") );
		}
		else
			return 0;
	}
	
	if( CITY_D->city_exist(city, num) )
		return CITY_D->query_section_info(city, num, "wizhall") || DEFAULT_CITY_EXIT(city, num);
	else
		return CITY_D->query_section_info(city, 0, "wizhall") || DEFAULT_CITY_EXIT(city, 0);
}

void do_gocity(object me, string arg)
{
	int num;
	string my_city = query("city", me);
	string *lines;

	if( !arg )
		return tell(me, pnoun(2, me)+"QnhyH help gocity ѦҫOΪkèϥ mayor OdߩҦơC\n");
	
	arg = remove_ansi(lower_case(arg));
	
	lines = explode(arg, " ");
	if(undefinedp(num = to_int(lines[<1]))) {
		num = 1;
		arg = implode(lines, " ");
	}
	else {
		arg = implode(lines[0..<2], " ");
	}
	

	if( !num ) num = 1;

	if( !CITY_D->city_exist(arg, num-1) )
		return tell(me, "oӥ@ɨèSoyC\n");

	if( !wizardp(me) )
	{
		if( CITY_D->query_city_info(arg, "no_occupy") )
			return tell(me, "oyLkqo̶iJC\n");
			
		if( my_city && my_city != arg )
			return tell(me, pnoun(2, me)+"O"+CITY_D->query_city_idname(my_city)+"ALkAۥѶiJLC\n");
		
		if( arg == "wizard" )
			return tell(me, CITY_D->query_city_idname(arg, num)+"OŮvAuŮviJC\n");
	}
	
	msg("$MELŮv߶׻EqҶ}ҪqDAe"+CITY_D->query_city_idname(arg, num-1)+"C\n", me, 0, 1);
	me->move(CITY_D->query_section_info(arg, num-1, "wizhall") || DEFAULT_CITY_EXIT(arg, (num-1)));
	msg("$MELŮvqDӨF"+CITY_D->query_city_idname(arg, num-1)+"C\n", me, 0, 1);
}

void create()
{
	set("short", HIW"Ův"NOR WHT""NOR);
	set("long",@TEXT
    jŮvⰼUݥߵۥ|䥨۬WA伵ۼƤQذγA
kOeFƦʤءAboɥjѪ۳yؿvAiHPı@[1;37mtq[mww
iJAPɫo]iHPؿv`BwwŧӪ[0;1;30mN[mPAGboy
̡A۳\hHKAѦ[1;33m South [mViHVۤvݪA|
Jy󫰥̩nh|HN@ӫAάOQ[1;33m gocity [mOez
ҫwCϥ [1;33mmayor [mOiHdߦUӫԲӸơA@Jyɪ
ҡC
TEXT);

	set("exits", ([
		"east" : "/wiz/wizhall/room_wizhall_2",
		"west" : "/wiz/wizhall/room_wizhall_6",
		"north" : "/wiz/wizhall/room_wizhall_4",
		"south" : (: south_exit($1) :),
		
	]));
	

	set("objects", ([
		"/obj/board/player" : 1,
	]));
	
	set_heart_beat(100);

	actions = ([ "gocity" : (: do_gocity :) ]);
	
	set("help/gocity", 
@HELP
Ly̥iHϥΦOۥѫe@yAOΪkpU
    
    gocity 'ID'	- eY
    
    Ҧp
    gocity center	- e center 
    
 ID i mayor Od
HELP,
	);

	::reset_objects();
}

void heart_beat()
{
	int heal;
	string roomshort = query("short");
	
	foreach( object ob in all_inventory(this_object()) )
	{
		if( !ob->is_living() ) return;

		heal = 0;
		
		if( !ob->is_stamina_full() )
		{
			heal = 1;
			ob->earn_stamina(20+random(21));
		}

		if( !ob->is_health_full() )
		{
			heal = 1;
			ob->earn_health(20+random(21));
		}

		if( !ob->is_energy_full() )
		{
			heal = 1;
			ob->earn_energy(20+random(21));
		}
		
		if( heal )
			msg(roomshort+"̯tqwwa`J$MEC\n"NOR, ob, 0, 1);
	}
}

void init(object ob)
{
	if( !ob->is_living() ) return;

	if( query("total_online_time", ob) < 24*60*60 )
	{
		string msg = HIY"\nsⴣܢwwwwww\n"
			NOR YEL"w"+pnoun(2, ob)+"iJͪ@ɽuW Mud CC\n"
			"sХԥ[\Ū http://www.revivalworld.org/rw/documents/newbie xоǤ\n"
			"ݧоǤYLDwQΡuchat xxxvѫOVuWLa߰\n"
			"YɦaϽаѦ http://www.revivalworld.org/rw/online\n"
			HIY"wwwwwwwwww\n\n"NOR;
			
		tell(ob, msg);
	}
}

