/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : create_wizhall.c
 * Author : Clode@RevivalWorld
 * Date   : 2002-02-02
 * Note   : إ Wizhall
 * Update :
 *  o 2000-00-00  
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <daemon.h>
#include <feature.h>
#include <location.h>
#include <map.h>
#include <message.h>

#define WALL_TABLE	0
#define ROOM_TABLE	1

inherit COMMAND;

string help = @HELP
        з create_wizhall OC
HELP;

private void command(object me, string arg)
{
	int x, y, num, type;
	string city;
	array room_coor, loc = query_temp("location",me);
	mapping bdata;
	
	if( !is_command() ) return;
	
	if( !arrayp(loc) ) return tell(me, pnoun(2, me)+"baϨtΤWoӫOC\n");
	
	num 	= loc[NUM];
	city 	= loc[CITY];
	
	if( CITY_D->query_coor_data(loc, "owner") != "GOVERNMENT/"+city )
		return tell(me, "ǫäOFgaC\n");

	if( !mapp(bdata = BUILDING_D->analyze_building_logic(loc)) )
		return tell(me, "ɫؿvسycDALk}iAбN~sسyC\n");


	if( sizeof(bdata["roomtable"]) != 6 )
		return tell(me, "ŮvO 3 X 2 ؿvC\n");
		

	// yиư}C
	foreach( string code in bdata["walltable"] )
	{
		loc = restore_variable(code);
		
		type = CITY_D->query_coor_data(loc, TYPE);
		
		if( type == WALL )
			CITY_D->set_coor_data(loc, FLAGS, NO_MOVE);
			
		else if( type != DOOR )
			return tell(me, "(Command:open)ƿ~AгqŮvBzC\n");
	}
	
	room_coor = allocate(6);
	
	// жyиư}C
	foreach( string code in bdata["roomtable"] )
	{	
		loc = restore_variable(code);
		
		// ]wyЬ ROOM аO
		CITY_D->set_coor_data(loc, ROOM, "wizhall");
		
		// ]wyФaϹϥܬ"  "
		CITY_D->set_coor_icon(loc, "  ");
		
		x += loc[X];
		if( !y || y < loc[Y] ) y = loc[Y];
	}	
	x/=6;

	// ]w Wizhall Xf
	CITY_D->create_wizhall_door(city, num, arrange_city_location(x, y+1, city, num));
	
	// إߧŮvЦaT
	ESTATE_D->set_estate("GOVERNMENT/"+city, bdata, "wizhall", city, num);
	
	CITY_D->set_coor_data(arrange_city_location(x, y, city, num), SPECIAL_EXIT, "/wiz/wizhall/room_wizhall_1");
	CITY_D->set_coor_data(arrange_city_location(x+1, y, city, num), SPECIAL_EXIT, "/wiz/wizhall/room_wizhall_2");
	CITY_D->set_coor_data(arrange_city_location(x-1, y, city, num), SPECIAL_EXIT, "/wiz/wizhall/room_wizhall_6");
	CITY_D->set_coor_data(arrange_city_location(x, y-1, city, num), SPECIAL_EXIT, "/wiz/wizhall/room_wizhall_4");
	CITY_D->set_coor_data(arrange_city_location(x+1, y-1, city, num), SPECIAL_EXIT, "/wiz/wizhall/room_wizhall_3");
	CITY_D->set_coor_data(arrange_city_location(x-1, y-1, city, num), SPECIAL_EXIT, "/wiz/wizhall/room_wizhall_5");
	CITY_D->set_coor_icon(arrange_city_location(x-1, y-1, city, num), HIW""NOR);
	CITY_D->set_coor_icon(arrange_city_location(x-1, y, city, num), NOR WHT""NOR);
	CITY_D->set_coor_icon(arrange_city_location(x+1, y-1, city, num), NOR HIW"v"NOR);
	CITY_D->set_coor_icon(arrange_city_location(x+1, y, city, num), NOR WHT""NOR);
	CITY_D->set_section_info(city, num, "wizhall", arrange_city_location(x, y+1, city, num));

	CHANNEL_D->channel_broadcast("news", me->query_idname()+"b"+CITY_D->query_city_idname(city, num)+""+CITY_D->position(x, y)+"سyF@ɡu"HIW"Ův"NOR WHT""NOR"vؿvC\n");
}
