/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : terrain.c
 * Author : Clode@RevivalWorld
 * Date   : 2006-09-07
 * Note   : terrain OC
 * Update :
 *  o 2000-00-00
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <feature.h>
#include <message.h>
#include <map.h>
#include <daemon.h>
#include <terrain.h>

inherit COMMAND;

string help = @HELP
@@ʫإߦaΪO

iHϥΪѼƦpUG

clear			- NثemyиƧMŦa
forest			- إߴ˪La([1;32m[m)
mountain1		- إߤsߦa([0;33m[m)
mountain2		- إߤsߦa([0;33m[m)
river1			- إߪey([0;44;1;34m[myVF)
river2			- إߪey([0;44;1;34m[myV)
river3			- إߪey([0;44;1;34m[myVn)
river4			- إߪey([0;44;1;34m[myV_)
road			- إ߹D
road 'W'		- إ߹DPDW
bridge			- إ߾([0;41;1;31m[m)
bridge 'W'		- إ߾ٻP٦W
wall			- إݩ
farm			- إ߹A([0;42;1;32m[m)
pasture			- إߪ([0;43;1;33m[m)
fishfarm		- إ߾i޳([0;44;1;34m[m)
light			- إ߸O([1;33mF[m)
pool			- إߤ([1;36m[m)
pavilion		- إ߲DF([1;37m[m)
tree			- إߤj([1;32mD[m)
grass			- إ߯([0;32ms[m)
statue			- إJ([1;35m[m)
icon 'ϧ'		- ¦bثeyФWø(Lݩʸ)
icon -d			- RثeyФWϧ
room 'жm'		- ]wثeyгsжɮ
room -d			- Rжs]w
room broken		- ]w@kж
name 'yЦW'		- ]wثeyйW
name -d			- RWٳ]w

HELP;

private void command(object me, string arg)
{
	string arg2;
	array loc = query_temp("location", me);

	if( !is_command() ) return;

	if( !arg )
		return tell(me, help);

	if( !arrayp(loc) || !AREA_D->is_area_location(loc) )
		return tell(me, pnoun(2, me)+"ubϳ]waΡC\n");
		
	sscanf(arg, "%s %s", arg, arg2);

	switch(arg)
	{
		// MaҦ
		case "clear":
		{
			// Myи
			AREA_D->delete_coor_data(loc);
			
			// Myйϧ
			AREA_D->delete_coor_icon(loc);
			
			msg("$MENogaiaC\n", me, 0, 1);
			
			break;
		}
		// إߴ˪La
		case "forest":
		{
			AREA_D->delete_coor_data(loc);
			AREA_D->set_coor_data(loc, TYPE, FOREST);
			AREA_D->set_coor_icon(loc, HIG""NOR);
			
			msg("$MEbogaWإߤF˪Lu"HIG""NOR"vaΡC\n", me, 0, 1);
			
			break;
		}
		// إߤsߦa()
		case "mountain1":
		{
			AREA_D->delete_coor_data(loc);
			AREA_D->set_coor_data(loc, TYPE, MOUNTAIN);
			AREA_D->set_coor_icon(loc, YEL""NOR);
			
			msg("$MEbogaWإߤFsߡu"YEL""NOR"vaΡC\n", me, 0, 1);
			
			break;
		}
		// إߤsߦa(k)
		case "mountain2":
		{
			AREA_D->delete_coor_data(loc);
			AREA_D->set_coor_data(loc, TYPE, MOUNTAIN);
			AREA_D->set_coor_icon(loc, YEL""NOR);
			
			msg("$MEbogaWإߤFsߡu"YEL""NOR"vaΡC\n", me, 0, 1);
			
			break;
		}
		// إߪeya(F)
		case "river1":
		{
			AREA_D->delete_coor_data(loc);
			AREA_D->set_coor_data(loc, TYPE, RIVER);
			AREA_D->set_coor_icon(loc, BBLU HIB""NOR);
			AREA_D->set_coor_data(loc, FLAGS, FLOW_EAST);

			msg("$MEbogaWإߤFeyu"BBLU HIB""NOR"v(FV)aΡC\n", me, 0, 1);
			
			break;
		}
		// إߪeya()
		case "river2":
		{
			AREA_D->delete_coor_data(loc);
			AREA_D->set_coor_data(loc, TYPE, RIVER);
			AREA_D->set_coor_icon(loc, BBLU HIB""NOR);
			AREA_D->set_coor_data(loc, FLAGS, FLOW_WEST);

			msg("$MEbogaWإߤFeyu"BBLU HIB""NOR"v(V)aΡC\n", me, 0, 1);
			
			break;
		}
		// إߪeya(n)
		case "river3":
		{
			AREA_D->delete_coor_data(loc);
			AREA_D->set_coor_data(loc, TYPE, RIVER);
			AREA_D->set_coor_icon(loc, BBLU HIB""NOR);
			AREA_D->set_coor_data(loc, FLAGS, FLOW_SOUTH);

			msg("$MEbogaWإߤFeyu"BBLU HIB""NOR"v(nV)aΡC\n", me, 0, 1);
			
			break;
		}
		// إߪeya(_)
		case "river4":
		{
			AREA_D->delete_coor_data(loc);
			AREA_D->set_coor_data(loc, TYPE, RIVER);
			AREA_D->set_coor_icon(loc, BBLU HIB""NOR);
			AREA_D->set_coor_data(loc, FLAGS, FLOW_NORTH);

			msg("$MEbogaWإߤFeyu"BBLU HIB""NOR"v(_V)aΡC\n", me, 0, 1);
			
			break;
		}
		// إ߹Da
		case "road":
		{
			AREA_D->delete_coor_data(loc);
			AREA_D->set_coor_data(loc, TYPE, ROAD);
			AREA_D->set_coor_icon(loc, "@");

			if( !arg2 )
				msg("$MEbogaWإߤFDaΡC\n", me, 0, 1);
			else
			{
				msg("$MEbogaWإߤFDèWu"+(arg2+NOR)+"vC\n", me, 0, 1);
				AREA_D->set_coor_data(loc, "short", kill_repeat_ansi(arg2+NOR));				
			}
			break;
		}
		// إ߾٦a
		case "bridge":
		{
			AREA_D->delete_coor_data(loc);
			AREA_D->set_coor_data(loc, TYPE, BRIDGE);
			AREA_D->set_coor_icon(loc, BRED HIR""NOR);

			if( !arg2 )
				msg("$MEbogaWإߤF١u"+BRED HIR""NOR+"vaΡC\n", me, 0, 1);
			else
			{
				msg("$MEbogaWإߤF١u"+BRED HIR""NOR+"vèWu"+(arg2+NOR)+"vC\n", me, 0, 1);
				AREA_D->set_coor_data(loc, "short", kill_repeat_ansi(arg2+NOR));				
			}
			break;
		}
		// إݩ
		case "wall":
		{
			AREA_D->delete_coor_data(loc);
			AREA_D->set_coor_data(loc, TYPE, WALL);
			AREA_D->set_coor_data(loc, FLAGS, NO_MOVE);

			msg("$MEbogaWإߤFݩʡC\n", me, 0, 1);
			
			break;
		}
		// إ߹A
		case "farm":
		{
			AREA_D->delete_coor_data(loc);
			AREA_D->set_coor_data(loc, TYPE, FARM);
			AREA_D->set_coor_icon(loc, HIG BGRN""NOR);
			
			msg("$MEbogaWإߤFAСu"HIG BGRN""NOR"vC\n", me, 0, 1);
			
			break;
		}
		// إߪ
		case "pasture":
		{
			AREA_D->delete_coor_data(loc);
			AREA_D->set_coor_data(loc, TYPE, PASTURE);
			AREA_D->set_coor_icon(loc, HIY BYEL""NOR);

			msg("$MEbogaWإߤFu"HIY BYEL""NOR"vC\n", me, 0, 1);
			
			break;
		}
		// إ߸O
		case "light":
		{
			AREA_D->delete_coor_data(loc);
			AREA_D->set_coor_data(loc, TYPE, LIGHT);
			AREA_D->set_coor_icon(loc, HIY"F"NOR);
			
			msg("$MEbogaWإߤFOu"HIY"F"NOR"vC\n", me, 0, 1);
			
			break;
		}
		// إߤ
		case "pool":
		{
			AREA_D->delete_coor_data(loc);
			AREA_D->set_coor_data(loc, TYPE, POOL);
			AREA_D->set_coor_icon(loc, HIC""NOR);
			
			msg("$MEbogaWإߤFu"HIC""NOR"vC\n", me, 0, 1);
			
			break;
		}
		// إ߲DF
		case "pavilion":
		{
			AREA_D->delete_coor_data(loc);
			AREA_D->set_coor_data(loc, TYPE, PAVILION);
			AREA_D->set_coor_icon(loc, HIW""NOR);
			
			msg("$MEbogaWإߤFDFu"HIW""NOR"vC\n", me, 0, 1);
			
			break;
		}
		// إߤj
		case "tree":
		{
			AREA_D->delete_coor_data(loc);
			AREA_D->set_coor_data(loc, TYPE, TREE);
			AREA_D->set_coor_icon(loc, HIG"D"NOR);
			
			msg("$MEbogaWإߤFju"HIG"D"NOR"vC\n", me, 0, 1);
			
			break;
		}
		// إ߯
		case "grass":
		{
			AREA_D->delete_coor_data(loc);
			AREA_D->set_coor_data(loc, TYPE, GRASS);
			AREA_D->set_coor_icon(loc, NOR GRN"s"NOR);
			
			msg("$MEbogaWإߤF֡u"NOR GRN"s"NOR"vC\n", me, 0, 1);
			
			break;
		}
		// إJ
		case "statue":
		{
			AREA_D->delete_coor_data(loc);
			AREA_D->set_coor_data(loc, TYPE, STATUE);
			AREA_D->set_coor_icon(loc, HIM""NOR);
			
			msg("$MEbogaWإߤFJu"HIM""NOR"vC\n", me, 0, 1);
			
			break;
		}
		// إ߾i޳
		case "fishfarm":
		{
			AREA_D->delete_coor_data(loc);
			AREA_D->set_coor_data(loc, TYPE, FISHFARM);
			AREA_D->set_coor_icon(loc, HIB BBLU""NOR);
			
			msg("$MEbogaWإߤFi޳u"HIB BBLU""NOR"vC\n", me, 0, 1);
			
			break;
		}	
		// ø(Bzݩʪ)
		case "icon":
		{
			if( !arg2 )
				return tell(me, "пJTO榡C\n");
	
			if( arg2 == "-d" )
			{
				AREA_D->delete_coor_icon(loc);
				
				msg("$MERFogaϧΡC\n", me, 0, 1);
				
				break;
			}
			AREA_D->set_coor_icon(loc, kill_repeat_ansi(arg2+NOR));
			
			msg("$MEbogaWإߤFu"+arg2+NOR+"vϧΡC\n", me, 0, 1);
		
			break;
		}
		// إ߹ж
		case "room":
		{
			if( !arg2 )
				return tell(me, "пJTO榡C\n");

			if( arg2 == "-d" )
			{
				AREA_D->delete_coor_data(loc, ROOM);
				AREA_D->delete_coor_data(loc, SPECIAL_EXIT);
				
				msg("$MERFogaжsơC\n", me, 0, 1);
				
				break;
			}
			else if( arg2 == "broken" )
			{
				AREA_D->delete_coor_data(loc);	
				AREA_D->set_coor_data(loc, ROOM, "room");
				msg("$MEbogaWإߤF@LkiJжC\n", me, 0, 1);
				return;
			}
			AREA_D->delete_coor_data(loc);
			AREA_D->set_coor_data(loc, SPECIAL_EXIT, arg2);
			AREA_D->set_coor_data(loc, ROOM, "room");

			msg("$MEbogaWإߤFPжu"+arg2+"vsC\n", me, 0, 1);
		
			break;
		}
		// إߤgaW
		case "name":
		{			
			if( !arg2 )
				return tell(me, "пJTO榡C\n");
			
			if( arg2 == "-d" )
			{
				AREA_D->delete_coor_data(loc, "short");
				
				msg("$MERFogaRWơC\n", me, 0, 1);
				
				break;
			}

			AREA_D->set_coor_data(loc, "short", kill_repeat_ansi(arg2+NOR));
				
			msg("$MENogaRWu"+arg2+NOR+"vC\n", me, 0, 1);
			
			break;
		}
		// Lp
		default:
		{
			tell(me, "пJTѼơC\n"+help);
			break;
		}
	}
}
