/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : eat.c
 * Author : Clode@RevivalWorld
 * Date   : 2003-03-04
 * Note   : eat O
 * Update :
 *  o 2000-00-00  
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <feature.h>

inherit COMMAND;

string help = @HELP
έO
eat '~'		- NYӪ~Y{l

HELP;

private void do_command(object me, string arg)
{
	int capacity;
	object ob;
	
	if( !arg )
	{
		if( me->is_npc() )
			return me->do_command("say QnڦYǤH\n");
		else
			return tell(me, pnoun(2, me)+"QnYǤH\n");
	}
	
	ob = present(arg, me) || present(arg, environment(me));
	
	if( !objectp(ob) )
	{
		if( me->is_npc() )
			return me->do_command("say èS "+arg+" oحC\n");
		else
			return tell(me, "èS "+arg+" oحC\n");
	}

	if( !ob->is_food() )
	{
		if( me->is_npc() )
			return me->do_command("say "+ob->query_idname()+"OALkΡC\n");
		else
			return tell(me, ob->query_idname()+"OALkΡC\n");
	}
	
	capacity = query("capacity", ob);

	if( capacity + me->query_food_cur() > me->query_food_max() )
	{
		if( me->is_npc() )
			return me->do_command("say ڦYU"+ob->query_idname()+"FI\n");
		else
			return tell(me, pnoun(2, me)+"YU"+ob->query_idname()+"FI\n");
	}
	
	me->add_food(capacity);

	msg("$MEN$YOUYi{l̡C\n", me, ob, 1);

	ob->eat();
	destruct(ob, 1);
}