/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : follow.c
 * Author : Clode@RevivalWorld
 * Date   : 2003-05-10
 * Note   : follow O
 * Update :
 *  o 2000-00-00
 *
 -----------------------------------------
 */

#include <daemon.h>
#include <feature.h>
#include <message.h>

inherit COMMAND;

string help = @HELP
oӫOiHA۰ʸۥt@ӤHʡC

follow [YH]		- }lHYH
follow -d		- HH

HELP;

private void do_command(object me, string arg)
{
	string target_id;
	object target_ob;
	object *followers;
	object following_ob;
	
	if( !arg )
	{
		if( me->is_npc() )
			return me->do_command("say ƱڸH֡H\n");
		else
			return tell(me, pnoun(2, me)+"QnH֡H\n");
	}
	
	if( arg == "-d" )
	{
		target_ob = query_temp("following", me);
		
		if( !objectp(target_ob) )
		{
			delete_temp("following", me);

			if( me->is_npc() )
				return me->do_command("say ڭ쥻KSbHHC\n");
			else
				return tell(me, pnoun(2, me)+"쥻KSbHHC\n");
		}

		followers = query_temp("follower", target_ob);		

		if( arrayp(followers) && sizeof(followers) )
		{
			followers -= ({ me });
			
			if( !sizeof(followers) )
				delete_temp("follower", target_ob);
			else
				set_temp("follower", followers, target_ob);
		}
		
		delete_temp("following", me);

		msg("$ME~H$YOU欰C\n", me, target_ob, 1);
		
		return;
	}

	target_id = arg;
	target_ob = present(target_id);

	if( !objectp(target_ob) )
	{
		if( me->is_npc() )
		{
			if( target_id == "me" )
				target_ob = this_player(1);
			else
				return me->do_command("say ǫS "+arg+" oӪFC\n");
		}
		else
			return tell(me, "ǫS "+arg+" oӪFC\n");
	}

	if( !target_ob->is_living() )
	{
		if( me->is_npc() )
			return me->do_command("say "+target_ob->query_idname()+"OͪALkHC\n");
		else
			return tell(me, target_ob->query_idname()+"OͪALkHC\n");
	}
		
	if( target_ob == me )
	{
		if( me->is_npc() )
			return me->do_command("say ڵLkHڦۤvC\n");
		else
			return tell(me, pnoun(2, me)+"LkH"+pnoun(2, me)+"ۤvC\n");
	}

	following_ob = query_temp("following", me);

	if( objectp(following_ob) )
	{
		followers = query_temp("follower", following_ob) || allocate(0);
		followers -= ({ me });
		
		if( !sizeof(followers) )
			delete_temp("follower", following_ob);
		else
			set_temp("follower", followers, following_ob);
			
		msg("$MEH$YOUC\n", me, following_ob, 1);	
	}
		
	followers = query_temp("follower", target_ob) || allocate(0);
	
	followers |= ({ me });
	
	set_temp("follower", followers, target_ob);
	set_temp("following", target_ob, me);

	msg("$ME}lμvab$YOUC\n", me, target_ob, 1);	
}
