/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : collect.c
 * Author : Clode@RevivalWorld
 * Date   : 2002-2-19
 * Note   : collect O
 * Update :
 *  o 2000-00-00  
 *
 -----------------------------------------
 */

#define COLLECT_STR_COST	35

#define MATERIAL_PATH		"/obj/materials/"

#include <ansi.h>
#include <map.h>
#include <feature.h>
#include <daemon.h>
#include <message.h>
#include <material.h>
#include <location.h>

inherit COMMAND;

string help = @HELP

ĶO

oӫOibaϤWĶUحơAƦ@ءC

metal	 - sϨϥΤQruĶ
stone	 - sϨϥpYuĶ
water	M - eyϥΤuĶ
wood	 - ˪LϥΤuĶ
fuel	U - ˪LϥluĶ

O榡:
collect metal		- Ķ@Ӫ(ĶWQru)
collect 10 metal	- @ĶQӪ
			  i`٨ǳ\OP֤ulavüW[}~v
collect info		- d߷ӫƱĶT

O: info

HELP;

// @ķUhٷUhO
private int cost_stamina(object me, int amount, int skilllevel)
{
	if( amount <= 10 )
		return me->cost_stamina(amount * (COLLECT_STR_COST - skilllevel/4));
	else if( amount <= 20 )
		return me->cost_stamina(amount * (COLLECT_STR_COST - skilllevel/4 - 1));
	else if( amount <= 50 )
		return me->cost_stamina(amount * (COLLECT_STR_COST - skilllevel/4 - 2));
	else if( amount <= 100 )
		return me->cost_stamina(amount * (COLLECT_STR_COST - skilllevel/4 - 3));

	return me->cost_stamina(amount * (COLLECT_STR_COST - skilllevel/4 - 4));	
}

private void do_command(object me, string arg)
{
	array loc;
	object ob, env = environment(me);
	mapping coorrangetype;
	object *tools;
	int skilllevel, endurance, materialamount, amount;
	string sloc, arg2;
	string city;
	int num;
	string myid = me->query_id(1);

	if( !arg )
		return tell(me, pnoun(2, me)+"QnĶظ귽H("HIW" metal"NOR"B"WHT" stone"NOR"B"HIC"M water"NOR"B"YEL" wood"NOR"B"HIM"U fuel"NOR")\n");
	
	if( (wizardp(me) && sscanf(arg, "info %s", city) == 1) || arg == "info" )
	{
		string msg;
		string id;
		mapping collection_record;
		mapping data;

		if( !city )
			city = query("city", me);
		
		if( !city )
			return tell(me, pnoun(2, me)+"ݩ@yC\n");

		if( !CITY_D->city_exist(city) )
			return tell(me, "S "+city+" oyC\n");
		
		msg = CITY_D->query_city_idname(city)+"ƱĶppU(۰ʩC 23:00 ks)G\n";
		msg += WHT"wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww\n"NOR;
		
		for(num=0;CITY_D->city_exist(city, num);num++)
		{
			msg += CITY_D->query_city_idname(city, num)+"\n";

			collection_record = CITY_D->query_collection_record(city, num);
			
			if( !sizeof(collection_record) )
				msg += "  LHĶ\n";
			else
			foreach(id, data in collection_record)
			{
				msg += sprintf("  %-15s%-10s%-10s%-10s%-10s%-10s\n",
					capitalize(id),
					HIW+data["metal"]+NOR,
					WHT+data["stone"]+NOR,
					HIC+data["water"]+NOR,
					YEL+data["wood"]+NOR,
					HIM+data["fuel"]+NOR);
			}
			
			msg += "\n";
		}
		
		msg += WHT"wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww\n"NOR;
		msg += HIW" metal"NOR"B"WHT" stone"NOR"B"HIC"M water"NOR"B"YEL" wood"NOR"B"HIM"U fuel"NOR"\n\n";
		return me->more(msg);
	}
	
	if( !env || !env->is_maproom() )
		return tell(me, "Lkbo̱Ķ귽C\n");

	
	//LUO
	if( me->is_delaying() )
	{
		tell(me, me->query_delay_msg());
		return me->show_prompt();
	}
	
	loc = query_temp("location", me);
	
	if( (MAP_D->query_map_system(loc)) != CITY_D )
		return tell(me, "Lkbo̱Ķ귽C\n");
 
 	city = loc[CITY];
	num = loc[NUM];

 	if( !CITY_D->is_citizen(me->query_id(1), city) )
 		return tell(me, pnoun(2, me)+"O"+CITY_D->query_city_idname(city)+"ALkbo̱Ķ귽C\n");
 
	coorrangetype = CITY_D->query_coor_range(loc, TYPE, 1);

	arg = lower_case(arg);

	if( sscanf(arg, "%d %s", amount, arg2) == 2 )
		arg = arg2;
	
	if( amount < 1 )
		amount = 1;
	
	if( amount > 1000 )
		return tell(me, "̦h@uĶ 1000 Ӹ귽C\n");

	switch(arg)
	{
		case "metal":
			skilllevel = me->query_skill_level(arg);
			
			coorrangetype = filter(coorrangetype, (: $2 == MOUNTAIN :));

			if( !sizeof(coorrangetype) )
				return tell(me, "񪺰ϰ줤èSsϡASk}ĪݡC\n");
			
			tools = filter_array(all_inventory(me), (: query("collection_tool", $1) == $(arg) :));
			
			if( !sizeof(tools) )
				return tell(me, pnoun(2, me)+"WSΨӶ}ĪݪuC\n");
			
			// ˬdϰ쪺Ʀsq
			foreach(sloc in keys(coorrangetype))
			{
				loc = restore_variable(sloc);
				materialamount = CITY_D->query_section_info(city, num, "resource/"+arg);
				
				if( materialamount >= amount )
				{
					if( !cost_stamina(me, amount, skilllevel) )
						return msg("$MEݼNNAwgSOA}ĪݤF...C\n", me, 0, 1);
					
					endurance = query("endurance", tools[0]);
		
					// ula(lavPu@[שMϥΪ̧ޯ)
					if( !random(endurance + to_int(skilllevel*endurance/100.)) )
					{
						msg("$MEW"+tools[0]->query_idname()+"Myԡz@nA`BF}ӡAMOSkA~ΨӶ}ĪݤF...C\n", me, 0, 1);
						
						if( !random(2) )
						{
							tell(me, pnoun(2, me)+"qoӨƥoh|gC\n");
							me->add_social_exp(endurance + to_int(skilllevel*endurance/100.) - 50 + random(101));
						}
						
						destruct(tools[0], 1);
						return;
					}
					
					CITY_D->set_section_info(city, num, "resource/"+arg, materialamount-amount);
					
					ob = new(MATERIAL_PATH+arg);

					if( amount > 1 )
						set_temp("amount", amount, ob);

					msg("$MEOaqqۤwXF"+ob->short(1)+"\n", me, 0, 1);
					
					// ƱĶT
					CITY_D->add_collection_record(city, num, myid, arg, amount);
					
					if( !me->get_object(ob, amount) )
					{
						msg("$MEwg"+ob->short(1)+"FIunbaWC\n", me, 0, 1);
						ob->move_to_environment(me);
					}
		
					if( me->query_skill_level("metal") < 20 )
						me->add_skill_exp("metal", amount*(12+random(11)));
					else if( me->query_skill_level("metal") == 20 )
						tell(me, pnoun(2, me)+"Ķޯ൥ŤwgF 20ALkAۧکWɡA󰪲`ǰݥ}ljǾǲߡC\n");

					me->add_social_exp(to_int(pow(amount*(20+random(21)), 0.9)));
					TREASURE_D->get_treasure_books(me, amount);
					return;
				}
			}
			return tell(me, "yݸ귽wgQjq}ġAѤUOAϥΪHqC\n");
			break;	

		case "stone":
			skilllevel = me->query_skill_level(arg);
			
			coorrangetype = filter(coorrangetype, (: $2 == MOUNTAIN :));

			if( !sizeof(coorrangetype) )
				return tell(me, "񪺰ϰ줤èSsϡASk}ĥۧC\n");
			
			tools = filter_array(all_inventory(me), (: query("collection_tool", $1) == $(arg) :));
			
			if( !sizeof(tools) )
				return tell(me, pnoun(2, me)+"WSΨӶ}ĥۧuC\n");
			
			// ˬdϰ쪺Ʀsq
			foreach(sloc in keys(coorrangetype))
			{
				loc = restore_variable(sloc);
				materialamount = CITY_D->query_section_info(city, num, "resource/"+arg);
				
				if( materialamount >= amount )
				{
					if( !cost_stamina(me, amount, skilllevel) )
						return msg("$MEݼNNAwgSOA}ĥۧF...C\n", me, 0, 1);
					
					endurance = query("endurance", tools[0]);
		
					// ula(lavPu@[שMϥΪ̧ޯ)
					if( !random(endurance + to_int(skilllevel*endurance/100.)) )
					{
						msg("$MEW"+tools[0]->query_idname()+"Myԡz@nA`BF}ӡAMOSkA~ΨӶ}ĥۧF...C\n", me, 0, 1);
						
						if( !random(2) )
						{
							tell(me, pnoun(2, me)+"qoӨƥoh|gC\n");
							me->add_social_exp(endurance + to_int(skilllevel*endurance/100.) - 50 + random(101));
						}
						destruct(tools[0], 1);
						return;
					}
					
					CITY_D->set_section_info(city, num, "resource/"+arg, materialamount-amount);
					
					ob = new(MATERIAL_PATH+arg);

					if( amount > 1 )
						set_temp("amount", amount, ob);

					msg("$MEOaqhwXF"+ob->short(1)+"\n", me, 0, 1);
					
					// ƱĶT
					CITY_D->add_collection_record(city, num, myid, arg, amount);

					if( !me->get_object(ob, amount) )
					{
						msg("$MEwg"+ob->short(1)+"FIunbaWC\n", me, 0, 1);
						ob->move_to_environment(me);
					}

					if( me->query_skill_level("stone") < 20 )
						me->add_skill_exp("stone", amount*(12+random(11)));
					else if( me->query_skill_level("stone") == 20 )
						tell(me, pnoun(2, me)+"Ķޯ൥ŤwgF 20ALkAۧکWɡA󰪲`ǰݥ}ljǾǲߡC\n");

					me->add_social_exp(to_int(pow(amount*(20+random(21)), 0.9)));
					TREASURE_D->get_treasure_books(me, amount);
					return;
				}
			}
			return tell(me, "yۧ귽wgQjq}ġAѤUOAϥΪHۡC\n");
			break;	

		case "water":
			skilllevel = me->query_skill_level(arg);
			
			coorrangetype = filter(coorrangetype, (: $2 == POOL || $2 == RIVER :));

			if( !sizeof(coorrangetype) )
				return tell(me, "񪺰ϰ줤èSASkĶMC\n");
			
			tools = filter_array(all_inventory(me), (: query("collection_tool", $1) == $(arg) :));
			
			if( !sizeof(tools) )
				return tell(me, pnoun(2, me)+"WSΨӶuC\n");
			
			// ˬdϰ쪺Ʀsq
			foreach(sloc in keys(coorrangetype))
			{
				loc = restore_variable(sloc);
				materialamount = CITY_D->query_section_info(city, num, "resource/"+arg);
				
				if( materialamount >= amount )
				{
					if( !cost_stamina(me, amount, skilllevel) )
						return msg("$MEݼNNAwgSOAF...C\n", me, 0, 1);
					
					endurance = query("endurance", tools[0]);
		
					// ula(lavPu@[שMϥΪ̧ޯ)
					if( !random(endurance + to_int(skilllevel*endurance/100.)) )
					{
						msg("$MEW"+tools[0]->query_idname()+"Myԡz@nAF@Ӥj}AMOSkA~ΨӸˤF...C\n", me, 0, 1);
						
						if( !random(2) )
						{
							tell(me, pnoun(2, me)+"qoӨƥoh|gC\n");
							me->add_social_exp(endurance + to_int(skilllevel*endurance/100.) - 50 + random(101));
						}

						destruct(tools[0], 1);
						return;
					}
					
					CITY_D->set_section_info(city, num, "resource/"+arg, materialamount-amount);
					
					ob = new(MATERIAL_PATH+arg);
					
					if( amount > 1 )
						set_temp("amount", amount, ob);

					msg("$MEΤOaqe_F"+ob->short(1)+"\n", me, 0, 1);
					
					// ƱĶT
					CITY_D->add_collection_record(city, num, myid, arg, amount);

					if( !me->get_object(ob, amount) )
					{
						msg("$MEwg"+ob->short(1)+"FIunbaWC\n", me, 0, 1);
						ob->move_to_environment(me);
					}
		
					if( me->query_skill_level("water") < 20 )
						me->add_skill_exp("water", amount*(12+random(11)));
					else if( me->query_skill_level("water") == 20 )
						tell(me, pnoun(2, me)+"Ķޯ൥ŤwgF 20ALkAۧکWɡA󰪲`ǰݥ}ljǾǲߡC\n");

					me->add_social_exp(to_int(pow(amount*(20+random(21)), 0.9)));
					TREASURE_D->get_treasure_books(me, amount);
					return;
				}
			}
			return tell(me, "y귽wgQjqϥΡAo۷VBAϥΤFC\n");
			break;
			
		case "wood":
			skilllevel = me->query_skill_level(arg);
			
			coorrangetype = filter(coorrangetype, (: $2 == FOREST :));

			if( !sizeof(coorrangetype) )
				return tell(me, "񪺰ϰ줤èSLASkC\n");
			
			tools = filter_array(all_inventory(me), (: query("collection_tool", $1) == $(arg) :));
			
			if( !sizeof(tools) )
				return tell(me, pnoun(2, me)+"WSΨӥ쪺uC\n");
			
			// ˬdϰ쪺Ʀsq
			foreach(sloc in keys(coorrangetype))
			{
				loc = restore_variable(sloc);
				materialamount = CITY_D->query_section_info(city, num, "resource/"+arg);
				
				if( materialamount >= amount )
				{
					if( !cost_stamina(me, amount, skilllevel) )
						return msg("$MEݼNNAwgSOAF...C\n", me, 0, 1);
					
					endurance = query("endurance", tools[0]);
		
					// ula(lavPu@[שMϥΪ̧ޯ)
					if( !random(endurance + to_int(skilllevel*endurance/100.)) )
					{
						msg("$MEW"+tools[0]->query_idname()+"Myԡz@nA`BF}ӡAMOSkA~ΨӥF...C\n", me, 0, 1);
						
						if( !random(2) )
						{
							tell(me, pnoun(2, me)+"qoӨƥoh|gC\n");
							me->add_social_exp(endurance + to_int(skilllevel*endurance/100.) - 50 + random(101));
						}
						
						destruct(tools[0], 1);
						return;
					}
					
					CITY_D->set_section_info(city, num, "resource/"+arg, materialamount-amount);
					
					ob = new(MATERIAL_PATH+arg);
				
					if( amount > 1 )
						set_temp("amount", amount, ob);

					msg("$MEVOaqUF"+ob->short(1)+"\n", me, 0, 1);
					
					// ƱĶT
					CITY_D->add_collection_record(city, num, myid, arg, amount);

					if( !me->get_object(ob, amount) )
					{
						msg("$MEwg"+ob->short(1)+"FIunbaWC\n", me, 0, 1);
						ob->move_to_environment(me);
					}
		
					if( me->query_skill_level("wood") < 20 )
						me->add_skill_exp("wood", amount*(12+random(11)));
					else if( me->query_skill_level("wood") == 20 )
						tell(me, pnoun(2, me)+"Ķޯ൥ŤwgF 20ALkAۧکWɡA󰪲`ǰݥ}ljǾǲߡC\n");

					me->add_social_exp(to_int(pow(amount*(20+random(21)), 0.9)));
					TREASURE_D->get_treasure_books(me, amount);
					return;
				}
			}
			return tell(me, "yL귽wgQjqAѤUOAϥΪp]C\n");
			break;

		case "fuel":
			skilllevel = me->query_skill_level(arg);
			
			coorrangetype = filter(coorrangetype, (: $2 == FOREST :));

			if( !sizeof(coorrangetype) )
				return tell(me, "񪺰ϰ줤èS˪LASk}ĿUơC\n");
			
			tools = filter_array(all_inventory(me), (: query("collection_tool", $1) == $(arg) :));
			
			if( !sizeof(tools) )
				return tell(me, pnoun(2, me)+"WSΨӶ}ĿUƪuC\n");
			
			// ˬdϰ쪺Ʀsq
			foreach(sloc in keys(coorrangetype))
			{
				loc = restore_variable(sloc);
				materialamount = CITY_D->query_section_info(city, num, "resource/"+arg);
				
				if( materialamount >= amount )
				{
					if( !cost_stamina(me, amount, skilllevel) )
						return msg("$MEݼNNAwgSOA}ĿUƤF...C\n", me, 0, 1);
					
					endurance = query("endurance", tools[0]);
		
					// ula(lavPu@[שMϥΪ̧ޯ)
					if( !random(endurance + to_int(skilllevel*endurance/100.)) )
					{
						msg("$MEW"+tools[0]->query_idname()+"Myԡz@nA`BF}ӡAMOSkA~ΨӶ}ĿUƤF...C\n", me, 0, 1);
						
						if( !random(2) )
						{
							tell(me, pnoun(2, me)+"qoӨƥoh|gC\n");
							me->add_social_exp(endurance + to_int(skilllevel*endurance/100.) - 50 + random(101));
						}
						
						destruct(tools[0], 1);
						return;
					}
					
					CITY_D->set_section_info(city, num, "resource/"+arg, materialamount-amount);
					
					ob = new(MATERIAL_PATH+arg);
					
					if( amount > 1 )
						set_temp("amount", amount, ob);

					msg("$MEOaqgąXF"+ob->short(1)+"\n", me, 0, 1);
					
					// ƱĶT
					CITY_D->add_collection_record(city, num, myid, arg, amount);

					if( !me->get_object(ob, amount) )
					{
						msg("$MEwg"+ob->short(1)+"FIunbaWC\n", me, 0, 1);
						ob->move_to_environment(me);
					}
					if( me->query_skill_level("fuel") < 20 )
						me->add_skill_exp("fuel", amount*(12+random(11)));
					else if( me->query_skill_level("fuel") == 20 )
						tell(me, pnoun(2, me)+"Ķޯ൥ŤwgF 20ALkAۧکWɡA󰪲`ǰݥ}ljǾǲߡC\n");

					me->add_social_exp(to_int(pow(amount*(20+random(21)), 0.9)));
					TREASURE_D->get_treasure_books(me, amount);
					return;
				}
			}
			return tell(me, "yUƸ귽wgQjq}ġALkAiQΪUơC\n");
			break;
		


		default:
			return tell(me, pnoun(2, me)+"QnحơH("HIW" metal"NOR", "WHT" stone"NOR", "HIC"M water"NOR", "YEL" wood"NOR", "HIM"U fuel"NOR")\n");
			break;
	}
}
	
