/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : region.c
 * Author : Clode@RevivalWorld
 * Date   : 2003-05-06
 * Note   : xΤga
 * Update :
 *  o 2000-00-00
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <map.h>
#include <daemon.h>
#include <feature.h>
#include <message.h>
#include <location.h>

inherit COMMAND;

string help = @HELP
    ΩxiϥΦOӳW
    	region A	- NgaWA~
    	region u	- NgaWu~
    	region 	- NgaWӷ~
    	region -d	- gaW
HELP;

#define REGION_COST	500000

private void do_command(object me, string arg)
{
	string owner;
	array loc;
	object env = environment(me);

	if( !arg ) 
		return tell(me, "пJ`WϦW(A, u, )C\n");

	if( !env || !env->is_maproom() ) 
		return tell(me, pnoun(2, me)+"LkWogaC\n");
	
	loc = query_temp("location", me);

	if( !CITY_D->city_exist(loc[CITY]) )
		return tell(me, "oaϤWOiWϪeC\n");

	if( !CITY_D->is_mayor_or_officer(loc[CITY], me) )
		return tell(me, pnoun(2, me)+"OoyΩxC\n");

	owner = CITY_D->query_coor_data(loc, "owner");
	
	if( owner )
	{
		if( owner == "GOVERNMENT/"+loc[CITY] )
			return tell(me, "oawgOFxgaALksWC\n");
		
		return tell(me, "oawgO "+owner+" gaALksWC\n");
	}

	switch( CITY_D->query_coor_data(loc, TYPE) )
	{
		case MOUNTAIN:
		case FOREST:
		case RIVER:
			return tell(me, "oaO۵MaΡALkiWϵeC\n");
	}

	switch( arg )
	{
		case "A":
			if( CITY_D->query_coor_data(loc, "region") == AGRICULTURE_REGION )
				return tell(me, "oga쥻NOA~ϡC\n");
			
			if( !CITY_D->change_assets(loc[CITY], -REGION_COST) )
				return tell(me, "uѤU $"+MONEY_D->city_to_money_unit(loc[CITY])+" "+CITY_D->query_assets(loc[CITY])+"AHsWgaFI\n");
		
			
			CITY_D->set_coor_data(loc, "region", AGRICULTURE_REGION);
			CITY_D->set_coor_data(loc, VALUE, "100000");
			CITY_D->set_coor_icon(loc, BGRN"D"NOR);
			
			CHANNEL_D->channel_broadcast("city", me->query_idname()+"N"+CITY_D->query_city_idname(loc[CITY], loc[NUM])+" "HIG+(loc[X]+1)+","+(loc[Y]+1)+NOR" gaW"HIG HBGRN"A~"NOR"C\n", me);
			msg("$MEIFF겣 $"+MONEY_D->city_to_money_unit(loc[CITY])+" "+REGION_COST+" NaWA~ϡC\n", me, 0, 1);
			
			break;
		case "u":
			if( CITY_D->query_coor_data(loc, "region") == INDUSTRY_REGION )
				return tell(me, "oga쥻NOu~ϡC\n");
			
			if( !CITY_D->change_assets(loc[CITY], -REGION_COST) )
				return tell(me, "uѤU $"+MONEY_D->city_to_money_unit(loc[CITY])+" "+CITY_D->query_assets(loc[CITY])+"AHsWgaFI\n");
		
			CITY_D->set_coor_data(loc, "region", INDUSTRY_REGION);
			CITY_D->set_coor_data(loc, VALUE, "200000");
			CITY_D->set_coor_icon(loc, BYEL"D"NOR);
			
			CHANNEL_D->channel_broadcast("city", me->query_idname()+"N"+CITY_D->query_city_idname(loc[CITY], loc[NUM])+" "HIG+(loc[X]+1)+","+(loc[Y]+1)+NOR" gaW"HIY HBYEL"u~"NOR"C\n", me);
			msg("$MEIFF겣 $"+MONEY_D->city_to_money_unit(loc[CITY])+" "+REGION_COST+" NaWu~ϡC\n", me, 0, 1);
			break;
			
		case "":
			if( CITY_D->query_coor_data(loc, "region") == COMMERCE_REGION )
				return tell(me, "oga쥻NOӷ~ϡC\n");

			if( !CITY_D->change_assets(loc[CITY], -REGION_COST) )
				return tell(me, "uѤU $"+MONEY_D->city_to_money_unit(loc[CITY])+" "+CITY_D->query_assets(loc[CITY])+"AHsWgaFI\n");
		
			CITY_D->set_coor_data(loc, "region", COMMERCE_REGION);
			CITY_D->set_coor_data(loc, VALUE, "300000");
			CITY_D->set_coor_icon(loc, BCYN"D"NOR);
			
			CHANNEL_D->channel_broadcast("city", me->query_idname()+"N"+CITY_D->query_city_idname(loc[CITY], loc[NUM])+" "HIG+(loc[X]+1)+","+(loc[Y]+1)+NOR" gaW"HIC HBCYN"ӷ~"NOR"C\n", me);
			msg("$MEIFF겣 $"+MONEY_D->city_to_money_unit(loc[CITY])+" "+REGION_COST+" NaWӷ~ϡC\n", me, 0, 1);
			break;
		
		case "-d":
			if( !CITY_D->query_coor_data(loc, "region") )
				return tell(me, "oa쥻NSWC\n");
			
			CITY_D->delete_coor_data(loc, "region");
			CITY_D->delete_coor_data(loc, 6);
			CITY_D->delete_coor_icon(loc);
			
			CHANNEL_D->channel_broadcast("city", me->query_idname()+"F"+CITY_D->query_city_idname(loc[CITY], loc[NUM])+" "HIG+(loc[X]+1)+","+(loc[Y]+1)+NOR" 즳gaWC\n", me);
			msg("$MEFa즳gaWC\n", me, 0, 1);
			break;
			
		default:
			return tell(me, "пJ`WϦW(A, u, )C\n");
	}
}
