/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : set.c
 * Author : Cwlin@RevivalWorld
 * Date   : 2003-06-07
 * Note   : 
 * Update :
 *  o 2003-00-00
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <feature.h>
#include <message.h>
#include <daemon.h>
#include <type.h>

inherit COMMAND;

#define VAR_TYPE        0
#define VAR_REGEXP      1
#define VAR_LEVEL	2
#define VAR_COMMENT     3

// ѼƫA
#define TYPE_BOOLEAN	0
#define	TYPE_INTEGER	1
#define TYPE_STRING	2

// ϥv
#define LV_PLAYER	0
#define LV_WIZARD	1

string help = @HELP
]wܼ

oӫOΨӳ]wܼơAiϥΪ̦ۥѽվߦnBߺDާ@ҡC

O榡:
set			ܩҦiѧ諸ܼƻP]w
set -l			ܩҦiѧ諸ܼƻP
set <ܼ> <>		Nܼ <ܼ> ȧאּ <>
set -d <ܼ>		Nܼ <ܼ> אּtιw]

O: chfn, alias,
HELP;
private nosave mapping ENV_VARS = 
([
//	ܼƦW	: ({ ѼƫA, ѼƮ榡(Wܪk), v,  }),
	"no_map"	: ({ TYPE_BOOLEAN, "[0-1]", 	LV_PLAYER, "}Yɦa (0: }, 1: )" }),
	"rumor"		: ({ TYPE_INTEGER, "[0-2]", 	LV_PLAYER, "WDΦWҦ (0: ΦW, 1: _W, 2: as)" }),
	"invis"		: ({ TYPE_BOOLEAN, "[0-1]", 	LV_WIZARD, "μҦ (0: X{, 1: )" }),
	"no_weather"	: ({ TYPE_BOOLEAN, "[0-1]", 	LV_WIZARD, "ѮvT (0: vT, 1: vT)" }),
        "timezone"	: ({ TYPE_STRING,  "[a-zA-Z]", 	LV_PLAYER, "ɰ" }),
        "edit_prompt"	: ({ TYPE_BOOLEAN, "[0-1]", 	LV_PLAYER, "ϥΤrs边ܩROܦr (0: , 1: )" }),
        "no_player_city": ({ TYPE_BOOLEAN, "[0-1]", 	LV_PLAYER, "aW٤eW (0: , 1:)" }),
 //       "no_id_color"	: ({ TYPE_BOOLEAN, "[0-1]",	LV_PLAYER, "W٤m(0: m, 1: ¥)" }),
 //       "no_color"	: ({ TYPE_BOOLEAN, "[0-1]",	LV_PLAYER, "Ҧrm(0: m, 1: ¥)" }),
]);

private void command(object me, string arg)
{
	mixed val;
	string var, msg;
	mapping myvars;
	array var_data;

	if( !is_command() ) return;

	if( !myvars = query("env", me) ) myvars = allocate_mapping(0);

	// ܥثe]w
	if( !arg || arg == "-l" )
	{
		msg = pnoun(2, me) + "ثe\]wܼƦpUG\n";
		foreach(var, var_data in ENV_VARS)
		{
			if( var_data[VAR_LEVEL] == LV_WIZARD && !wizardp(me) ) continue;

			if( arg != "-l" )
			{
				val = myvars[var];
				if( var_data[VAR_TYPE] == TYPE_BOOLEAN ) val = (val ? "O":"_");
				if( var_data[VAR_TYPE] == TYPE_STRING ) val = (val ? val:"]w");
			}
			else val = var_data[VAR_COMMENT];
			
			msg += sprintf(HIW BLK" ["HIW"%-|16s"BLK"]"NOR"\t\t -> " + val + "\n", var);
		}
		return tell(me, msg);
	}

	if( sscanf(arg, "%s %s", var, val) != 2 )
		return tell(me, "O榡~AаѦ help set HohϥθTC\n");

	if( var == "-d" )
	{
		var = val;
		val = "0";
	}

	if( undefinedp(var_data = ENV_VARS[var]) )
		return tell(me, "S " + var + " oܼơC\n");

	if( var_data[VAR_LEVEL] == LV_WIZARD && !wizardp(me) )
		return tell(me, "S " + var + " oܼơC\n");

	if( val != "0" && !regexp(val, var_data[VAR_REGEXP]) )
		return tell(me, var + " ܼƤ\ϥ " + val + " oӭȡC\n" );

	switch(var_data[VAR_TYPE])
	{
		case TYPE_BOOLEAN:
			val = to_int(val);
			val = (val ? 1:0);
			if( !val ) map_delete(myvars, var);
			else myvars[var] = val;
			val = (val ? "O":"_");
			break;
		case TYPE_INTEGER:
			val = to_int(val);
			if( !val ) map_delete(myvars, var);
			else myvars[var] = val;
			break;
		case TYPE_STRING:
			val = sprintf("%s", val);
			if( val == "0" ) map_delete(myvars, var);
			else myvars[var] = val;
			break;
		default:break;
	}

	if( !sizeof(myvars) ) myvars = 0;
	set("env", myvars, me);

	return tell(me, "ܼ " + var + " = " + val + " ]wC\n");
}
 
