/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : title.c
 * Author : Clode@RevivalWorld
 * Date   : 2005-01-02
 * Note   : title O
 * Update :
 *  o 2000-00-00
 *
 -----------------------------------------
 */

#include <daemon.h>
#include <feature.h>
#include <message.h>

inherit COMMAND;

string help = @HELP
    ٸ]wAbӤH֦SNN|oUص}ٸ
UدSƥΥȵG|oSٸ

	title		ܥثeҥΪٸ
	title -l	CXثeiHϥΪٸ
	title -d	ܥثeٸ
	title 'Ʀr'	]wQnܪٸ

HELP;

private void do_command(object me, string arg)
{
	string title = query("title", me);
	string *all_titles = query("all_titles", me);
    	
    	if( !arg )
    	{
    		if( !title )
    			return tell(me, pnoun(2, me)+"ثeS]wܥٸC\n");
    		
    		return tell(me, pnoun(2, me)+"ثeܪٸu"+title+"vC\n");
    	}
    	else if( arg == "-l" )
    	{
    		int i;
    		string msg;
    		
    		if( !arrayp(all_titles) || !sizeof(all_titles) )
    			return tell(me, pnoun(2, me)+"ثeSٸiHϥΡC\n");

    		msg = pnoun(2, me)+"ثeiHϥΪٸpUG\n";
		
		foreach( title in all_titles )
			msg += (++i)+". "+title+"\n";
			
		return tell(me, msg+"\n");
	}
	else if( arg == "-d" )
	{
		if( !title )
			return tell(me, pnoun(2, me)+"ثeS]wܥٸC\n");
			
		delete("title", me);
		return tell(me, pnoun(2, me)+"ܡu"+title+"vٸC\n");
	}
	else if( to_int(arg) )
	{
		int i, j = to_int(arg);
		
		if( j < 1 )
			return tell(me, "пJTƦrC\n");
			
    		if( !arrayp(all_titles) || !sizeof(all_titles) )
    			return tell(me, pnoun(2, me)+"ثeSٸiHϥΡC\n");
    
		foreach( title in all_titles )
		{
			if( ++i == j )
			{
				set("title", title, me);
				return tell(me, pnoun(2, me)+"]wnܪٸu"+title+"vC\n");
			}
		}
		return tell(me, "èS "+j+" ӽsٸC\n");
	}
	else if( wizardp(me) && find_player(arg) )
	{
		int i;
		string msg;
		object player = find_player(arg);
		
		all_titles = query("all_titles", player);
		
	    	if( !arrayp(all_titles) || !sizeof(all_titles) )
    			return tell(me, player->query_idname()+"ثeSٸiHϥΡC\n");
    		
    		msg = player->query_idname()+"ثeiHϥΪٸpUG\n";
		
		foreach( title in all_titles )
			msg += (++i)+". "+title+"\n";
			
		return tell(me, msg+"\n");
	}
	return tell(me, help+"\n");
}