/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : warning.c
 * Author : Clode@RevivalWorld
 * Date   : 2003-05-29
 * Note   : warning O
 * Update :
 *  o 2000-00-00  
 *
 -----------------------------------------
 */

#include <daemon.h>
#include <feature.h>
#include <ansi.h>
#include <message.h>

inherit COMMAND;

string help = @HELP
	warning [aid] [multi]
HELP;

private void command(object me, string arg)
{
	object target;
	string option;

	if( !is_command() ) return;

	if( !arg || sscanf(arg, "%s %s", arg, option) != 2 )
		return tell(me, pnoun(2, me)+"QnĵiơH\n", CMDMSG);
	
	if( !objectp(target = find_player(arg)) )
		return tell(me, "S "+arg+" oӤHC\n", CMDMSG);

	switch( option )
	{
		case "multi":
		{
			int indeed_multi;
			string target_ip = query_ip_number(target);

			foreach( object user in users() - ({ target }) )
				if( query_ip_number(user) == target_ip )
				{
					indeed_multi++;
					tell(target, BEEP+HIR+"\ntĵiG"+user->query_idname()+HIR"P"+pnoun(2, target)+" IP nJCAХߧYb}WDX(:ϥIPɾ)A_hNBH@hC\n\n"NOR, CMDMSG);
					tell(user, BEEP+HIR+"\ntĵiG"+target->query_idname()+HIR"P"+pnoun(2, user)+" IP nJCAХߧYb}WDX(:ϥIPɾ)A_hNBH@hC\n\n"NOR, CMDMSG);
				}
			
			if( indeed_multi )
			{
				tell(me, "weX"+target->query_idname()+"ۦP IP еnJĵiA@ "+(indeed_multi+1)+" ӬۦP IP еnJC\n", CMDMSG);
				CHANNEL_D->channel_broadcast("nch", me->query_idname()+"weX"+target->query_idname()+"ۦP IP еnJĵiA@ "+(indeed_multi+1)+" ӬۦP IP еnJC");
			}
			else
				tell(me, target->query_idname()+"õLеnJΡC\n", CMDMSG);
			break;
		}
		default:
			return tell(me, "пJTĵiﶵ(multi)C\n", CMDMSG);
	}
}
