/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : architectonic-large_b.c
 * Author : Clode@RevivalWorld
 * Date   : 2005-12-23
 * Note   : ؿvޯ
 * Update :
 *  o 2003-00-00  

 -----------------------------------------
 */

#include <ansi.h>
#include <inherit.h>
#include <skill.h>

#define BOOK_SKILL 	"architectonic-adv"
#define BOOK_EXP	10000
#define BOOK_LEVEL	"B"
#define BASE_SKILL	([ "architectonic" : 100 ])

inherit STANDARD_OBJECT;

mapping actions;

void do_readbook(object me, string arg)
{
	foreach(string skill, int level in BASE_SKILL)
	{
		if( me->query_skill_level(skill) < level )
			return tell(me, pnoun(2, me)+"u"+(SKILL(skill))->query_idname()+"v٤HΨAѡu"+(SKILL(BOOK_SKILL))->query_idname()+"vC\n");
	}

 	msg("$ME}l{uŪ_$YOUAu$MEŵM}Ԧ_IYAGqYoFܦhFC\n", me, this_object(), 1);

	tell(me, pnoun(2, me)+"oF "+BOOK_EXP+" Iu"+(SKILL(BOOK_SKILL))->query_idname()+"vgȡC\n");
	me->add_skill_exp(BOOK_SKILL, BOOK_EXP);
	
	msg("$YOUb$ME\ŪKƬHC\n", me, this_object(), 1);

	destruct(this_object(), 1);
}

void create()
{
	set_idname(HIG+(SKILL(BOOK_SKILL))->query_id()+NOR GRN" book "BOOK_LEVEL+NOR, HIG+(SKILL(BOOK_SKILL))->query_name()+NOR GRN"޳N "BOOK_LEVEL" "NOR);
	set_temp("status", HIC"}"NOR CYN"");

	if( this_object()->set_shadow_database() ) return;
	
	set("unit", "");
	set("mass", 300);
	set("value", 10000);
	set("badsell", 1);

	actions = ([ "readbook" : (: do_readbook :) ]);

}