/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : mine.c
 * Author : Sinji@RevivalWorld
 * Date   : 2005-04-10
 * Note   : apð
 * Update :
 *  o 2005-04-12 Sinji ﻼ^j
    o 2005-04-12 Clode ץܰD
    o 2005-04-13 Sinji ץ{Ĳv
 -----------------------------------------
 */
 
#include <ansi.h>
#include <daemon.h>
#include <inherit.h>
#include <secure.h>
#include <lock.h>

inherit STANDARD_OBJECT;

void do_join(object me, string arg);
void do_start(object me, string arg);
void do_show(object me, string arg);
void do_find(object me, string arg);
void do_finding(object me, int x, int y);
private void reset_mine();

// Oʧ@
nosave mapping actions = 	
([
	"join"			:	(: do_join :),
	"start"			:	(: do_start :),
	"show"			:	(: do_show :),
	"find"			:	(: do_find :),
	"reset"			:	(: reset_mine :),
]);
// ϤV
nosave mapping corresponding =
([
	"north"			:	"south",
	"south"			:	"north",
	"east"			:	"west",
	"west"			:	"east",
	"northwest"		:	"southeast",
	"northeast"		:	"southwest",
	"southwest"		:	"northeast",
	"southeast"		:	"northwest",
	"up"			:	"down",
	"down"			:	"up",
]);

// 
nosave string help = @HELP
apԪ-ϥλ

join			[JC
start			}lC
show			ܧGp
find <Xb> <Yb>	ȶ}Ӥ
reset			C
HELP;

nosave array mine_map;
nosave int total_mine = 0, finded_mine = 0;
nosave int map_size = 0;
nosave int player_turn = 0;
nosave object *players = allocate(0);


private int is_started()	// CO_}l
{
	return pointerp(mine_map);
}

private int valid_coordinate(int x, int y)	// ˬdyЬO_
{
	if( x < 0 || y < 0 || x >= sizeof(mine_map) || y >= sizeof(mine_map[0]) ) return 0;
	return 1;
}

private int valid_find(int x, int y)		// ˬdyЬO_wM
{
	if( mine_map[x][y] > 0 )return 0;
	return 1;
}

private int player_filter()	// Lowsba
{
	if( !is_started() ) return 0;

	players -= ({ 0 });
	if( !sizeof(players) )
	{
		reset_mine();
		return 1;
	}
	return 0;
}

private varargs void player_flying(object me, int i)
{
	mixed exit;
	mapping exits;
	object env;
	string arg;
	string my_idname, from;

	env = environment(me);
	my_idname = me->query_idname();

	if( !mapp(exits = query("exits", env)) || !sizeof(exits) ) return;

	if( i > 10 )
		return broadcast(env, my_idname+"FaWAåB½uFnXAG˪MC\n", 0, me);

	arg = keys(exits)[random(sizeof(exits))];
	exit = exits[arg];
	from = CHINESE_D->to_chinese(corresponding[arg]);
	if( functionp(exit) ) exit = evaluate(exit, me);

	// YOyХXf
	if( arrayp(exit) )
	{
		if( (MAP_D->query_map_system(exit))->query_coor_data(exit, "lock") & LOCKED && !wizardp(me) )
			return broadcast(env, my_idname+"FLӡAWF "+capitalize(arg)+" VC\n", 0, me);

		if( !wizardp(me) && (MAP_D->query_map_system(exit))->query_coor_data(exit, "lock") & WIZLOCKED )
			return broadcast(env, my_idname+"FLӡAWF "+capitalize(arg)+" VC\n", 0, me);
	}
	// YOW٥Xf
	else if( stringp(exit) )
	{
		if( query("lock/"+arg, env) & LOCKED && !wizardp(me))					   
			return broadcast(env, my_idname+"FLӡAWF "+capitalize(arg)+" VC\n", 0, me);

		if( !wizardp(me) && query("lock/"+arg, env) & WIZLOCKED )
			return broadcast(env, my_idname+"FLӡAWF "+capitalize(arg)+" VC\n", 0, me);
	}
	else return;

	broadcast(env, my_idname+""+(CHINESE_D->to_chinese(arg)||" "+capitalize(arg)+NOR" V")+"hC\n", 0, me);

	me->move(exit);

	if( from )
		broadcast(exit, my_idname+"q"+from+"FLӡC\n", 0, me);
	else
		broadcast(exit, my_idname+"FLӡC\n", 0, me);

	player_flying(me, i++);
}

private varargs object query_player(int i)	// dߥثe쪺a
{
	return players[(player_turn+i)%(sizeof(players)||1)];
}

private void next_player()	// U@쪱a
{
	object ob = query_player();

	if( player_filter() ) return;
	msg(CYN"\ni "HIC" " + (++player_turn) + " B$MEC\n\n"NOR, ob, 0, 1);
	tell(ob, "\a");
	do_show(ob, 0);
	return;
}

private void kick_player(object me, int x, int y)	// Xa
{
	mine_map[x][y] = 10;
	player_turn--;
	players -= ({ me });
	me->faint();
	player_flying(me);
	delete_temp("status", me);
	set_temp("status", HIY + sizeof(players) + " Hð"NOR);
	tell(me, HIY"\ni "YEL"CAAFC\n\n"NOR);
}

private void reset_mine()	// mC
{
	foreach(object ob in (players - ({ 0 })))
		delete_temp("status", ob);
	set_temp("status", HIY"ðI"NOR);
	mine_map = 0;
	player_turn = 0;
	players = allocate(0);
	msg(HIY"\ni "YEL"CC\n\n"NOR, this_object(), 0, 1);
}

private int allocate_mine(int width, int height, float ratio)
{
	int i, mine_count, x, y;

	if( ratio == 0 ) return 0;
	// إ߯x}
	mine_map = allocate(width);
	for(x=0; x<width; x++)
		mine_map[x] = allocate(height);

	// Htmu
	mine_count = width*height*ratio;
	i = mine_count;
	while(i > 0)
	{
		x = random(width);
		y = random(height);
		if( mine_map[x][y] == -1 ) continue;
		mine_map[x][y] = -1;
		i--;
	}
	return mine_count;
}
private int find_mine(int x, int y)
{
	array finding_queue = allocate(0);
	int mine_count;

	if( !valid_coordinate(x, y) ) return -2;
	if( mine_map[x][y] == -1 ) return 1;
	if( mine_map[x][y] > 0 ) return -1;

	finding_queue += ({ ({ x, y }) });
	while(sizeof(finding_queue))
	{
		array loc = finding_queue[0];
		x = loc[0];
		y = loc[1];
		finding_queue -= ({ loc });

		// ˬd|PO_ap
		mine_count = 0;
		for(int dx=-1; dx<=1; dx++)
			for(int dy=-1; dy<=1; dy++)
			{
				if( dx == 0 && dx == dy ) continue;
				if( !valid_coordinate(x+dx, y+dy) ) continue;
				if( mine_map[x+dx][y+dy] != -1
				 && mine_map[x+dx][y+dy] != 10 ) continue;
				//printf("%d %d has bomb\n", x + dx+1, y + dy+1); 
				mine_count++;
			}

		// Oapƶq
		if( mine_map[x][y] <= 0 )
		{
			mine_map[x][y] = 1 + mine_count;
			finded_mine++;
		}

		// YLaph۰ʮi}
		if( mine_count != 0 ) continue;
		for(int dx=-1; dx<=1; dx++)
			for(int dy=-1; dy<=1; dy++)
			{
				if( dx == 0 && dx == dy ) continue;
				if( !valid_coordinate(x+dx, y+dy) ) continue;
				if( mine_map[x+dx][y+dy] > 0 ) continue;
				finding_queue += ({ ({ x+dx,y+dy }) });
			}
	}
	return 0;
}

void do_join(object me, string arg) 
{
	if( sizeof(players) >= 10 )
		return tell(me, "xywAеyAӡC\n");

	if( is_started() )
		return tell(me, "Cw}lAШϥ show O[ԡC\n");

	if( member_array(me, players) != -1 )
		return tell(me, "zw[JCFAШϥ start O}lCC\n");

	msg("$MEqfUǥX 2 TҳѵLXNiF$YOUC\n", me, this_object(), 1);
	tell(me, HIC"YawAYiϥ start O}lCC\n"NOR);

	players += ({ me });
	set_temp("status", HIY"ðI (" + sizeof(players) + " H)"NOR);
}

void do_start(object me, string arg)
{
	int i, max_x, max_y;
	
	if( member_array(me, players) == -1 )
		return tell(me, "zåѥ[CAШϥ join O[JCC\n");
	if( is_started() )
		return tell(me, "Cwg}lAШϥ find OӴMapC\n");

	set_temp("status", HIY + sizeof(players) + " Hð"NOR);
	msg(YEL"\ni "HIY"apC}lC\n\n"NOR, me, 0, 1);

	max_x = 8 + sizeof(players);
	max_y = 8 + sizeof(players);
	map_size = max_x * max_y;

	msg(CYN"i "HIC"Hͦa "+max_x+"x"+max_y+"...\n"NOR, me, 0, 1);
	total_mine = allocate_mine(max_x, max_y, (random(20)+15)/100.0);

	msg(CYN"i "HIC"wtmap@ "+total_mine+" T...\n"NOR, me, 0, 1);
	msg(CYN"i "HIC"ѻlYXC ...\n"NOR, me, 0, 1);

	player_filter();
	i = sizeof(players);
	msg(CYN"i "HIC"@ " + i + " 쪱a: \n"NOR, me, 0, 1);
	msg(CYN"i "NOR, me, 0, 1);
	while(i)
	{
		object ob = players[random(i)];

		set_temp("status", HIY""NOR YEL"ap"NOR, ob);
		msg(HIC + (sizeof(players)-i+1) + ". " + ob->query_idname() + HIC", "NOR, me, 0, 1);
		players -= ({ ob });
		players += ({ ob });
		i--;
	}
	msg(CYN"\ni "HIC"пJ help mine d߫OΪkC\n"NOR, me, 0, 1);
	msg(HIY"\ni "YEL"Cؼ: ׶}Ҧi঳apaIC\n"NOR, me, 0, 1);

	next_player();
}
void do_show(object me, string arg)
{
	string msg = "Gp (@ " + total_mine + " Tu, Ѿl " + (map_size-finded_mine) + " ӦaI):\n";
	int flag = 0;

	if( !is_started() )
		return tell(me, "C|}lAШϥ start O}lCC\n");

	if( wizardp(me) && arg == "mines" ) flag = 1;

	

	msg += WHT"Y"HIW"\\"NOR + WHT"X";
	for(int i=0; i<sizeof(mine_map); i++)
		msg += sprintf("%s%2d"NOR, (i%2==0 ? HIW:WHT), i+1);
	msg += "\n"NOR;

	for(int y=0; y<sizeof(mine_map[0]); y++)
	{
		int hcenter = sizeof(mine_map[0])/2;

		msg += sprintf("%s%2d "NOR, (y%2==0 ? HIW:WHT), y+1);
		for(int x=0; x<sizeof(mine_map); x++)
		{
			string symbol;
			switch(mine_map[x][y]-1)
			{
			
			case -2:	if( flag ) { symbol = HBWHT + HIR""NOR; break; }
			case -1:	//if( (x+y)%2 == 0 )
						symbol = HBWHT + WHT""NOR;
					//else	symbol = BBLU + HIW""NOR;
					break;
			case  0:	symbol = NOR"  "NOR;		break;
			case  1:	symbol = HIB""NOR;		break;
			case  2:	symbol = HIG""NOR;		break;
			case  3:	symbol = HIR""NOR;		break;
			case  4:	symbol = HIY""NOR;		break;
			case  5:	symbol = HIC""NOR;		break;
			case  6:	symbol = HIW""NOR;		break;
			case  7:	symbol = HIW""NOR;		break;
			case  8:	symbol = HIW""NOR;		break;
			case  9:	symbol = HIR""NOR;		break;
			default:	symbol = sprintf(HIW"%2d "NOR, mine_map[x][y]-1);
			}
			msg += sprintf("%2s", symbol);
		}
		msg += sprintf(HIG" %s%-2d "NOR, (y%2==0 ? HIW:WHT), y+1);

		if( y == hcenter-2 )
			msg += "ثe " + query_player()->query_idname();
		if( y == hcenter )
			msg += "U@ " + query_player(1)->query_idname();
		msg += "\n";
	}

	msg += HIW"   ";
	for(int i=0; i<sizeof(mine_map); i++)
		msg += sprintf("%s%2d"NOR, (i%2==0 ? HIW:WHT), i+1);
	msg += "\n"NOR;

	tell(me, msg);	
}
void do_find(object me, string arg)
{
	int x, y;

	if( !is_started() )
		return tell(me, "C|}lAШϥ start O}lCC\n");

	if( me != query_player() )
		return tell(me, "{b٨SAC\n");

	if( !arg || sscanf(arg, "%d %d", x, y) != 2 )
		return tell(me, "OЦ: find <> <C>\n");

	if( !valid_coordinate(x-1, y-1) )
		return tell(me, "yФwWXaϽdC\n");
	if( !valid_find(x-1, y-1) )
		return tell(me, "oӮyФwgLFC\n");

	msg("$MEpllN}BV " + sprintf("%d, %d", x, y) + " yФW ...\n", me, 0, 1);
	call_out((: do_finding :), 1, me, x, y);
	
}
void do_finding(object me, int x, int y)
{
	int res;

	player_filter();	// ˬdaO_sb

	res = find_mine(x-1, y-1);
	if( res < 0 ) return;
	if( res )
	{
		switch(random(2))
		{
		case 0: msg("$ME}UGS򲧪C\n", me, 0, 1); break;
		case 1: msg(HIR"\n$MEapFII\n\n"NOR, me, 0, 1); break;
		}
		msg("MTuIv@nAu$MEQ@ζ¬ĤWݡC\n", me, 0, 1);

		kick_player(me, x-1, y-1);

		CHANNEL_D->channel_broadcast("news",
			sprintf("%s@}apUAuIv@nTAu@ζ¬ĤWݡC\n", me->query_idname()));
		if( sizeof(players) == 1 )
		{
			msg(HIY"\n$MEap!!\n\n"NOR, query_player(), 0, 1);
			reset_mine();
		}
		else next_player();
	}
	else
	{
		switch(random(2))
		{
		case 0: msg("$ME}UGS򲧪C\n", me, 0, 1); break;
		case 1: msg("$ME}UGnoͤơAS򳣨So͡C\n", me, 0, 1); break;
		}
		if( sizeof(players) == 1 && map_size == (total_mine + finded_mine) )
		{
			msg(HIY"\n$MEap!!\n\n"NOR, me, 0, 1);
			reset_mine();
		}
		else next_player();
	}
	return;
}

void heart_beat()
{
	player_filter();
}
void create()
{
	set_idname("mine game",HIC"ap"NOR CYN"Ԫ"NOR);
	set("flag/no_amount", 1);
	set("long", help);
	set("unit", "x");
	set("mass", -1);
	reset_mine();
	set_heart_beat(10);
}