/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : mj.h
 * Author : Clode@RevivalWorld
 * Date   : 
 * Note   : INCLUDE file
 * Update :
 *  o 2000-00-00  
 *
 -----------------------------------------
 */

#define DATA_PATH	"/data/object/mj112.o"
#define MJAI_FILE 	"/obj/etc/mj/mjai.c"

#define VERSION 	"1.13"

// @
#define BASEMONEY	10000
// @x
#define BONUSMONEY	4000

// Score Index
#define SCORE		0
#define ROUNDS		1
#define WINTIMES	2
#define GUNTIMES	3
#define BONUSES 	4
#define HUMYSELVES	5
#define LOSEBONUSES	6
#define LOSETIMES	7

// MJtile Index
#define CHINESE 	0
#define AMOUNT		1
#define COLOR1		2
#define COLOR2		3

// MJdata Index
#define PLAYING 	0	//C
#define TURN		1	//
#define DUMPED		2	//P
#define DUMPING 	3	//P
#define MO		4	//NP
#define CHEAT		5	//BJ
#define TILELIMIT	6	//yi
#define ROUND		7	//`ƭp
#define MROUND		8	//ƭp
#define WINNER		9	//WĹa
#define HUMYSELF	10	//ۺN
#define HUFIRST 	11	//ѭJ
#define NINEYOUNGS	12	//E\EM
#define LOSER		13	//j
#define CMASTER 	14	//s
#define ROUNDWIND	15	//魷
#define OPENDOOR	16	//}
#define FINISH		17	//@
#define CFINISH 	18	//
#define KEYTILE 	19	//P
#define LISTENING	20	//ťP
#define ONLOOKER	21	//[

// Pdata Index
#define PLAYER		0	//
#define ID		1	//ID
#define IDNAME		2	//W
#define TILE		3	//DP
#define OTILE		4	//P
#define FLOWER		5	//P
#define AUTOPON 	6	//۰ʸI
#define AUTOGON 	7	//۰ʺb
#define AUTOHU		8	//۰ʭJ
#define LISTEN		9	//ťP
#define TAILTILE	10	//N
#define LOOKSEA 	11	//ݮ
#define SECRETGON	12	//tb
#define MONEY		13	//wX
#define PLISTEN 	14	//۰ťP
#define LISTENTYPE	15	//ťPA
#define AUTOOFF 	16	//۰
#define FLOWERNUM	17	//P
#define LOOKALL 	18	//ݥ
#define AI		19	//AIa
#define PDUMPED		20	//ӤHLP

// Psort Index
#define MASTER		0	//a

#define TITLE_SCREEN_LENGTH	14
#define Dsort	({ "F","n","","_" })
#define Tsort	({ "1w","2w","3w","4w","5w","6w","7w","8w","9w","1s","2s","3s","4s","5s","6s","7s","8s","9s","1t","2t","3t","4t","5t","6t","7t","8t","9t","ea","so","we","no","ba","jo","fa","f1","f2","f3","f4","f5","f6","f7","f8", })
