/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : rice seedlings.c
 * Author : Clode@RevivalWorld
 * Date   : 2005-09-09
 * Note   : _
 * Update :
 *  o 2000-00-00
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <inherit.h>
#include <nature.h>
#include <map.h>

inherit STANDARD_OBJECT;

void create()
{
	set_idname("rice seedling","_");

	if( this_object()->set_shadow_ob() ) return;

	set("long","i@@몺DC\n");
	set("unit", "");
	set("mass", 10);	// q
	set("value", 3);	// 
	set("badsell", 1);

	// ؤlT
	set("growth",
	([
		//
		"type":		FARM,

		//W
		"idname":	this_object()->query_idname(),
		
		//خɪT
		"start_msg":"_aGЦaA@YYVaPıC\n" ,
			
	       	//Cؤlί]ݭnƼƶq
	       	"material":
	       	([
	       		"/obj/materials/water":5,
	       	]),
			
	       	//β~ƶq]wP~|
	       	"harvest":
	       	([
	       		"/obj/farming/product/rice":50,
	       	]),

		//ήɪT
		"harvest_msg":"$MEwߦaγo_СC\n",

		//شӦ~һݭnޯP䵥
		"skill":
		([
			"farming":0,
		]),

		//ɪT
		"growing":
		([
			5:	"_ФWpp]wgjFC\n",
			50:	"u_Ф@NsMARFͮC\n",
			150:	"_ФW_̤wgFC\n",
			250:	"u@⪺_СAwgΦA@FA@ߵ@}lKiHΡC\n",
			300:	"oAФW_̤wgFAשiHΤFC\n",
		]),
	
		// ѮvTԭz
		"weather":
		([
			SNOWY:	"jssYϱo_@a\FC\n",
			SHOWER:	"sӪBqϱo@ǽ_@wGFC\n",
			TYPHOON:"䭷ŧϱo_@Qjdy_C\n",
			FOEHN:	"Ijŧ_@ֳt\C\n",
		]),
	]));
}
