/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : enterprise.c
 * Author : Clode@RevivalWorld
 * Date   : 2006-02-08
 * Note   : ~
 * Update :
 *  o 2000-00-00
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <inherit.h>
#include <feature.h>
#include <equipment.h>
#include <buff.h>
#include <daemon.h>

inherit STANDARD_OBJECT;
inherit EQUIPMENT;

mapping actions;

void fire_process(object me, object target, int combo, int sec)
{
	if( sec == 0 )
	{
		int damage;
		for(int i=0;i<combo;i++)
		{
			damage = range_random(15, 35);
			msg("$YOUQ$MEog 12 }CAɭP "HIR+damage+NOR" ͩRˮ`("NOR GRN+target->query_health_cur()+NOR"/"HIG+target->query_health_max()+NOR")C\n", me, target, 1);

			if( !target->cost_health(damage) )
				target->faint();
		}

		delete_temp("delay/fire");
	}
	else
	{
		msg("Z 12 }C$YOU٦ "+sec+" ...\n", me, target, 1);
		call_out((: fire_process, me, target, combo, sec-1 :), 1);
	}
}

void fire(object me, string arg)
{
	int combo = random(11)+1;
	object target = find_player(arg) || present(arg);

	if( !me->is_equipping_object(this_object()) )
		return tell(me, pnoun(2, me)+"˳"+this_object()->query_idname()+"C\n");

	if( query_temp("delay/fire") > time() )
		return tell(me, "ZLksogAеݪZtΧNoC\n");

	if( !objectp(target) )
		return tell(me, "S "+arg+" oӤHC\n");

	for(int i=0;i<combo;i++)
		msg("$MEa"+this_object()->query_idname()+"$YOUog 12 }C("HIY+combo+NOR YEL" so"NOR")C\n", me, target, 1);
	set_temp("delay/fire", time() + 5);
	call_out((: fire_process, me, target, combo, 5 :), 1);
}

void shield(object me, string arg)
{
	if( !me->is_equipping_object(this_object()) )
		return tell(me, pnoun(2, me)+"˳"+this_object()->query_idname()+"C\n");

	if( !query_temp("shield/on") )
	{
		msg("$MEҰ"+this_object()->query_idname()+"۰ʽW@ntΡC\n", me, 0, 1);
		set_temp("status", HIR"(@n)"NOR);
		set_temp("shield/on", 1);
	}
	else
	{
		msg("$ME"+this_object()->query_idname()+"۰ʽW@ntΡC\n", me, 0, 1);
		delete_temp("status");
		delete_temp("shield/on");
	}
}

void antimatter_process(object me, object target, int sec)
{
	if( sec == 0 )
	{
		msg("$YOUQ$MEұҰʪϪ贲fAɭP "HIR+1000000+NOR" ͩRˮ`("NOR RED+"-1000000"+NOR"/"HIG+target->query_health_max()+NOR")C\n", me, target, 1);

		target->faint();

		if( userp(target) )
			LOGOUT_D->quit(target);

		delete_temp("delay/antimatter");
	}
	else
	{
		msg("ZϪ贲fEq٦ "+sec+" ...\n", me, target, 1);
		call_out((: antimatter_process, me, target, sec-10 :), 10);
	}
}

// Ϫ贲f
void antimatter(object me, string arg)
{
	object target = find_player(arg) || present(arg);

	if( !me->is_equipping_object(this_object()) )
		return tell(me, pnoun(2, me)+"˳"+this_object()->query_idname()+"C\n");

	if( query_temp("delay/antimatter") > time() )
		return tell(me, "ZLksogAеݪZtΧNoC\n");

	if( !objectp(target) )
		return tell(me, "S "+arg+" oӤHC\n");

	msg("$MEa"+this_object()->query_idname()+"$YOU}ҤϪ贲fC\n", me, target, 1);
	set_temp("delay/antimatter", time() + 60);
	call_out((: antimatter_process, me, target, 60 :), 1);
}

void create()
{
	set_idname(HIC"arc"NOR CYN"an"HIW"gel"NOR, HIC"j"NOR CYN"Ѩ"HIW"");
	set_temp("status", HIY""NOR YEL"");

	actions = ([
	    "fire" : (: fire :),
	    "shield" : (: shield :),
	    "antimatter": (: antimatter :),
	]);

	if( this_object()->set_shadow_ob() ) return;

	set("long", @LONG
  tƶWt檺tPھŲA֦⪺O
  
    Z
      11  12 }CA`Xq 8 U 5 d
      1 ӰtqlpޡA˳ 50 Tqlp
      4  4 sopޡA`@˳Ʀ 250 Tp
      Ϫ贲fC
  
    m
      ۰ʽW@ntΡA`eq 459 UJ
      G׽ƦXKPT׽ƦXKh~ߡA[W 10 ̪ܿNk˥
      ŵcO@ޡC 
  
    tO
      `覱t 8 
      t覱t 9.9 
      ̤jOOHt 9.99  24 pɡC   
   
    tӪ
    t()     t(C 299,792,458 /)
    [1;37m1            [1;30m1
    [1;37m2            [1;30m8
    [1;37m3            [1;30m27
    [1;37m4            [1;30m64
    [1;37m5            [1;30m125
    [1;37m6            [1;30m216
    [1;37m7            [1;30m343
    [1;37m8            [1;30m512
    [1;37m9            [1;30m729      
    [1;37m10           [1;30m1000
    [1;37m11           [1;30m1331
    [1;37m12           [1;30m1728
    [1;37m13           [1;30m2197
    [1;37m14.1         [1;30m2803.221  [0m
LONG
	);

	set("unit", "");
	set("mass", 0);
	set("value", 12000000);
	set("flag/no_amount", 1);

	set(BUFF_STR, 100);
	set(BUFF_PHY, 100);
	set(BUFF_INT, 100);
	set(BUFF_AGI, 100);
	set(BUFF_CHA, 100);

	set(BUFF_STAMINA_MAX, 100);
	set(BUFF_HEALTH_MAX, 100);
	set(BUFF_ENERGY_MAX, 100);

	set(BUFF_STAMINA_REGEN, 100);
	set(BUFF_HEALTH_REGEN, 100);
	set(BUFF_ENERGY_REGEN, 100);

	set(BUFF_LOADING_MAX, 100);
	set(BUFF_FOOD_MAX, 100);
	set(BUFF_DRINK_MAX, 100);

	set(BUFF_SOCIAL_EXP_BONUS, 100);
	
	set("buff/status", HIC"j"NOR CYN"Ѩ"HIW"");

	::setup_equipment(EQ_MOUNT, HIG"r"NOR GRN"p"NOR);
}
