/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : _condition_liv.c
 * Author : Clode@RevivalWorld
 * Date   : 2003-03-04
 * Note   : A
 * Update :
 *  o 2000-00-00  
 *
 -----------------------------------------
 */

// ߰ݪA
nomask int in_condition(string condition_file)
{
	return mapp(query("condition/"+replace_string(condition_file, "/","#")));
}

// ҰʪA, 1 
varargs nomask void start_condition(string condition_file, int time, int heart_beat)
{
	mapping condition_setup = allocate_mapping(0);

	// YwgbۦPAheA
	if( in_condition(condition_file) )
		condition_file->stop_effect(this_object());

	// ]wAɶΨϥιw]ɶ
	if( !undefinedp(time) && time > 0 )
		condition_setup["time"] = time;
	else
		condition_setup["time"] = condition_file->query_default_condition_time();
		
	// ]wA߸ɶΨϥιw]߸ɶ
	if( !undefinedp(heart_beat) && heart_beat > 0 )
		condition_setup["heart_beat"] = heart_beat;
	else
		condition_setup["heart_beat"] = condition_file->query_default_condition_heart_beat();

	set("condition/"+replace_string(condition_file, "/","#"), condition_setup);
	
	// 檬AҰʮɪĪG
	condition_file->start_effect(this_object());
}


// A
nomask void stop_condition(string condition_file)
{
	delete("condition/"+replace_string(condition_file, "/","#"));
	
	// 檬AɪĪG
	condition_file->stop_effect(this_object());
}

// ܪAɶ
nomask void change_condition_time(string condition_file, int time)
{
	if( !in_condition(condition_file) ) return;
		
	addn("condition/"+replace_string(condition_file, "/","#")+"/time", time);
}

// ^ǪA
varargs nomask mapping query_condition(string condition_file)
{
	if( undefinedp(condition_file) )
		return query("condition");

	return query("condition/"+replace_string(condition_file, "/","#"));
}
