/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : selfcharge.c
 * Author : Clode@RevivalWorld
 * Date   : 2006-02-09
 * Note   : 
 * Update :
 *  o 2000-00-00  

 -----------------------------------------
 */
 
#include <ansi.h>
#include <buff.h>

#define CONDITION_ID		"selfcharge"
#define CONDITION_NAME		HIY"ۧ"NOR YEL"R"NOR
#define CONDITION_TYPE		"["
#define DEFAULT_TIME		(3*60*60)
#define DEFAULT_HEART_BEAT	0

// ^ǪA^W
string query_condition_id()
{
	return CONDITION_ID;
}

// ^ǪAW
string query_condition_name()
{
	return CONDITION_NAME;
}

// ^ǪAAW
string query_condition_type()
{
	return CONDITION_TYPE;
}

// ^ǪAw]ɶ
int query_default_condition_time()
{
	return DEFAULT_TIME;
}

// ^ǪAw]߸ɶ
int query_default_condition_heart_beat()
{
	return DEFAULT_HEART_BEAT;
}

// ҰʪAɪĪG
void start_effect(object ob)
{
	string condition_key = "condition/"+replace_string(base_name(this_object()), "/","#")+"/";

	set(condition_key+BUFF_SOCIAL_EXP_BONUS, 2, ob);
	set(condition_key+BUFF_STAMINA_MAX, 50, ob);
	set(condition_key+BUFF_HEALTH_MAX, 50, ob);
	set(condition_key+BUFF_ENERGY_MAX, 50, ob);

	msg("$MEiJu"CONDITION_NAME"v"CONDITION_TYPE"AC\n", ob, 0, 1);
}

// AɪĪG
void stop_effect(object ob)
{
	msg("$MEu"CONDITION_NAME"v"CONDITION_TYPE"AC\n", ob, 0, 1);
}

// Ai椤ĪG
void heart_beat_effect(object ob)
{


}
