/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : labor.c
 * Author : Clode@RevivalWorld
 * Date   : 2003-05-03
 * Note   : HOЩҪ
 * Update :
 *  o 2000-00-00  
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <map.h>
#include <feature.h>
#include <message.h>
#include <daemon.h>
#include <citydata.h>
#include <gender.h>
#include <object.h>

inherit ROOM_ACTION_MOD;

#define LABOR_RENT	"100000"

#define LABOR_ID	"ID"
#define LABOR_IDNAME	"IDNAME"
#define LABOR_AGE	"AGE"
#define LABOR_SKILLS	"SKILLS"

// ΤHO
void do_hire(object me, string arg)
{
	int num, i;
	object newnpc;
	object env = environment(me)->query_master();
	int leadership_level;
	int leadership_adv_level;
	string money_unit = env->query_money_unit();

	if( !arg )
		return tell(me, "CӤHOжOݭn "HIY+money(money_unit, LABOR_RENT)+NOR"C\n"+pnoun(2, me)+"QnΥsHO(Boy/Girl)HάOΦg窺HO(list C)H\n");

	arg = lower_case(arg);

	leadership_level = me->query_skill_level("leadership");
	leadership_adv_level = me->query_skill_level("leadership-adv");
	
	if( sizeof(query("hirelabors", me)) >= (leadership_level + leadership_adv_level)/5 )
		return tell(me, pnoun(2, me)+"ثeɯO̦huන "+ ((leadership_level + leadership_adv_level)/5)+" HC\n");

	if( !me->spend_money(money_unit, LABOR_RENT) )
		return tell(me, pnoun(2, me)+"SΤHOFC\n");

	switch(arg)
	{
	case "b":
	case "boy":
		newnpc = load_object("/npc/"+SERIAL_NUMBER_D->query_serial_number("labor"));
		set("gender", MALE_GENDER, newnpc);
		set("birthday", TIME_D->query_game_time(), newnpc);
		newnpc->set_idname("poor boy", "Laikpk");
		break;
	case "g":
	case "girl":
		newnpc = load_object("/npc/"+SERIAL_NUMBER_D->query_serial_number("labor"));
		set("gender", FEMALE_GENDER, newnpc);
		set("birthday", TIME_D->query_game_time(), newnpc);
		newnpc->set_idname("poor girl", "Laikpk");
		break;
	default:
		if( (num = to_int(arg)) > 0 )
		{
			foreach( string file, array info in LABOR_D->query_labors() )
			{
				if( ++i == num )
				{
					newnpc = load_object(file);
					break;
				}	
			}

			if( !objectp(newnpc) )
				return tell(me, "пJTsC\n");
			else
				LABOR_D->remove_labor(base_name(newnpc));
		}
		else
			return tell(me, pnoun(2, me)+"QnΨk٬Ok(Boy/Girl)άOJ list sH\n");
	}


	set("boss", me->query_id(1), newnpc);

	newnpc->save();
	newnpc->move_to_environment(me);

	msg("$MEF "HIY+money(money_unit, LABOR_RENT)+NOR" ΤF@ӤHOAu$YOUwwqᨫFXӡC\n", me, newnpc, 1);
	newnpc->do_command("follow "+me->query_id(1));
	newnpc->do_command("say "+me->query_name()+HIG"@NΧڡAڤ@w|nnƪ...\n"NOR);

	set("hirelabors", (query("hirelabors", me)||({})) | ({base_name(newnpc)}), me);
	set("hired", count(query("hired", env), "+", 1), env);

	env->save();
	log_file("command/hire", sprintf("%s hired %O\n", me->query_id(1), newnpc));
}

private void confirm_fire(object me, object npc, string arg)
{
	if( lower_case(arg) == "n" || lower_case(arg) == "no" )
	{
		int suicide;
		string basename;
		string idname;

		msg("$MEF@nDGs"+pnoun(2, npc)+"uSťIHڥs"+pnoun(2, npc)+"uoII\n", me, 0, 1);
		npc->do_command("cry");
		msg("$YOUˤ߱ai"+query("short", environment(me))+"Ab$MEeC\n", me, npc, 1);

		// iJ LABOR_D ݨLH
		LABOR_D->add_labor(npc);

		basename = base_name(npc);
		idname = npc->query_idname();

		// NPC ۱, û
		if( (query("relationship/"+me->query_id(1), npc) > 500 && random(5)) || !random(10) )
			suicide = 1;

		log_file("command/fire", sprintf("%s fired %O\n", me->query_id(1), npc ));

		npc->move(VOID_OB);
		destruct(npc);
		me->save();
		me->finish_input();

		if( suicide )
		{	
			broadcast(environment(me), 
			    HIY"uťjf~MǨӸH̪IA"+idname+HIY"qBӳFUӡA۱FC\n"
			    "u"+idname+HIY"Wۤ@ig"HIR""NOR RED""HIY"rAgFXӦrGuڤ|Ǧ󪺡A@Oڦۤvn...vC\n"NOR
			);

			LABOR_D->remove_labor(basename);
			rm(basename+".o");
		}

	}
	else
	{
		msg("$MEDGnaIN"+pnoun(2, npc)+"~bڨǧaI\n", me, 0, 1);
		npc->do_command("jump");
		npc->do_command("say 󪺤jjwڥû|ѰOI^_^");
		me->finish_input();
	}
}

// }HO
void do_fire(object me, string arg)
{
	object npc;

	if( !arg )
		return tell(me, pnoun(2, me)+"Qn}֡H\n");

	if( !objectp(npc = present(arg, environment(me))) )
		return tell(me, "ǫS "+arg+" oӤHC\n");

	if( !npc->is_living() )
		return tell(me, pnoun(2, me)+"Qn}"+npc->query_idname()+"HᱼO֡H\n");

	if( query("boss", npc) != me->query_id(1) )
		return tell(me, npc->query_idname()+"äOAΪHOC\n");

	msg("$MEhJ$YOUDG"+pnoun(2, npc)+"aAڤwgAݭn"+pnoun(2, npc)+"FC\n", me, npc, 1);
	npc->do_command("sob");
	npc->do_command("say DD"+pnoun(2, me)+"I~b"+pnoun(2, me)+"ǰƦnܡHSou@ڬUhI");
	tell(me, "\nn~dU"+npc->query_idname()+""+pnoun(2, me)+"u@ܡH(Yes/No)");
	set_this_player(me);
	input_to((:confirm_fire, me, npc:));
}

void do_list(object me, string arg)
{
	int i, skill_num;
	int total_skill_level;
	string msg, skill;
	mapping skills, data;
	object ob;
	mapping labors = LABOR_D->query_labors();

	if( !sizeof(labors) )
		return tell(me, "ثeS󦳸g窺HOiHΡC\n");

	if( arg && (i = to_int(arg)) && i > 0 && i <= sizeof(labors) )
	{
		foreach(string file, mapping info in labors)
		{
			if( !(--i) )
			{
				ob = load_object(file);
				msg = COMMAND_D->find_command_object("score")->score_standard(ob);
				msg += COMMAND_D->find_command_object("skill")->skill_list(me, ob);
				
				me->more(msg);
				return;
			}
		}
	}
	
	i = 0;

	msg =  NOR WHT"wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww\n"NOR;
	msg +=        "s HOW                         ʧO ޯ `X nD~()\n";
	msg += NOR WHT"wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww\n"NOR;

	foreach( string file, mapping info in labors )
	{
		ob = load_object(file);

		skills = query("skills", ob);

		skill_num = 0;
		total_skill_level = 0;
		if( mapp(skills) )
		foreach( skill, data in skills )
		{
			skill_num++;

			total_skill_level += data["level"];
		}
		msg += sprintf("%-3d. %-33s"HIW" %s  "HIG"%-6d"HIC" %-9d"HIY"$%s\n"NOR, ++i, ob->query_idname(), query("gender", ob)==1?"k":"k", skill_num, total_skill_level, NUMBER_D->number_symbol(SALARY_D->query_labor_salary(ob)));
	}

	msg += NOR WHT"wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww\n"NOR;
	msg += HIW"list 's' "NOR WHT"d߸ԲݩʻPޯ\n"NOR;

	me->more(msg);
}
// ]wؿvжA
nosave mapping action_info =
([
    "lobby"	:
    ([
	"short"	: NOR GRN"Щ"NOR,
	"help"	:
	([
	    "topics":
@HELP
    ЩҴѤu@P԰HOѵC
HELP,

	    "hire":
@HELP
ΤHOOAΪkpUG
  hire boy		- Τ@skʤHO
  hire girl		- Τ@skʤHO
  hire 2		- νs 2 wsbHO
HELP,

	    "fire":
@HELP
}HOOAΪkpUG
  fire john		- NWls john HO}
HELP,

	    "list":
@HELP
CXثewsbHOAΪkpUG
  list			- CXҦثewsbLHΪHO
  list 's'		- d߸ӤHOݩʻPޯ
HELP,
	]),
	"action":
	([
	    "hire"		: (: do_hire :),
	    "fire"		: (: do_fire :),
	    "list"		: (: do_list :),
	]),
    ]),
]);


// ]wؿv
nosave array building_info = ({

    // ؿvW
    HIG"HOЩ"NOR

    // }iؿv̤֩ж
    ,1

    // ̤jۦPؿvƶq(0 N)
    ,0

    // ؿvؿv, GOVERNMENT(F), ENTERPRISE(~), INDIVIDUAL(pH)
    ,GOVERNMENT

    // ؿviؿvϰ, AGRICULTURE_REGION(A~), INDUSTRY_REGION(u~), COMMERCE_REGION(ӷ~)
    ,AGRICULTURE_REGION | INDUSTRY_REGION | COMMERCE_REGION

    // }iO
    ,"5000000"

    // ؿvռаO
    ,0

    // ca^m
    ,20

    // ̰i[\Ӽh
    ,1

    // ̤jۦPؿvƶq(0 N)
    ,0

    // ؿvɥN
    ,1
});
