/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : trading_post.c
 * Author : Clode@RevivalWorld
 * Date   : 2002-4-13
 * Note   : ۥѶRҰʧ@~Ӫ
 * Update :
 *  o 2000-00-00  
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <map.h>
#include <daemon.h>
#include <feature.h>
#include <message.h>

inherit ROOM_ACTION_MOD;

inherit __DIR__"inherit/_object_database_mod.c";
inherit __DIR__"inherit/_action_list";
inherit __DIR__"inherit/_action_buy";
inherit __DIR__"inherit/_action_sell";

#define TRADING_POST_CAPACITY	-1

nosave mapping allowable_trade = 
([

	"A@":
		({
			"/obj/farming/seed/rice_seedling", "-1",
			"/obj/farming/seed/herbage_seed", "-1",
			"/obj/farming/seed/barley_seed", "-1",
			"/obj/farming/seed/corn_seed", "-1",
			"/obj/farming/seed/rose_seed", "-1",
			"/obj/farming/seed/sunflower_seed", "-1",
			"/obj/farming/seed/lily_seed", "-1",
		}),
	"":
		({
			"/obj/pasture/breed/chicken_stud", "-1",
			"/obj/pasture/breed/pig_stud", "-1",
			"/obj/pasture/breed/sheep_stud", "-1",
			"/obj/pasture/breed/horse_stud", "-1",
			"/obj/pasture/breed/cattle_stud", "-1",
			"/obj/pasture/breed/deer_stud", "-1",
		}),
	"i":
		({
			"/obj/fishfarm/breed/clam", "-1",
			"/obj/fishfarm/breed/young_crab", "-1",
			"/obj/fishfarm/breed/young_shrimp", "-1",
		}),
	"":
		({
			"/obj/fishing/rod/toy_rod", "-1",
			"/obj/fishing/rod/bamboo_rod", "-1",
			"/obj/fishing/rod/wood_rod", "-1",
			"/obj/fishing/rod/plastic_rod", "-1",
			"/obj/fishing/rod/carbon_fiber_rod", "-1",
			"/obj/fishing/rod/microelectronic_rod", "-1",
			"/obj/fishing/bait/bread_bug", "-1",
			"/obj/fishing/bait/prawn", "-1",
			"/obj/fishing/bait/tsou_chip", "-1",
			"/obj/fishing/bait/worm", "-1",
		}),
	"Ķ":
		({
			"/obj/collection/tool/coarse_pickax", "-1",
			"/obj/collection/tool/coarse_drill", "-1",
			"/obj/collection/tool/coarse_bucket", "-1",
			"/obj/collection/tool/coarse_saw", "-1",
			"/obj/collection/tool/coarse_shovel", "-1",
			
		}),
	"L":
		({
                        "/obj/etc/newspaper", "-1",
                        "/obj/etc/firework", "-1",
                        "/obj/systemproducts/flatbed_tricycle", "-1",
		}),

]);

// ]wؿvжA
nosave mapping action_info =
([
	"lobby"	:
	([
		"short"	: HIW"RjU"NOR,
		"help"	:
			([
"topics":
@HELP
    RjUOaʶRPcӫ~aAѩOѬF}]Aȷ|HVaʰӫ~C
HELP,

"list":
@HELP
CXҦc椤ӫ~OAΪkpUG
  list			- CXҦc椤ӫ~
HELP,

"buy":
@HELP
ʶRӫ~OAΪkpUG
  buy all rice			- RUҦ rice ӫ~
  buy 3 rice			- RU 3  rice ӫ~
  buy rice			- RU 1  rice ӫ~
  buy 3 2			- RU 3 s 2 ӫ~
  buy 2				- RU 1 s 2 ӫ~
  buy rice to center 1 51,22	- RU 1  rice ӫ~ðeF center  1 ìPy(51,22)Bؿv
HELP,

"sell":
@HELP
cӫ~OAΪkpUG
  sell all		- XҦWic檺ӫ~
  sell all rice		- XҦ rice ӫ~
  sell 3 rice		- X 3  rice ӫ~
HELP,
			]),
		"action":
			([
				//"sell"		: (: do_trading_post_sell($1, $2, 50) :),
				"list"		: (: do_list($1, $2, "products", TRADING_POST_CAPACITY) :),
				"buy"		: (: do_buy($1, $2, "products", "GOVERNMENT") :),
			]),
	]),
]);


// ]wؿv
nosave array building_info = ({
	
	// ؿvW
	NOR YEL"y"NOR

	// }iؿv̤֩ж
	,1

	// ̤jۦPؿvƶq(0 N)
	,0

	// ؿvؿv, GOVERNMENT(F), ENTERPRISE(~), INDIVIDUAL(pH)
	,GOVERNMENT

	// ؿviؿvϰ, AGRICULTURE_REGION(A~), INDUSTRY_REGION(u~), COMMERCE_REGION(ӷ~)
	,AGRICULTURE_REGION | INDUSTRY_REGION | COMMERCE_REGION

	// }iO
	,"5000000"
	
	// ؿvռаO
	,0

	// ca^m
	,10
	
	// ̰i[\Ӽh
	,1
	
	// ̤jۦPؿvƶq(0 N)
	,0
	
	// ؿvɥN
	,1
});
