/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : university.c
 * Author : Clode@RevivalWorld
 * Date   : 2003-05-31
 * Note   : j
 * Update :
 *  o 2000-00-00  
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <map.h>
#include <feature.h>
#include <message.h>
#include <daemon.h>
#include <npc.h>
#include <skill.h>
#include <condition.h>

inherit ROOM_ACTION_MOD;

#define CLASS_UNIT	10000
#define MSGTITLE	HIM"W-"NOR


void do_list(object me, string arg)
{
	string skill_type;
	string list="";
	object skillob, env = environment(me);
	string *skills = SKILL_D->query_sorted_skills();
	string course = query("course", env);
	
	list += WHT"wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww\n"NOR;
	
	if( course )
		list += "ثeҵ{G"HIY+(SKILL(course))->query_idname()+"\n"NOR;
	else
		list += "ثeS}]ҵ{\n";

	list += WHT"wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww\n"NOR;
	list += "ҵ{                    ǲ W a u ҵ{²\n";
	
	foreach(string skill in skills)
	{
		if( !SKILL_D->skill_exists(skill) )
		{
			skill_type = skill;		
			continue;
		}
		
		skillob = load_object(SKILL(skill));
		
		if( !objectp(skillob) ) continue;
	
		if( skillob->self_learning() ) continue;

		if( skill_type )
		{
			list += "- "+skill_type+" -\n";
			skill_type = 0;
		}

		list += sprintf("%-36s"WHT"%4.1f"HIY" %4d "NOR" %2s   %2s  %s"NOR"\n"NOR
			    ,skillob->query_idname()
			    ,1/(skillob->exp_multiple(me))
			    ,skillob->max_level(me)

			    ,skillob->allowable_learn() & PLAYER_SKILL ? ( skillob->allowable_learn(me) ? HIW : HIR)+""NOR : WHT""NOR
			    ,skillob->allowable_learn() & NPC_SKILL ? HIW""NOR : WHT""NOR
			    ,skillob->query_skill_note()||"L");
	}
	list += WHT"wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww\n"NOR;
	list += "                                      "HIW""NOR"GiǲߡB"HIR""NOR"Giǲߦ{ץB"WHT""NOR"GLkǲ\n\n"NOR;
	
	me->more(list);
}



void do_setup(object me, string arg)
{
	object env = environment(me);
	string course = query("course", env);

	if( query("owner", env)[11..] != query("enterprise", me) )
		return tell(me, pnoun(2, me)+"äO~C\n");

	if( !arg )
		return tell(me, "пJTO榡C\n");

	if( sscanf(arg, "course %s", course) == 1 )
	{
		if( course == "-d" )
		{
			msg("$MEoЫǪҵ{]wC\n", me, 0, 1);
			delete("course", env);
			env->save();
			return;
		}
		
		if( !SKILL_D->skill_exists(course) || (SKILL(course))->self_learning() )
			return tell(me, "èS "+course+" oؽҵ{C\n");
		
		msg("$MENoЫǪҵ{]wu"+(SKILL(course))->query_idname()+"vC\n", me, 0, 1);
		set("course", course, env);
		env->save();
	}
	else
		return tell(me, "пJTO榡C\n");
}


void confirm_learn(object me, string skill, int socialexp, string moneyunit, int is_member, string input)
{
	int bonus;
	string msg = "";

	if( input && (lower_case(input) == "y" || lower_case(input) == "yes") )
	{
		switch(random(50))
		{
			case 0:
			{
				bonus = socialexp/100;
				msg = MSGTITLE"ѮvۯbªOWVg۽ƾǤ...C\n";
				msg += MSGTITLE HIC"$ME֯ӶO 1% |g("+bonus+")III\n"NOR;
				
				break;
			}
			case 1:
			{
				bonus = socialexp/50;
				msg = MSGTITLE"Ѯv}MqOWŬaF@UAoˤƤ]So...C\n";
				msg += MSGTITLE HIC"$ME֯ӶO 2% |g("+bonus+")III\n"NOR;
				
				break;
			}
			case 2:
			{
				msg = MSGTITLE"$MEFӤpȹΩѮvIᰪtghAuѮv⻴@ۡAŧL...C\n";
				break;
			}
			case 3:
			{
				bonus = socialexp/33;
				msg = MSGTITLE"ѮvNNaDGu"+me->query_idname()+pnoun(2, me)+"Ӧ^oӰDCv\n";
				msg += MSGTITLE"$MEy@ܰWDGu...Ѯv藍_Aڨ餣ΪAQR...Cv\n";
				msg += MSGTITLE HIC"$ME֯ӶO 3% |g("+bonus+")III\n"NOR;
				
				break;
			}
			case 4:
			{
				msg = MSGTITLE"$MEΦbWAѤWyFfGuI...I...I...vC\n";
				break;
			}
			case 5:
			{
				msg = MSGTITLE"$MEbĤ@ƪyWɦaյ۰ݤkѮvȩC\n";
				break;
			}
			case 6:
			{
				msg = MSGTITLE"Ыǥ~ɦaǨӡGuN׺...nYN׺o...vC\n";
				break;
			}
			case 7:
			{
				msg = MSGTITLE"ЫǸ̶ǨӰ}}死Au$MECYDbF...C\n";
				break;
			}
			case 8:
			{
				msg = MSGTITLE"$MEⲴèbaHۼgOAQ$MEۤv]ݤOgFǤC\n";
				break;
			}
			case 9:
			{
				bonus = socialexp/33;
				msg = MSGTITLE"ѮvGu"+me->query_idname()+"ڰ"+pnoun(2, me)+"A1+1 h֡Hv\n";
				msg += MSGTITLE"$MEiyyɻP_ӡGuoDڲש|FA׬O 11 C\n";
				msg += MSGTITLE HIC"$ME֯ӶO 3% |g("+bonus+")III\n"NOR;
				break;
			}
			case 10:
			{
				bonus = socialexp/20;
				msg = MSGTITLE"$MEhaGuqAѮvAo̱пFաA쩳ڤnñСCv\n";
				msg += MSGTITLE"ѮvGu"+me->query_idname()+pnoun(2, me)+"ηQ~F...v\n";
				msg += MSGTITLE HIC"$ME֯ӶO 5% |g("+bonus+")III\n"NOR;
				break;
			}
			case 11:
			{
				bonus = socialexp/10;
				msg = MSGTITLE"$ME]aGuѮvpnAn]nnťCv\n";
				msg += MSGTITLE"kѮv`ۦaGu"+me->query_idname()+"PǤdUOo򻡡AL"+pnoun(2, me)+"o즨ZN|o캡Cv\n";
				msg += MSGTITLE HIC"$ME֯ӶO 10% |g("+bonus+")III\n"NOR;
				break;
			}
			case 12:
			{
				bonus = socialexp/33;
				msg = MSGTITLE"ѮvGu"+me->query_idname()+"Pǥ'ֳQ'y@ӥylCv\n";
				msg += MSGTITLE"$MEGuekPǪåʹֳQڰFCv\n";
				msg += MSGTITLE HIC"$ME֯ӶO 3% |g("+bonus+")III\n"NOR;
				break;
			}
			case 13:
			{
				msg = MSGTITLE"$MEMЫǪfĥhC\n";
				msg += MSGTITLE"ѮvGu"+me->query_idname()+pnoun(2, me)+"WҤW@bnhIگIv\n";
				msg += MSGTITLE"$MEGuHbڰө[lWFIIv\n";
				msg += MSGTITLE"ѮvGu...v\n";
				break;
			}
			case 14:
			{
				msg = MSGTITLE"ѮvGu"+me->query_idname()+"Pǥ'Mud'y@ӥylCv\n";
				msg += MSGTITLE"$MEGunnںıCv\n";
				break;
			}
			case 15:
			{
				bonus = socialexp/50;
				msg = MSGTITLE"Ѯv_QꪺIWï|DGuoOֶðŪIHv\n";
				msg += MSGTITLE"$ME۰ŤM۹j}PǡGuLCv\n";
				msg += MSGTITLE"j}P٥ӱoΤwgQѮvšC\n";
				msg += MSGTITLE HIC"$ME֯ӶO 2% |g("+bonus+")III\n"NOR;
				break;
			}
		
		}

		if( !me->cost_social_exp(socialexp-bonus) )
		{
			tell(me, pnoun(2, me)+"S|gȨӧ@oǲߡC\n");
			return me->finish_input();
		}

		me->add_skill_exp(skill, socialexp);

		msg(msg+"$MEӶO "HIG+(socialexp-bonus)+NOR" I|gȨӾǲߡu"HIY+(SKILL(skill))->query_idname()+NOR"vC\n", me, 0, 1);
		me->finish_input();
	}
	else
	{
		tell(me, pnoun(2, me)+"Mwǲ߳oޯC\n");
		me->finish_input();
	}
}

void do_learn(object me, string arg)
{
	int is_member;
	int socialexp;
	string skill;
	object skillob;
	object env = environment(me);
	string moneyunit = env->query_money_unit();

	skill = query("course", env);

	if( !skill )
		return tell(me, "oЫǨèS}]ҵ{C\n");
	
	if( !SKILL_D->skill_exists(skill) || (SKILL(skill))->self_learning() )
		return tell(me, "èS "+skill+" oؽҵ{C\n");

	skillob = load_object(SKILL(skill));

	if( !arg || (!sscanf(arg, "%d", socialexp) && arg != "full") )
		return tell(me, "пJTO榡C\n");

	if( arg == "full" )
	{
		socialexp = to_int((skillob->level_exp(skillob->max_level(me)) - me->query_skill_exp(skill))/skillob->exp_multiple(me));

		if( socialexp < 1 )
			return tell(me, pnoun(2, me)+"u"HIY+skillob->query_idname()+NOR"vޯ൥ŤwgF̤jȡC\n");
	}
	
	if( socialexp < 1 || socialexp > 100000000 )
		return tell(me, "ӶO|gȥ 1  100,000,000 ("+socialexp+")C\n");

	if( !skillob->allowable_learn(me) )
		return tell(me, skillob->query_idname()+""+pnoun(2, me)+"ӨӹL}`C\n");
		
	if( me->query_skill_level(skill) >= skillob->max_level(me) )
		return tell(me, pnoun(2, me)+""+skillob->query_idname()+"wgF̰ŤFC\n");

	is_member = query("owner", env)[11..] == query("enterprise", me);
	
	tell(me, pnoun(2, me)+"ǳƯӶO "HIG+NUMBER_D->number_symbol(socialexp)+NOR" I|gȨӾǲߡu"HIY+skillob->query_idname()+NOR"vC\nO_Twnǲ(Yes/No)H\n");	

	input_to( (: confirm_learn, me, skill, socialexp, moneyunit, is_member :) );
}



void leave(object room, object me)
{
	me->stop_condition(KNOWLEDGESANCTUARY);
}

void init(object room, object me)
{
	if( query("function", room) == "classroom" )
	{
		if( !me->in_condition(KNOWLEDGESANCTUARY) )
			me->start_condition(KNOWLEDGESANCTUARY);
	}
}

string look_room(object room)
{
	string course = query("course", room);
	
	if( query("function", room) == "classroom" )
	{
		if( !course )
			return "ثeS}]ҵ{C\n"NOR;
		else if( !SKILL_D->skill_exists(course) )
		{
			delete("course", room);
			return "ثeS}]ҵ{C\n"NOR;
		}
		else
			return "ѮvbxWѵ"HIY+(SKILL(course))->query_idname()+NOR"ҵ{C\n"NOR;
	}
}

// ]wؿvжA
nosave mapping action_info =
([
	"classroom"	:
	([
		"short"	: NOR HIW"Ы"NOR,
		"help"	: 
			([ 
"topics":
@HELP
    o̬OjǤ@ЫǡC
HELP,

"list":
@HELP
d߽ҵ{O
  list			- CXҦҵ{T
HELP,

"setup":
@HELP
Ыǽҵ{]wO
  setup course water	- ]wЫǱMб²MĶ(Water)ҵ{
  setup course -d	- ҵ{]w
HELP,

"learn":
@HELP
ǲ߫O
  learn full		- ۰ʭpǲߨ̰ũһݪ|g
  learn 20000		- ӶO 20,000 I|gȨӾǲ߳oЫǩҶ}]ҵ{
                          ǶOCH 10,000 |gӭp
HELP,
			]),

		"heartbeat":0,	// ڮɶ 1 
		"job": 0,
		"action":
			([
			
				"list" 		: (: do_list :),
				"learn"		: (: do_learn :),
				"setup"		: (: do_setup :),
			]),
	]),
]);

// ]wؿv
nosave array building_info = ({
	
	// ؿvW
	HIM"j"NOR

	// }iؿv̤֩ж
	,12

	// ̤jۦPؿvƶq(0 N)
	,5

	// ؿvؿv, GOVERNMENT(F), ENTERPRISE(~), INDIVIDUAL(pH)
	,ENTERPRISE

	// ؿviؿvϰ, AGRICULTURE_REGION(A~), INDUSTRY_REGION(u~), COMMERCE_REGION(ӷ~)
	,AGRICULTURE_REGION

	// }iO
	,"20000000"
	
	// ؿvռаO
	,0

	// ca^m
	,0
	
	// ̰i[\Ӽh
	,3
	
	// ̤jۦPؿvƶq(0 N)
	,0
	
	// ؿvɥN
	,1
});
