/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : ppl_login_d.c
 * Author : Clode@RevivalWorld
 * Date   : 2000-12-29
 * Note   : anF
 * Update :
 *  o 2001-02-09 Clode R port k, i@ǵ{gk
 *  o 2001-07-20 Clode g repeat login id ˬd
 *
 -----------------------------------------
 */

#include <ip.h>
#include <ansi.h>
#include <login.h>
#include <daemon.h>
#include <object.h>
#include <secure.h>
#include <gender.h>
#include <mudlib.h>
#include <message.h>
#include <ip.h>

#define INITIALIZE		1
#define INPUT_ID		2
#define INPUT_PASSWORD		3
#define INPUT_NEW_ID		4
#define INPUT_NEW_NAME		5
#define INPUT_NEW_PASSWORD	6
#define CONFIRM_PASSWORD	7
#define INPUT_EMAIL		8
#define INPUT_GENDER		9
#define RECONNECT		10
#define NEW_PLAYER		11
#define OLD_PLAYER		12
#define ENTER_GAME		13
#define FPASS_ID		14
#define FPASS_EMAIL		15

mapping newchar = allocate_mapping(0);
private nosave mapping ip_time = allocate_mapping(0);
private mapping login_ip_num = allocate_mapping(0);
string *reserved_id = ({  });

nomask void reset_newchar()
{
	newchar = allocate_mapping(0);	
}

nomask void reset_cmdlimit()
{
	login_ip_num = allocate_mapping(0);
}

mapping query_loginip()
{
	return login_ip_num;
}

// FW 30 N]w banip 24 p
private void set_user_cmdlimit( string ip )
{
	// A check @
	if( login_ip_num[ip] >= 30 )
	{	
		if( !(IP_D->query_ip(ip)) )
		{
			IP_D->set_ip( this_object(), ip, BAN, 24*3600);
			IP_D->set_ip_note( this_object(), ip, "P ip @ Login WL 30 ");
		}
	}
}

private nomask varargs void logon_handle(int state, object ob, string arg)
{
	ob->reset_time_out(); // ]Time_outɶ

	if( arg && query("encode/gb", ob) ) arg = G2B(arg);

	switch(state)
	{
		/* ҩl Login */
	case INITIALIZE:
		{
			string ip = query_ip_number(ob), ban;

			foreach(string limitedip, mapping data in IP_D->query_ipdata())
			if( regexp(ip, limitedip) && data["status"] == BAN )
			{
				ob->directly_receive(HIR"\nĵiAzҨϥΪ IP("+limitedip+") mثeQtΦCTnJC\n"NOR);
				CHANNEL_D->channel_broadcast("nch", ip+" ϥΪ̹ըϥγQT IP nJ");
				destruct(ob);
				return;
			}

			if(sscanf( query_ip_name(ob), "%*s.%s.edu.tw", ban )==2)
			{
				if( ban == "cyut" )
				{
					tell( ob, sprintf( HIR"\nĵiAzҨϥΪ IP(%s) mثeQtΦCTnJC\n"NOR, query_ip_number(ob)));
					destruct(ob);
					return;
				}	
			}

			if(sscanf( query_ip_name(ob), "%*s.%*s.%s.edu.tw", ban )==3)
			{
				if( ban == "cyut" )
				{
					tell( ob, HIR"\nĵiAzҨϥΪ IP(%s) mثeQtΦCTnJC\n"NOR, query_ip_number(ob));
					destruct(ob);
					return;
				}	
			}			


			if( time() - ip_time[ip] < 60 )
			{
				tell(ob, sprintf( HIY"su IP ZeWuɶȹj %d ,  %d AաC\n"NOR, time() - ip_time[ip], 60 + ip_time[ip] - time()));
				CHANNEL_D->channel_broadcast("nch", ip +" ϥΪW login ɶLu, ڵnJ !");
				destruct(ob);
				return;
			} 

			ob->directly_receive("Current charset is " + (query("encode/gb", ob) ? "Simplified Chinese (GB)":"Traditional Chinese (BIG5)") + "\n");
			ob->directly_receive("Please input GB/BIG5 to change charset or directly login user.\n");

			tell(ob, sprintf(
				"гysCпJ 'new'C%s\n"
				"z^WrG",
				(LOGIN_D->query_wiz_lock() < GUEST ? HIC"(\anJ)"NOR:HIR"(TanJ)"NOR)));

			input_to( (: logon_handle, INPUT_ID, ob :) );
			return;
		}
		/* J ID */
	case INPUT_ID:
		{	
			int level_num;

			if( !arg || arg == "" )
				return logon_handle(INITIALIZE, ob);

			arg = remove_ansi(remove_fringe_blanks(lower_case(arg)));

			if( arg == "gb" )
			{
				set("encode/gb", 1, ob);
				return this_object()->logon(ob);
			}
			else if( arg == "big5" )
			{
				delete("encode/gb", ob);
				return this_object()->logon(ob);
			}

			if( arg == "new" && LOGIN_D->query_wiz_lock() < GUEST )
			{
				string ip = query_ip_number(ob);

				if( ip == "75.84.17.242" )
				{
					tell(ob, "pzҨϥΪ ip ALkAUsC\n");
					return logon_handle(INITIALIZE, ob);
				}
				
				if( query_ip_name(ob)[<13..] == "csupomona.edu" ) 
				{
					tell(ob, "pzҨϥΪ ip ALkAUsC\n");
					return logon_handle(INITIALIZE, ob);
				}
				
				if( ++newchar[ip] >= 5 )
				{
					CHANNEL_D->channel_broadcast("sys", "nJG"+ip+" ϥΪ̥swUWL "+5+" ALkAUsC");
					tell(ob, "pzswUWL "+5+" ALkAUsC\n");
					return logon_handle(INITIALIZE, ob);
				}

				tell(ob, "пJzQϥΪ^IDG");
				input_to( (: logon_handle, INPUT_NEW_ID, ob :) ); return;
			}
			if( arg == "pass" )
			{
				tell(ob, "пJz^IDG");
				input_to( (: logon_handle, FPASS_ID, ob :) ); return;
			}

			level_num = SECURE_D->level_num(arg);

			if( sizeof(users()) > MAX_USERS && level_num < GUEST )
			{
				tell(ob, "pCaWuHƤ̤jW "+MAX_USERS+" AЭ@ߵԡC\n");
				return logon_handle(INITIALIZE, ob);
			}

			if( level_num < LOGIN_D->query_wiz_lock() )
			{
				tell(ob, HIY"tΧs@AثeȤ\vb "+SECURE_D->level_num_to_level_name(LOGIN_D->query_wiz_lock())+" HWϥΪ̳suC\n"NOR);
				return logon_handle(INITIALIZE, ob);
			}

			if( file_size(user_data(arg)) <= 0 )
			{
				tell(ob, "CS "+arg+" o쪱aC\n");
				return logon_handle(INITIALIZE, ob);
			}

			if( LOGIN_D->is_repeat_login(arg) )
			{
				tell(ob, "pzJ "+capitalize(arg)+" bQnAФŭеnC\n");
				return logon_handle(INITIALIZE, ob);
			}
			else
				set("id", arg, ob);

			if( level_num > PLAYER )
				tell(ob, "zϥΪv "+SECURE_D->level_num_to_level_name(level_num)+"Azѳs "+WIZ_PORT+" Wu~֦ŮvvC\n");

			tell(ob, "пJKXG");

			input_to( (: logon_handle, INPUT_PASSWORD, ob :), 1 );
			return;           
		}
	case FPASS_ID:
		{
			tell(ob, "ӪAȩ|ҥΡC");
			destruct(ob);
			return;

			if( file_size(user_data(arg)) <= 0 )
			{
				tell(ob, "CS "+arg+" o쪱aC\n");
				return logon_handle(INITIALIZE, ob);
			}
			set("id", arg, ob);
			tell(ob, "пJӨ⪺HcmG");
			input_to( (: logon_handle, FPASS_EMAIL, ob :) ); return;
		}
	case FPASS_EMAIL:
		{
			object user_ob = load_user(query("id", ob));
			if( query("email", user_ob) == arg )
			{
				tell(ob, "tΤwNsKX Email ܱzHcC\n");
				SMTP_D->mail(arg, "ӪAȩ|ҥ", "ͪ@ - "+query("id", ob)+" KX");
			}
			else tell(ob, "zJƸӨ⤣šC\n");
			destruct(user_ob);
			destruct(ob);
			return;
		}
		/* JKX */
	case INPUT_PASSWORD:
		{
			string password = PASSWORD_D->query_password(query("id", ob));

			if( !arg || crypt(arg, password) != password )
			{
				tell(ob, "KXJ~C\n");

				if( LOGIN_D->input_wrong_password(ob) >= 3 )
				{
					tell(ob, "AwgJ~KXTAЭsnJAաC\n");
					destruct(ob); return;
				}

				tell(ob, "пJTKXG");
				input_to( (: logon_handle, INPUT_PASSWORD, ob :), 1 ); return;
			}

			// YbCۦP ID ϥΪ̪
			if( find_player(query("id", ob)) )
			{
				object player = find_player(query("id", ob));
				set("player", player , ob);

				// Yʪ, h߰ݬO_N
				if( interactive(player) )
				{
					tell(ob, "AQNثebCۦPH(Y/N)H\n");
					input_to( (: logon_handle, RECONNECT, ob :) );
					return;
				}

				logon_handle(RECONNECT, ob, "y");return;
			}

			/* KXˬdT, iJC */
			return logon_handle(OLD_PLAYER, ob);
		}

		/* Js ID */
	case INPUT_NEW_ID:
		{
			int len;
			string ban;

			if( sscanf( query_ip_name(ob), "%*s-%*s-%*s-%*s.dynamic.%s.net", ban ) ==5 ) 
			{
				if( ban == "hinet" )
				{
					tell( ob, sprintf(HIR"\nĵiAzҨϥΪ IP(%s) mثeQtΦCTnsC\n"NOR, query_ip_number(ob)));
					destruct(ob);
					return;
				}			
			}

			if( sscanf( query_ip_name(ob), "%*s-%*s-%*s-%*s..HINET-IP.%s.net", ban ) ==5 ) 
			{
				if( ban == "hinet" )
				{
					tell( ob, sprintf(HIR"\nĵiAzҨϥΪ IP(%s) mثeQtΦCTnsC\n"NOR, query_ip_number(ob)));
					destruct(ob);
					return;
				}			
			}

			if(sscanf( query_ip_name(ob), "%*s.%s.edu.tw", ban )==2)
			{
				if( ban = "cyut" )
				{
					tell( ob, HIR"\nĵiAzҨϥΪ IP(%s) mثeQtΦCTnsC\n"NOR, query_ip_number(ob));
					destruct(ob);
					return;
				}	
			}
			
			if(sscanf( query_ip_name(ob), "%*s.%*s.%s.edu", ban )== 3)
			{
				if( ban = "csupomona" )
				{
					tell( ob, HIR"\nĵiAzҨϥΪ IP(%s) mثeQtΦCTnsC\n"NOR, query_ip_number(ob));
					destruct(ob);
					return;
				}	
			}
			
			if( !arg || arg == "" )
			{
				tell(ob, "пJzQϥΪ^N(ID)G");
				input_to( (: logon_handle, INPUT_NEW_ID, ob :) ); return;
			}

			len = strlen((arg = lower_case(arg)));

			if( (len = strlen(arg)) < 3 || len > 12 )
			{
				tell(ob, "藍_AA^Wru 3  12 ӦrC\nпJzQϥΪ^N(ID)G");
				input_to( (: logon_handle, INPUT_NEW_ID, ob :) );return;
			}

			foreach( string a in arg )
			if( (int) a<'a' || (int) a>'z' ) 
			{
				tell(ob, "藍_AA^Wruέ^rC\nпJzQϥΪ^N(ID)G");
				input_to( (: logon_handle, INPUT_NEW_ID, ob :) );return;
			}

			if( member_array(arg, reserved_id) != -1 )
			{
				tell(ob, " ID tΫOdrAдt@ӦWrC\nпJzQϥΪ^N(ID)G");
				input_to( (: logon_handle, INPUT_NEW_ID, ob :) );return;
			}

			if( file_size(user_data(arg)) > 0 )
			{
				tell(ob, "Cwaϥ "+capitalize(arg)+"Aдt@ӦWrC\nпJzQϥΪ^N(ID)G");
				input_to( (: logon_handle, INPUT_NEW_ID, ob :) );return;
			}

			if( LOGIN_D->is_repeat_login(arg) )
			{
				tell(ob, "pzID:"+capitalize(arg)+"bnJAФŭеnJC\n");
				return logon_handle(INITIALIZE, ob);
			}
			else
				set("id", arg, ob);


			tell(ob, "пJzW(Name)G");
			input_to( (: logon_handle, INPUT_NEW_NAME, ob :) );
			return;
		}

		/* JsW */
	case INPUT_NEW_NAME:
		{
			int len;
			if( !arg || (len=strlen(arg)) < 2 || len > 12 )
			{
				tell(ob, "zJ 1  12 ӦrG");
				input_to( (: logon_handle, INPUT_NEW_NAME, ob :) ); return;
			}

			if( strsrch(arg, "@") != -1 || strsrch(arg, " ") != -1 )
			{                	
				tell(ob, "ФťΪŮӷW١C\nпJW١G");
				input_to( (: logon_handle, INPUT_NEW_NAME, ob :) ); return;
			}

			foreach( int a in arg )
			{
				if( a <= ' ' )
				{
					tell(ob, "zW٤αrC\nпJW(Name)G");
					input_to( (: logon_handle, INPUT_NEW_NAME, ob :) );return;
				}
			}

			set("name", arg, ob);

			tell(ob, "w"+arg+"("+capitalize(query("id", ob))+")iJ"MUD_FULL_NAME"C\n");
			tell(ob, "пJzQϥΪKXG");
			input_to( (: logon_handle, INPUT_NEW_PASSWORD, ob :), 1 );
			return;	
		}

		/* JsKX */        
	case INPUT_NEW_PASSWORD:
		{
			if( !arg || strlen(arg) < 4 )
			{
				tell(ob, "пJh|ӦrKXG");
				input_to( (: logon_handle, INPUT_NEW_PASSWORD, ob :), 1 );return;
			}

			set("password", crypt(arg, 0), ob);
			tell(ob, "ЦAJ@zKXR");
			input_to( (: logon_handle, CONFIRM_PASSWORD, ob :), 1 );
			return;
		}

		/* AT{KX */
	case CONFIRM_PASSWORD:
		{
			if( !arg || crypt( arg, query("password", ob) ) != query("password", ob) )
			{
				tell(ob, "T{KXѡC\nЭsJzQϥΪKXG");
				input_to( (: logon_handle, INPUT_NEW_PASSWORD, ob :), 1 );return;
			}

			PASSWORD_D->set_password(query("id", ob), query("password", ob));

			tell(ob, "zHc}N@ƥɮת̾ڡAΪ Enter JC\nzHc}G");
			input_to( (: logon_handle, INPUT_EMAIL, ob :) ); return;
		}

		/* ]wEMAIL */
	case INPUT_EMAIL:
		{
			if( !arg || arg=="" )
				tell(ob, "z@N~ॢɡAVŮvӽгƥɮתvQC\n");
			else if( sscanf(arg,"%*s@%*s.%*s") != 3 )
			{
				tell(ob, "Hc}榡DC\nЭsJzHc}G");
				input_to( (: logon_handle, INPUT_EMAIL, ob :) ); return;
			}
			else set("email", arg, ob);

			tell(ob, "пܱzʧOAk(M)Bk(F)R");
			input_to( (: logon_handle, INPUT_GENDER, ob :) ); return;
		}
		/* ]wʧO */
	case INPUT_GENDER:
		{
			if( arg == "m" || arg == "M" ) 
				set("gender", MALE_GENDER, ob);
			else if( arg == "f" || arg == "F" ) 
				set("gender", FEMALE_GENDER, ob);
			else
			{
				tell(ob, "пJ M άO FC\nпܱzʧOAk(M)Bk(F)R");
				input_to( (: logon_handle, INPUT_GENDER, ob :) );return;
			}

			return logon_handle(NEW_PLAYER, ob);
		}	

		/* san */
	case NEW_PLAYER:
		{
			object user_ob = load_object(user_file_name(query("id", ob)));

			/*ഫƨxs*/
			user_ob->set_idname(query("id", ob), query("name", ob));

			set("email", query("email", ob), user_ob);
			set_temp("login/ident", query("ident", ob), user_ob);
			set_temp("login/remoteport", query("remote_port", ob), user_ob);
			set_temp("login/terminaltype", query("terminaltype", ob), user_ob);
			set_temp("windowsize", query("windowsize", ob) || DEFAULT_WINDOW_SIZE, user_ob);

			if( query("encode/gb", ob) )
				set("encode/gb", 1, user_ob);
			else
				delete("encode/gb", user_ob);

			set_temp("new_player", 1, user_ob);

			exec( user_ob, ob );

			CHAR_D->create_char(user_ob, query("gender", ob));

			user_ob->save();

			destruct(ob);

			return logon_handle(ENTER_GAME, user_ob);
		}

		/* ªan */
	case OLD_PLAYER:
		{
			object user_ob = load_user(query("id", ob));

			if( !objectp(user_ob) )
			{
				object login_ob = new(LOGIN_OB);

				tell(ob, "LkJ "+capitalize(query("id", ob))+" xsɡApŮvBzC\n");
				exec(login_ob, ob);
				destruct(ob);
				logon_handle(INITIALIZE, login_ob);return;
			}

			set_temp("login/ident", query("ident", ob), user_ob);
			set_temp("login/remoteport", query("remote_port", ob), user_ob);
			set_temp("login/terminaltype", query("terminaltype", ob), user_ob);
			set_temp("windowsize", query("windowsize", ob) || DEFAULT_WINDOW_SIZE, user_ob);

			if( query("encode/gb", ob) )
				set("encode/gb", 1, user_ob);
			else
				delete("encode/gb", user_ob);

			//  LOGIN_OB  USER_OB
			exec( user_ob , ob );
			destruct(ob);

			return logon_handle(ENTER_GAME, user_ob);
		}

		/* ssu */
	case RECONNECT:
		{
			object reconnect_ob;

			if( !arg || remove_ansi(remove_fringe_blanks(lower_case(arg))) != "y" )
			{
				tell(ob, "zMwNCۦPHC\n");
				ob->reset_database();

				logon_handle(INITIALIZE, ob);return;
			}

			if( !objectp(reconnect_ob = query("player", ob)) )
			{
				tell(ob, "쥻CHwgAЭsnJC\n");
				ob->reset_database();
				logon_handle(INITIALIZE, ob);return;
			}

			if( !interactive(reconnect_ob) )
				reconnect_ob->reconnect();
			else
			{
				object temp = new(VOID_OB);

				tell(reconnect_ob, "t~@ϥΪ̦ "+query_ip_name(ob)+" suNFAC\n");

				/* N쥻aഫܤ@ӼȮ USER_OB ANR */
				exec(temp, reconnect_ob);
				destruct(temp);
			}

			set_temp("reconnect", 1, reconnect_ob);
			set_temp("login/ident", query("ident", ob), reconnect_ob);
			set_temp("login/remoteport", query("remote_port", ob), reconnect_ob);
			set_temp("windowsize", query("windowsize", ob) || DEFAULT_WINDOW_SIZE, reconnect_ob);
			set_temp("login/terminaltype", query("terminaltype", ob), reconnect_ob);

			if( query("encode/gb", ob) )
				set("encode/gb", 1, reconnect_ob);
			else
				delete("encode/gb", reconnect_ob);

			/* N user_ob */
			exec( reconnect_ob , ob );
			destruct(ob);

			delete_temp("new_player", reconnect_ob);

			return logon_handle(ENTER_GAME, reconnect_ob);
		}

		/* iJC */
	case ENTER_GAME:
		{
			// O ip Wuɶ
			string ip = query_ip_number(ob);
			ip_time[ip] = time();
			
			// O ip Wu
			if( !login_ip_num[ip] )
				login_ip_num[ip] = 1;
			else
			if( login_ip_num[ip] >= 30 )
			{
				login_ip_num[ip] = 30;
				set_user_cmdlimit(ip);
			} else
				login_ip_num[ip] = ( login_ip_num[ip] + 1 );
			
			// iJC
			LOGIN_D->enter_game(ob);
			return;

		}/* ENTER_GAME */

	default: return logon_handle(INITIALIZE, ob);

	}/* END SWITCH */

}

void wait_for_login(object login_ob, string arg)
{
	tell(login_ob, "JAеy ...\n");
	input_to( (: wait_for_login, login_ob :) );
}

nomask void logon(object login_ob)
{
	/* Jt */
	if( !SYSTEM_D->valid_login() )
	{
		tell(login_ob, HIY + MUD_FULL_NAME + "JAеy ...\n"NOR);
		SYSTEM_D->add_loginuser( login_ob );
		input_to((: wait_for_login, login_ob :));
		return;
	}

	LOGIN_D->show_login_message(login_ob);

	if( !LOGIN_D->check_login_attacker(query_ip_number(login_ob)) )
	{
		login_ob->directly_receive(HIR"\nܩpAo IP["+query_ip_number(login_ob)+"] nJʧ@ӹLWcAеyԦAաC\n"NOR);
		//CHANNEL_D->channel_broadcast("sys", "nJG"+query_ip_number(login_ob)+" nJʧ@ӹLWcAju");
		//destruct(login_ob);
		logon_handle(INITIALIZE, login_ob);
		return;
	}

	logon_handle(INITIALIZE, login_ob);
}

int remove()
{
	foreach(object user in users())
	{
		if( !user->is_login_ob() ) continue;
		tell(user, HIR"\nܩpAntΧsA·бzAsnC\n"NOR);
		flush_messages(user);
		destruct(user);
	}
}

string query_name()
{
	return "anJt(PPL_LOGIN_D)";
}
