/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : valid_readwrite.c
 * Author : Clode@RevivalWorld
 * Date   : 2001-07-05
 * Note   : included by Master Object
 * Update :
 *  o 2002-00-00

 -----------------------------------------
 */

#include <daemon.h>
#include <secure.h>

/*
W١G
        valid_read - ˬd@ӤHO_vŪ@ɮסC
ykG
        int valid_read( string file, object user, string func );

         valid_read( r ɮ,  ϥΪ, r 禡 );
ΪkG
        C@ӪŪɮ׮ɡAXʵ{|IsD_ valid_read()
        HˬdO_\ŪC禡ѼƬɮצW١BŪɪBI
        s禡W١CpG valid_read() Ǧ^DsȡAh\ŪC
ѦҡG
        valid_write
@̡G
        Tim Hollebeek  Beek@ZorkMUD, Lima Bean, IdeaExchange, and elsewhere
½ĶG
        spock@muds.net          2000.May.21.    v22 
*/
int valid_read(string file, object from, string func)
{
	return SECURE_D->valid_check(file, from, func, READ);
}

/*
W١G
        valid_write - ˬd@ӪO_vgJ@ɮסC
ykG
        int valid_write( string file, object ob, string func );

         valid_write( r ɮ,  , r 禡 );
ΪkG
        C@ӪռgJɮ׮ɡAXʵ{|IsD_󤤪
        valid_write() HˬdO_\gJC禡ѼƬɮצW١BռgJ
        ɪBIs禡W١qq`OQϥΪ~禡rCpG
        valid_write() Ǧ^DsȡAh\gJC
ѦҡG
        valid_read
@̡G
        Tim Hollebeek  Beek@ZorkMUD, Lima Bean, IdeaExchange, and elsewhere
½ĶG
        spock@muds.net          2000.May.21.    v22 
*/
int valid_write(string file, object from, string func)
{
	return SECURE_D->valid_check(file, from, func, WRITE);
}
