/* This program is a part of RW mudlib
 * See /doc/help/copyright for more info
 -----------------------------------------
 * File   : room_wizhall_6.c
 * Author : Clode@RevivalWorld
 * Date   : 2003-08-23
 * Note   : зǩж
 * Update :
 *  o 2000-00-00
 *
 -----------------------------------------
 */

#include <ansi.h>
#include <inherit.h>
#include <daemon.h>

inherit STANDARD_ROOM;

string help = @HELP
boӥZL_жèSSTC
HELP;

mapping actions;

void init(object ob);

void do_join(object me, string arg)
{
	if( query("newbiemaster", me) )
		return tell(me, pnoun(2, me)+"wgOsɭFC\n");

	if( query("total_online_time", me) < 6*30*24*60*60 )
		return tell(me, pnoun(2, me)+"CɶWLӤALksɭC\n");

	if( wizardp(me) )
		return tell(me, "ŮvLksɭC\n");

	me->add_title(HIY"s"NOR YEL"ɭ"NOR);
	set("newbiemaster", 1, me);

	CHANNEL_D->channel_broadcast("news", me->query_idname()+"@qȩʪ"HIY"s"NOR YEL"ɭ"NOR"AФjaxAs⦳DҥiV"+pnoun(3, me)+"߰ݡC\n");

	me->save();

	init(0);
}

void do_leave(object me, string arg)
{
	if( !query("newbiemaster", me) )
		return tell(me, pnoun(2, me)+"쥻NOsɭC\n");

	me->remove_title(HIY"s"NOR YEL"ɭ");
	delete("newbiemaster", me);

	CHANNEL_D->channel_broadcast("news", me->query_idname()+"sɭ¾ȡAФja"+pnoun(3, me)+"e^mxC\n");

	me->save();

	init(0);
}

void create()
{
	set("short", HIW"Ův"NOR WHT" "NOR YEL"n"NOR);

	set("exits", ([
		"east" : "/wiz/wizhall/room_wizhall_1",
	    ]));

	set("objects", ([
	    ]));

	init(0);

	actions = ([
	    "join" : (: do_join :),
	    "leave": (: do_leave :),
	]);

	::reset_objects();
}

void init(object ob)
{
	object master_player;

	string roomlong = @TEXT
    o̬Os⪺ɭ𮧫ǡAB\FUظ޲оǹDAݨӨC
ܨWɷsiJoӼsj@ɡAިWAɭ̫oO֦h
APɧOF\hn͡AuWqlݪOCXثeuWsɭ
WACWDݥL̴NFAUFOutell "id" XXXXvKiHP
L̷q͸ܡAML̤jhƤ]OjHA@w|^A͸ܡAiHhմX
ɭάOJuchat XXXXvb@WDWoݡC
TEXT;

	roomlong += HIY"\n                     uWsɭ ID\n"NOR;

	foreach( master_player in users() )
	{
		if( query("newbiemaster", master_player) )
			roomlong += sprintf(HIY"%-24s"NOR" %-30s\n", CITY_D->query_city_idname(query("city", master_player))||"Ly", master_player->query_idname());
	}

	set("long", roomlong);
}
